#ifndef	NOIDENT
#ident	"@(#)CaptionP.h	1.2 SMI"
#ident	"@(#)caption:include/openlook/CaptionP.h	1.13"
#endif

/* 
** CaptionP.h - Private definitions for Open Look Caption Widget
*/

#include <Xol/ManagerP.h>	/* include superclasses' header */
#include <Xol/Caption.h>

#ifndef _CaptionP_h
#define _CaptionP_h

typedef struct {
	int make_compiler_happy;
	} CaptionClassPart;

/* Full class record declaration */
typedef struct _CaptionClassRec {
    CoreClassPart	core_class;
    CompositeClassPart	composite_class;
    ConstraintClassPart	constraint_class;
    ManagerClassPart	manager_class;
    CaptionClassPart	caption_class;
} CaptionClassRec;

extern CaptionClassRec captionClassRec;

/* New fields for the Caption widget record */

typedef struct {
	/* resources */
	Pixel		fontcolor;
	XFontStruct	*font;
	String		label;
	OlDefine	position;
	OlDefine	alignment;
	Dimension	space;

	/* internal data */
	GC         	normal_GC; 	/* GC for text			*/
	GC         	hilite_GC; 	/* GC for highlighted text	*/
	Dimension	caption_len;	/* len of text in chars		*/
	Dimension	caption_width;	/* width of text in pixels	*/
	Dimension	caption_height;	/* height of caption in pixels	*/
	Position	caption_x;	/* where text is placed		*/
	Position	caption_y;	/* where text is placed		*/
	char		*selection_start;	/* ptr to start of selection*/
	char		*selection_end;	/* ptr to end of selection	*/
	int		selection_mode;	/* chars, words, lines...	*/
	Time            time;           /* time of last key or button action*/ 
	String		clip_contents;	/* clipboard contents		*/

} CaptionPart;

/*
** Full instance record declaration
*/

typedef struct _CaptionRec {
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    ManagerPart		manager;
    CaptionPart		caption;
} CaptionRec;

#endif /* _CaptionP_h */
