#ifndef NOIDENT
#ident	"@(#)Dynamic.h	1.2 SMI"
#ident	"@(#)olmisc:Dynamic.h	1.1"
#endif

/*
 * Dynamic.h
 *
 */

#ifndef _Dynamic_h
#define _Dynamic_h

typedef enum
   { 
   NOT_DETERMINED, MOUSE_CLICK, MOUSE_MOVE, MOUSE_MULTI_CLICK 
   } ButtonAction;

typedef enum
   {
   OL_UNKNOWN_INPUT, 
   OL_UNKNOWN_BTN_INPUT,
      OL_SELECT, OL_ADJUST, OL_MENU, 
      OL_CONSTRAIN, OL_DUPLICATE, OL_PAN,
   OL_UNKNOWN_KEY_INPUT, 
      OL_CUT, OL_COPY, OL_PASTE,
      OL_HELP, OL_CANCEL, OL_PROP, OL_STOP, OL_UNDO, 
      OL_NEXT_FIELD, OL_PREV_FIELD,
      OL_CHARFWD, OL_CHARBAK, 
      OL_ROWDOWN, OL_ROWUP, 
      OL_WORDFWD, OL_WORDBAK,
      OL_LINESTART, OL_LINEEND, 
      OL_DOCSTART, OL_DOCEND,
      OL_PANESTART, OL_PANEEND,
      OL_DELCHARFWD, OL_DELCHARBAK, 
      OL_DELWORDFWD, OL_DELWORDBAK, 
      OL_DELLINEFWD, OL_DELLINEBAK, OL_DELLINE,
      OL_SELCHARFWD, OL_SELCHARBAK, 
      OL_SELWORDFWD, OL_SELWORDBAK, 
      OL_SELLINEFWD, OL_SELLINEBAK, OL_SELLINE,
      OL_SELFLIPENDS,
      OL_REDRAW, OL_RETURN, 
      OL_PAGEUP, OL_PAGEDOWN, 
      OL_HOME, OL_END, 
      OL_SCROLLUP, OL_SCROLLDOWN,
      OL_SCROLLLEFT, OL_SCROLLRIGHT,
      OL_SCROLLLEFTEDGE, OL_SCROLLRIGHTEDGE,
      OL_PGM_GOTO,
   } OlInputEvent;

typedef struct
   {
   Boolean          consumed;
   XEvent *         event;
   KeySym *         keysym;
   char *           buffer;
   int *            length;
   OlInputEvent     ol_event;
   } OlInputCallData, *OlInputCallDataPointer;

typedef struct _OlDynamicResources
   {
   Widget       w;
   caddr_t      base;
   XtResource * dynamic;
   int          num_dynamic;
   ArgList      args;
   int          num_args;
   void        (*CB)();
   } OlDynamicResources;

typedef struct _OlDynamicColors
   {
   Pixel        textForeground;
   Pixel        textBackground;
   Pixel        inputFocus;
   } OlDynamicColors;

extern void         LookupOlColors();
extern OlInputEvent LookupOlInputEvent();
extern void         OlReplayBtnEvent();
extern void         _OlDynamicHandler();
extern void         OlGetApplicationResources();
extern ButtonAction OlDetermineMouseAction();
extern void         OlGrabDragPointer();
extern void         OlUngrabDragPointer();
extern void         OlDragAndDrop();
extern void         OlRegisterDynamicCallback();
extern int          OlUnregisterDynamicCallback();
extern void         OlCallDynamicCallbacks();

#endif
