#ifndef NOIDENT
#ident	"@(#)EventObjP.h	1.2 SMI"
#ident	"@(#)eventobj:EventObjP.h	1.7"
#endif

#ifndef _OlEventObjP_h
#define _OlEventObjP_h

/*
 ************************************************************
 *
 *  Date:	July 19, 1989
 *
 *  Description:
 *	This file contains the private definitions for the
 *	OPEN LOOK(tm) EventObj (Meta) Class.
 *
 ************************************************************
 */

#include <X11/RectObjP.h>
#include <Xol/PrimitiveP.h>	/* for Primitive functionality */
#include <Xol/EventObj.h>

extern void _OlAddEventHandler();
extern void _OlRemoveEventHandler();

/* Macros */

#define _OlXTrans(w, x_val) \
    ((_OlIsGadget(w)) ? ((RectObj)(w))->rectangle.x + (x_val) : (x_val))

#define _OlYTrans(w, y_val) \
    ((_OlIsGadget(w)) ? ((RectObj)(w))->rectangle.y + (y_val) : (y_val))

/*
 *  Event Object Class Data Structures
 */
typedef struct _EventObjClassPart {
    /* fields for Primitive Class equivalence */
    OlCanAcceptFocusFunc can_accept_focus;
    OlHighlightProc      highlight_handler;
    OlUnitTypeList       unit_types;
    Cardinal             num_unit_types;
    OlHelpInfo *         help_info;
    OlDynamicResource *  dynamic_resources;
    Cardinal             num_dyn_resources;
    XtVersionType        version;
    XtPointer            extension;
} EventObjClassPart;

typedef struct _EventObjClassRec {
    RectObjClassPart	rect_class;
    EventObjClassPart	event_class;
} EventObjClassRec;

/*
 *  eventObjClassRec is defined in EventObj.c
 */
extern EventObjClassRec eventObjClassRec;

/*
 *  Event Object Instance Data Structures
 */
typedef struct {
    /* these must be declared first since they coincide with fields in
     * CorePart
     */
    XtEventTable	event_table;

    /* fields for Primitive Instance equivalence */
    Boolean		traveral_on;
    XtPointer		user_data;
    OlDefine		unit_type;
} EventObjPart;

typedef struct _EventObjRec {
    ObjectPart		object;
    RectObjPart		rectangle;
    EventObjPart	event;
} EventObjRec;

#endif /* _OlEventObjP_h */
