#ifndef	NOIDENT
#ident	"@(#)FCheckBoxP.h	1.2 SMI"
#ident	"@(#)flat:FCheckBoxP.h	1.3"
#endif

#ifndef _OL_FCHECKBOXP_H
#define _OL_FCHECKBOXP_H

/*
 ************************************************************************	
 * Description:
 *	This is the flat checkbox container's private header file.
 ************************************************************************	
 */

#include <Xol/FExclusivP.h>
#include <Xol/FCheckBox.h>

/*
 ************************************************************************	
 * Define Widget Class Part and Class Rec
 ************************************************************************	
 */

				/* Define new fields for the class part	*/

typedef struct {
    int		no_class_fields;
} FlatCheckBoxClassPart;

				/* Full class record declaration 	*/

typedef struct _FlatCheckBoxClassRec {
    CoreClassPart		core_class;
    PrimitiveClassPart		primitive_class;
    FlatClassPart		flat_class;
    FlatExclusivesClassPart	exclusives_class;
    FlatCheckBoxClassPart	checkbox_class;
} FlatCheckBoxClassRec;

				/* External class record declaration	*/

extern FlatCheckBoxClassRec	flatCheckBoxClassRec;

/*
 ************************************************************************	
 * Define Widget Instance Structure
 ************************************************************************	
 */
				/* Define Expanded sub-object instance	*/

typedef struct {
	OlDefine	position;	/* position of check box	*/
} FlatCheckBoxItemPart;

			/* Item's Full Instance record declaration	*/

typedef struct {
	FlatItemPart		flat;
	FlatExclusivesItemPart	exclusives;
	FlatCheckBoxItemPart	checkbox;
} FlatCheckBoxItemRec, *FlatCheckBoxItem;

			/* Define new fields for the instance part	*/
typedef struct {
			/* Must finish this in next load	*/

	XFontStruct *		check_font;
	GC			check_gc;
	FlatCheckBoxItemPart	item_part;
} FlatCheckBoxPart;

				/* Full instance record declaration	*/

typedef struct _FlatCheckBoxRec {
    CorePart		core;
    PrimitivePart	primitive;
    FlatPart		flat;
    FlatExclusivesPart	exclusives;
    FlatCheckBoxPart	checkbox;
} FlatCheckBoxRec;

#endif /* _OL_FCHECKBOXP_H */
