#ifndef	NOIDENT
#ident	"@(#)FExclusivP.h	1.2 SMI"
#ident	"@(#)flat:FExclusivP.h	1.8"
#endif

#ifndef _OL_FEXCLUSIVP_H
#define _OL_FEXCLUSIVP_H

/*
 ************************************************************************	
 * Description:
 *	This is the flat exclusive container's private header file.
 ************************************************************************	
 */

#include <Xol/FlatP.h>
#include <Xol/FExclusive.h>

#ifndef XtNpreviewItem
#define	XtNpreviewItem	"previewItem"
#endif /* XtNpreviewItem */

#ifndef XtCPreviewItem
#define	XtCPreviewItem	"PreviewItem"
#endif /* XtCPreviewItem */

/*
 ************************************************************************	
 * Define Widget Class Part and Class Rec
 ************************************************************************	
 */

				/* Define new fields for the class part	*/

typedef struct {
    Boolean	exclusive_settings;	/* are settings exclusive ?	*/
    Boolean	allow_class_default;	/* is default item allowed ?	*/
} FlatExclusivesClassPart;

				/* Full class record declaration 	*/

typedef struct _FlatExclusivesClassRec {
    CoreClassPart		core_class;
    PrimitiveClassPart		primitive_class;
    FlatClassPart		flat_class;
    FlatExclusivesClassPart	exclusives_class;
} FlatExclusivesClassRec;

				/* External class record declaration	*/

extern FlatExclusivesClassRec		flatExclusivesClassRec;

/*
 ************************************************************************	
 * Define Widget Instance Structure
 ************************************************************************	
 */

				/* Define Expanded sub-object instance	*/

typedef struct {
	Boolean		set;		/* is this item set ?		*/
	Boolean		the_default;	/* is this item the default ?	*/
	Boolean		label_tile;	/* tile the label ?		*/
	OlDefine	label_justify;	/* justification of the labels	*/
	Pixel		font_color;	/* font foreground color	*/
	String		label;		/* textual label		*/
	XtPointer	client_data;	/* for callbacks		*/
	XtCallbackProc	select_proc;	/* select callback		*/
	XtCallbackProc	unselect_proc;	/* unselect callback		*/
	XFontStruct *	font;		/* rendering font		*/
	XImage *	label_image;	/* Image label			*/
} FlatExclusivesItemPart;

			/* Item's Full Instance record declaration	*/

typedef struct {
	FlatItemPart		flat;
	FlatExclusivesItemPart	exclusives;
} FlatExclusivesItemRec, *FlatExclusivesItem;

			/* Define new fields for the instance part	*/

typedef struct {
						/* Public Resources	*/

	Pixel		foreground;	/* sub-object foreground color	*/
	Boolean		none_set;	/* does a sub-object always have
					 * to be set ?			*/
	
						/* Private Resources	*/

	Boolean		trigger;	/* activate the default		*/
	Boolean		menu_descendant; /* is the shell a menu ?	*/
	Boolean		allow_instance_default;/* can there be a default
					 * sub-object for this instance	*/
	Boolean		internal_manage;/* Must internally manage some attr.*/
	Boolean		dim;		/* is the setting dimmed ?	*/
	Cardinal	current_item;	/* the currect item		*/
	Cardinal	set_item;	/* previously selected item	*/
	Cardinal	default_item;	/* the default item		*/
	Cardinal	preview_item;	/* preview widget sub-object	*/
	GC		stippled_gc;	/* GC for indeterminate setting	*/
	GC		normal_gc;	/* GC for normal visual		*/
	GC		label_gc;	/* GC for normal labels/images	*/
	Boolean *	set_list;	/* for non-exclusive types	*/
	Widget		preview;	/* widget to preview in		*/
	FlatExclusivesItemPart item_part;/* sub-object data for this part*/
} FlatExclusivesPart;

				/* Full instance record declaration	*/

typedef struct _FlatExclusivesRec {
    CorePart		core;
    PrimitivePart	primitive;
    FlatPart		flat;
    FlatExclusivesPart	exclusives;
} FlatExclusivesRec;

#endif /* _OL_FEXCLUSIVP_H */
