#ifndef	NOIDENT
#ident	"@(#)ListPaneP.h	1.2 SMI"
#ident	"@(#)scrolllist:include/Xol/ListPaneP.h	1.19"
#endif
/*
 ListPaneP.h (C hdr file)
	Acc: 596865505 Tue Nov 29 22:58:25 1988
	Mod: 596865505 Tue Nov 29 22:58:25 1988
	Sta: 596865505 Tue Nov 29 22:58:25 1988
	Owner: 4777
	Group: 1985
	Permissions: 666
*/
/*
	START USER STAMP AREA
*/
/*
	END USER STAMP AREA
*/
/* 
 * ListPaneP.h - Private definitions for ListPane widget
 */

#ifndef _ListPaneP_h
#define _ListPaneP_h

#include <Xol/PrimitiveP.h>		/* include superclasses's header */
#include <Xol/ListPane.h>		/* include public header file */
#include <Xol/ScrollingP.h>		/* need this too */

/***********************************************************************
 *
 *	(Private) Resources
 *
 */

#define XtNdelete	"delete"
#define XtNeditOn	"editOn"
#define XtNeditOff	"editOff"
#define XtNinsert	"insert"
#define XtNmove		"move"
#define XtNtouch	"touch"
#define XtNview		"view"

#define XtCEditOff	"EditOff"


/***********************************************************************
 *
 *	Class structure
 *
 */

/* New fields for the ListPane widget class record */
typedef struct {
	int no_class_fields;		/* make compiler happy */
} ListPaneClassPart;

/* Full class record declaration */
typedef struct _ListPaneClassRec {
	CoreClassPart		core_class;
	PrimitiveClassPart	primitive_class;
	ListPaneClassPart	list_pane_class;
} ListPaneClassRec;

/* Class record variable */
externalref ListPaneClassRec listPaneClassRec;

/***********************************************************************
 *
 *	Instance (widget) structure
 *
 */

/* New fields for the ListPane widget record */
typedef struct { 
    /* "PUBLIC" (resource) members */
	Node *		delete;		/* delete an item */
	Node *		edit_on;	/* edit (put text field on) this item */
	Boolean		edit_off;	/* edit (put text field on) this item */
	XFontStruct *	font;
	Pixel		font_color;	/* "foreground" color */
	Node *		insert;		/* insert an item */
	Node *		move;		/* move to node in tree */
	Boolean		recomputeWidth;	/* resize or live with geometry */
	Boolean		selectable;
	Node *		touch;		/* touch an item */
	Boolean		update_view;	/* lock/unlock view */
	Node *		view;		/* view an item */
	Cardinal	viewHeight;	/* # of items in view */

    /* PRIVATE members */
	Cardinal	actualViewHeight; /* (actual) # of items in view */
	String		cb_contents;	/* string built of selected items */
	Cardinal	cb_char_cnt;	/* selection byte count */
	unsigned char	click_state;	/* for detecting double clicks */
	Boolean		editMode;	/* item being editted (?) */
	GC		gc_inverted;
	GC		gc_normal;
	int		initial_motion;	/* direction of initial motion */
	Cardinal	items_selected;	/* number of items selected */
	ListWidget	list_widget;	/* list widget ancestor (ugh) */
	Boolean		own_clipboard;	/* CLIPBOARD ownership */
	Boolean		own_focus;	/* TRUE: widget has focus */
	Boolean		own_selection;	/* selection ownership */
	int		prev_index;	/* for motion: previous index */
	unsigned long	repeat_rate;	/* for auto scolling */
	int		scroll;		/* pointer w/i pane for auto scroll */
	Cardinal	scrollValue;	/* to get relative #'s from sbar */
	Node *		search_item;	/* begin search at this item (node) */
	int		start_index;	/* for motion: start index */
	Dimension	tallest_item;	/* in entire list (in pixels) */
	XtIntervalId	timer_id;	/* timer for auto-scroll */
	Node *		viewHead;	/* 1st item in view */
	Boolean		viewLocked;	/* state of view */
	Dimension	widest_item;	/* in entire list (in pixels) */

	/* item spacing: these are pixel dimensions derived from device-
	 * independent dimensions.  they are fixed so are calculated once.
	 */
	Dimension vert_margin;		/* margin between top (bottom) of
					 * pane and top (bottom) item
					 */
	Dimension horiz_margin;		/* horiz margin between pane & item */
	Dimension vert_pad;		/* total vertical padding.  therefore:
					 * pad + label height = item height
					 */
	Dimension horiz_pad;		/* total horizontal padding.  therefore:
					 * pad + label width = item width
					 */
} ListPanePart;

/* Full instance record declaration */
typedef struct _ListPaneRec {
	CorePart	core;
	PrimitivePart	primitive;
	ListPanePart	list_pane;
} ListPaneRec;

#endif /* _ListPaneP_h */
