#ifndef NOIDENT
#ident	"@(#)ManagerP.h	1.2 SMI"
#ident	"@(#)manager:ManagerP.h	1.8"
#endif

/***********************************************************************
 *
 * Manager Widget Private Data
 *
 ***********************************************************************/

#ifndef _OlManagerP_h
#define _OlManagerP_h


#include <X11/ConstrainP.h>
#include <Xol/Manager.h>

typedef void (*OlHighlightProc)();
/* Widget	w;		*/
/* OlDefine	highlight_type; */

typedef void (*OlManagerProc)();
/* Widget	manager;	*/
/* Widget	descendant;	*/

typedef Widget (*OlTraversalFunc)();
/* Widget	w;		*/
/* OlDefine	direction;	*/
/* Time		time;		*/


/***********************************************************************
 *
 * Class record
 *
 ***********************************************************************/

/* New fields for the ManagerWidget class record */
typedef struct {
    OlHighlightProc	highlight_handler;
    OlManagerProc	insert_descendant;
    OlManagerProc	delete_descendant;
    OlTraversalFunc	traversal_handler;
    OlUnitTypeList	unit_types;
    Cardinal		num_unit_types;
    OlHelpInfo *	help_info;
    OlDynamicResource *	dynamic_resources;
    Cardinal		num_dyn_resources;
    XtVersionType	version;
    XtPointer		extension;
} ManagerClassPart;

/* Full class record declaration */
typedef struct _ManagerClassRec {
    CoreClassPart	core_class;
    CompositeClassPart	composite_class;
    ConstraintClassPart	constraint_class;
    ManagerClassPart	manager_class;
} ManagerClassRec;

extern ManagerClassRec	managerClassRec;

/***********************************************************************
 *
 * Instance record
 *
 ***********************************************************************/

/* New fields for the ManagerWidget record */
typedef struct _ManagerPart {
    /* Resource-related data */
    Boolean	traversal_mgr;
    XtPointer	user_data;
    OlDefine	unit_type;

    /* Non-resource-related data */
    OlDefine		highlight_state;
    struct _ol_list *	traversal_list;
    Widget		primitive_widget;
}	ManagerPart;


/* Full instance record declaration */
typedef struct _ManagerRec {
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    ManagerPart		manager;
} ManagerRec;


/***********************************************************************
 *
 * Constants
 *
 ***********************************************************************/

/* Constants for class procedure inheritance */
#define XtInheritDeleteDescendant	((OlManagerProc)_XtInherit)
#define XtInheritHighlightHandler	((OlHighlightProc)_XtInherit)
#define XtInheritInsertDescendant	((OlManagerProc)_XtInherit)
#define XtInheritTraversalHandler	((OlTraversalFunc)_XtInherit)

#define _OL_IS_MANAGER(w)   (XtIsSubclass((w), managerWidgetClass))

extern void	_OlCallHighlightHandler();
/* Widget	w;			*/
/* OlDefine	highlight_state;	*/

extern void	_OlDeleteDescendant();
/* Widget	w;	*/

extern Widget	_OlInsertDescendant();
/* Widget	w;	*/


#endif /* _OlManagerP_h */
