#ifndef	NOIDENT
#ident	"@(#)OpenLook.h	1.3 SMI"
#ident	"@(#)oltemporary:OpenLook.h	1.6"
#endif
/*
 OpenLook.h (C hdr file)
	Acc: 597622178 Thu Dec  8 17:09:38 1988
	Mod: 597619173 Thu Dec  8 16:19:33 1988
	Sta: 597619173 Thu Dec  8 16:19:33 1988
	Owner: 4777
	Group: 1985
	Permissions: 644
*/
/*
	START USER STAMP AREA
*/
/*
	END USER STAMP AREA
*/
#ifndef __Ol_OpenLook_h__
#define __Ol_OpenLook_h__

/*
 *************************************************************************
 *
 * Description:
 *		This file contains all the things necessary to compile
 *	an OPEN LOOK (tm) application.
 *
 *******************************file*header*******************************
 */

#include <Xol/OlXlibExt.h>
#include <Xol/OlClients.h>

#ifdef _XtIntrinsic_h			/* for Xwin 1.0 compatibility */

#include <Xol/OlStrings.h>

/*
 ************************************************************************
 *	Define some ANSI C and C++ stuff
 ************************************************************************
 */

			/* Define the token 'const' if not ANSI or C++	*/

#if !defined(__STDC__) && !defined(__cplusplus) && \
	!defined(c_plusplus) && !defined(const)
#define const
#endif /* __STDC__ && __cplusplus && c_plusplus && const */

			/* Define a macro for function Prototypes.
			 * Do this in two steps.
			 * NOTE: since ANIS C and C++ treat externs for
			 * parameterless functions differently, declare
			 * a paremeter function in the following way:
			 *	fooNoParams OL_NO_ARGS;
			 * As for functions with params, do :
			 *	fooWithParams OL_ARGS((char *, int));
			 */

#ifdef __STDC__
#ifndef OlNeedFunctionPrototypes
#define OlNeedFunctionPrototypes 1
#endif
#define OL_ARGS(x)	x
#define OL_NO_ARGS()	(void)
#else /* __STDC__ */
#if defined(__cplusplus) || defined(c_plusplus)
#ifndef OlNeedFunctionPrototypes
#define OlNeedFunctionPrototypes 1
#endif
#define OL_ARGS(x)	x
#define OL_NO_ARGS()	()
#endif /* __cpluslus || c_plusplus */
#endif /* __STDC__ */

				/* If OlNeedFunctionPrototypes is defined, but
				 * its value is zero, undefine it	*/

#if defined(OlNeedFunctionPrototypes) && (OlNeedFunctionPrototypes == 0)
#undef OlNeedFunctionPrototypes
				/* Undefine the function args macro since
				 * we don't want prototypes		*/
#ifdef OL_ARGS
#undef OL_ARGS
#undef OL_NO_ARGS
#endif /* OL_ARGS */
#endif

				/* Now check the function argument macros
				 * and if it's undefined here, define it
				 * for the case with no function
				 * prototypes.				*/
#ifndef OL_ARGS
#define OL_ARGS(x)	()
#define OL_NO_ARGS()	()
#endif /* OL_ARGS */

/*
 ************************************************************************
 *	Define True Constant Tokens
 *		Tokens that appear in this section should not have
 *		their values changed.
 ************************************************************************
 */

#define OL_IGNORE		(~0)

/*
 ************************************************************************
 *	Define Tokens that have arbitary value assignments.  (Though
 *	their values must not change since it would break backwards
 *	compatibility.)
 *	New tokens should be added to the end of the list and their
 *	values must be unique.
 ************************************************************************
 */

#define OleditDone		0
#define OleditError		1
#define OleditPosError		2
#define OleditReject		3

#define OL_ABSENT_PAIR		0
#define OL_ALL			1
#define OL_ALWAYS		2
#define OL_ATOM_HELP		3
#define OL_BOTH			4
#define OL_BOTTOM		5
#define OL_BUTTONSTACK		6
#define OL_CENTER		7
#define OL_CLASS_HELP		8
#define OL_COLUMNS		9
#define OL_COPY_MASK_VALUE	10
#define OL_COPY_SIZE		11
#define OL_COPY_SOURCE_VALUE	12
#define OL_CURRENT		13
#define OL_DEFAULT_PAIR		14
#define OL_DISK_SOURCE		15
#define OL_DISPLAY_FORM		16
#define OL_DOWN			17
#define OL_EXISTING_SOURCE	18
#define OL_FIXEDCOLS		19
#define OL_FIXEDHEIGHT		20
#define OL_FIXEDROWS		21
#define OL_FIXEDWIDTH		22
#define OL_FLAT_BUTTON		23
#define OL_FLAT_CHECKBOX	24
#define OL_FLAT_CONTAINER	25
#define OL_FLAT_EXCLUSIVES	26
#define OL_FLAT_HELP		27
#define OL_FLAT_NONEXCLUSIVES	28
#define OL_HALFSTACK		29
#define OL_HORIZONTAL		30
#define OL_IMAGE		31
#define OL_IN			32
#define OL_INDIRECT_SOURCE	33
#define OL_LABEL		34
#define OL_LEFT			35
#define OL_MASK_PAIR		36
#define OL_MAXIMIZE		37
#define OL_MILLIMETERS		38
#define OL_MINIMIZE		39
#define OL_NEVER		40
#define OL_NEXT			41
#define OL_NONE			42
#define OL_NONEBOTTOM		43
#define OL_NONELEFT		44
#define OL_NONERIGHT		45
#define OL_NONETOP		46
#define OL_NOTICES		47
#define OL_NO_VIRTUAL_MAPPING	48
#define OL_OBLONG		49
#define OL_OUT			50
#define OL_OVERRIDE_PAIR	51
#define OL_PIXELS		52
#define OL_POINTS		53
#define OL_POPUP		54
#define OL_PREVIOUS		55
#define OL_PROG_DEFINED_SOURCE	56
#define OL_RECTBUTTON		57
#define OL_RIGHT		58
#define OL_ROWS			59
#define OL_SOURCE_FORM		60
#define OL_SOURCE_PAIR		61
#define OL_STAYUP		62
#define OL_STRING		63
#define OL_STRING_SOURCE	64
#define OL_TEXT_APPEND		65
#define OL_TEXT_EDIT		66
#define OL_TEXT_READ		67
#define OL_TOP			68
#define OL_TRANSPARENT_SOURCE	69
#define OL_VERTICAL		70
#define OL_VIRTUAL_BUTTON	71
#define OL_VIRTUAL_KEY		72
#define OL_WIDGET_HELP		73
#define OL_WINDOW_HELP		74
#define OL_WRAP_ANY		75
#define OL_WRAP_WHITE_SPACE	76

/*
 ************************************************************************
 *	Define Bitwise Tokens
 *		This are easily identified by the naming convention
 ************************************************************************
 */
#define OL_B_OFF		0
#define OL_B_HORIZONTAL		(1<<0)
#define OL_B_VERTICAL		(1<<1)
#define OL_B_BOTH		(OL_B_VERTICAL|OL_B_HORIZONTAL)

/*
 ************************************************************************
 *	Define Constant tokens that are being maintained for source
 *	compatibility with older versions of the toolkit.
 ************************************************************************
 */
#define OL_BEEP_NEVER			OL_NEVER
#define OL_BEEP_NOTICES			OL_NOTICES
#define OL_BEEP_NOTICES_AND_FOOTERS	OL_ALWAYS
#define OL_BEEP_ALWAYS			OL_ALWAYS
#define OL_AUTO_SCROLL_OFF		OL_B_OFF
#define OL_AUTO_SCROLL_HORIZONTAL	OL_B_HORIZONTAL
#define OL_AUTO_SCROLL_VERTICAL		OL_B_VERTICAL
#define OL_AUTO_SCROLL_BOTH		OL_B_BOTH
#define OL_GROW_OFF			OL_B_OFF
#define OL_GROW_HORIZONTAL		OL_B_HORIZONTAL
#define OL_GROW_VERTICAL		OL_B_VERTICAL
#define OL_GROW_BOTH			OL_B_BOTH

/*
 ************************************************************************
 *	Define public structures
 ************************************************************************
 */
				/* Define a structure for the complex
				 * flat help id				*/

typedef struct _OlFlatHelpId {
	Widget		widget;
	Cardinal	item_index;
} OlFlatHelpId;

/*
 *************************************************************************
 *	Macros
 *************************************************************************
 */
			/* The following three macros would normally
			 * appear in the private header file, but we
			 * need them for the metric macros		*/

#define _OlFloor(value)		((int) (value))
#define _OlCeiling(value)	((int) (_OlFloor(value) == (value) ? \
					(value) : ((value) + 1)))
#define _OlRound(dbl)		((int) ((double) (dbl) + (double)\
				((double)(dbl) < (double)0 ? -0.5 : 0.5)))

						/* Metric macros	*/

extern Display * toplevelDisplay;

#define OlDefaultDisplay toplevelDisplay
#define OlDefaultScreen  DefaultScreenOfDisplay(toplevelDisplay)

					/* Pixels to Millimeters */

#define Ol_ScreenPixelToMM(direction, value, screen) \
	((double) (value) * (double)(direction == OL_HORIZONTAL ? \
	((double)WidthMMOfScreen(screen) / (double)WidthOfScreen(screen))  :\
	((double)HeightMMOfScreen(screen) / (double)HeightOfScreen(screen))))

#define OlScreenPixelToMM(direction, value, screen) \
		_OlRound(Ol_ScreenPixelToMM(direction, value, screen))

#define Ol_PixelToMM(direction, value) \
		Ol_ScreenPixelToMM(direction, value, OlDefaultScreen)

#define OlPixelToMM(direction, value) \
		OlScreenPixelToMM(direction, value, OlDefaultScreen)

					/* Millimeters to Pixels */

#define Ol_ScreenMMToPixel(direction, value, screen) \
	((double) (value) * (double)(direction == OL_HORIZONTAL ? \
	((double)WidthOfScreen(screen) / (double)WidthMMOfScreen(screen))  :\
	((double)HeightOfScreen(screen) / (double)HeightMMOfScreen(screen))))

#define OlScreenMMToPixel(direction, value, screen) \
		_OlRound(Ol_ScreenMMToPixel(direction, value, screen))

#define Ol_MMToPixel(direction, value) \
		Ol_ScreenMMToPixel(direction, value, OlDefaultScreen)

#define OlMMToPixel(direction, value) \
		OlScreenMMToPixel(direction, value, OlDefaultScreen)

					/* Pixels to Points */

#define Ol_ScreenPixelToPoint(direction, value, screen) \
	(2.834645669 * (double)(value) * (double)(direction == OL_HORIZONTAL ? \
	((double)WidthMMOfScreen(screen) / (double)WidthOfScreen(screen))  :\
	((double)HeightMMOfScreen(screen) / (double)HeightOfScreen(screen))))

#define OlScreenPixelToPoint(direction, value, screen) \
		_OlRound(Ol_ScreenPixelToPoint(direction, value, screen))

#define Ol_PixelToPoint(direction, value) \
		Ol_ScreenPixelToPoint(direction, value, OlDefaultScreen)

#define OlPixelToPoint(direction, value) \
		OlScreenPixelToPoint(direction, value, OlDefaultScreen)

					/* Points to Pixels */

#define Ol_ScreenPointToPixel(direction, value, screen) \
	(0.352777777 * (double)(value) * (double)(direction == OL_HORIZONTAL ? \
	((double)WidthOfScreen(screen) / (double)WidthMMOfScreen(screen))  :\
	((double)HeightOfScreen(screen) / (double)HeightMMOfScreen(screen))))

#define OlScreenPointToPixel(direction, value, screen) \
		_OlRound(Ol_ScreenPointToPixel(direction, value, screen))

#define Ol_PointToPixel(direction, value) \
		Ol_ScreenPointToPixel(direction, value, OlDefaultScreen)

#define OlPointToPixel(direction, value) \
		OlScreenPointToPixel(direction, value, OlDefaultScreen)


/*************************************************************************
 *
 *	typedef's, enum's, struct's
 */

typedef short		OlDefine;	/* OPEN LOOK non-bitmask #defines*/
typedef unsigned long	OlBitMask;	/* OPEN LOOK bitmask #defines	*/

				/* Include some things that should of
				 * been in the R3 Intrinsics but were
				 * not.  These must be removed for R4	*/

#ifndef XtSpecificationRelease

typedef caddr_t		XtPointer;
#define XtRWidget	"Widget"

#endif /* XtSpecificationRelease */

typedef void	(*OlAppErrorMsgHandler)();
/*	String		name;		message's resource name - 	*/
/*					concatenated with the type	*/
/*	String		type;		message's resource type - 	*/
/*					concatenated to the name	*/
/*	String		class;		class of message		*/
/*	String		message;	composed message created from	*/
/*					variable arguments		*/

typedef void	(*OlAppWarningMsgHandler)();
/*	String		name;		message's resource name - 	*/
/*					concatenated with the type	*/
/*	String		type;		message's resource type - 	*/
/*					concatenated to the name	*/
/*	String		class;		class of message		*/
/*	String		message;	composed message created from	*/
/*					variable arguments		*/

typedef void	(*OlErrorHandler)();
/*	String	error_message;		simple error message string	*/

typedef void	(*OlWarningHandler)();
/*	String	warning_message;	simple warning message string	*/

					/* Packed Widget Structure	*/
typedef struct {
	Widget          widget;		/* new id to be filled in	*/
	String          name;		/* name of new widget		*/
	WidgetClass *	class_ptr;	/* addr. of widget class	*/
	Widget *	parent_ptr;	/* addr. of parent id		*/
	String		descendant;	/* resource names used in GetValues
					 * call on parent to get real
					 * parent			*/
	ArgList         resources;	/* resources for new widget	*/
	Cardinal        num_resources;	/* number of resources		*/
	Boolean         managed;	/* should widget be managed ???	*/
} OlPackedWidget, *OlPackedWidgetList;

/*
 * Support for Text Verification Callbacks
 */
typedef enum {motionVerify, modVerify, leaveVerify} OlVerifyOpType;
typedef enum {OlsdLeft, OlsdRight} OlScanDirection;
typedef enum {
    OlstPositions, OlstWhiteSpace, OlstEOL, OlstParagraph, OlstLast
    } OlScanType;

typedef long OlTextPosition;
typedef struct {
	int           firstPos;
	int           length;
	unsigned char *ptr;
} OlTextBlock, *OlTextBlockPtr;

typedef struct {
	XEvent		*xevent;
	OlVerifyOpType	operation;
	Boolean		doit;
	OlTextPosition	currInsert, newInsert;
	OlTextPosition	startPos, endPos;
	OlTextBlock	*text;
} OlTextVerifyCD, *OlTextVerifyPtr;


/*************************************************************************
 *
 *	Public extern declarations
 */

	/* This func is specific to Primitives and could be defined in
	 * Primitive.h except that Complex widgets don't include
	 * Primitive.h */
extern Boolean
OlCanAcceptFocus OL_ARGS((
	Widget,
	Time
));

	/* Convert a string containing virtual expressions into
	 * into a standard Xt translation string		*/
extern char *
OlConvertVirtualTranslation OL_ARGS((
	char *		/* translation;	- virtual translation	*/
));

	/* Create a single Packed Widget	*/
extern Widget
OlCreatePackedWidget OL_ARGS((
	OlPackedWidget *	/* packed_widget; */
));

	/* Create multiple packed widgets	*/
extern Widget
OlCreatePackedWidgetList OL_ARGS((
	/* OlPackedWidgetList	packed_widget_list; */
	/* Cardinal		num_of_elements; */
));

				/* OPEN LOOK toolkit error	*/
extern void
OlError OL_ARGS((
	String		/* error_msg;	- message string */
));

extern void
OlFlatGetValues OL_ARGS((
	Widget,		/* widget;	- flat widget id	*/
	Cardinal,	/* item_index;	- item to query		*/
	ArgList,	/* args;	- querying args		*/
	Cardinal	/* num_args;	- number of args	*/
));

extern void
OlFlatSetValues OL_ARGS((
	Widget,		/* widget;	- flat widget id	*/
	Cardinal,	/* item_index;	- item to modify	*/
	ArgList,	/* args;	- modifying args	*/
	Cardinal	/* num_args;	- number of args	*/
));

extern char
OlGetResolution OL_ARGS((
	Screen *	/* screen;	*/
));

	/* This func is specific to Primitives and could be defined in */
	/* Primitive.h except that Complex widgets don't include */
	/* Primitive.h */
extern Boolean
OlHasFocus OL_ARGS((
	Widget		/* widget; widget to query	*/
));

					/* Toolkit initialization	*/
extern Widget
OlInitialize OL_ARGS((
	char *,		/* shell_name;	- initial shell instance name	*/
	char *,		/* classname;	- application class		*/
	XrmOptionDescRec *, /* urlist;	- options list			*/
	Cardinal,	/* num_urs;	- number of options		*/
	int *,		/* argc;	- pointer to argc		*/
	char **		/* argv;	- argv				*/
));

					/* Toolkit post-initialization	*/
extern void
OlPostInitialize OL_ARGS((
	char *,		/* classname;	- application class		*/
	XrmOptionDescRec *, /* urlist;	- options list			*/
	Cardinal,	/* num_urs;	- number of options		*/
	int *,		/* argc;	- pointer to argc		*/
	char **		/* argv;	- argv				*/
));

					/* Toolkit pre-initialization	*/
extern void
OlPreInitialize OL_ARGS((
	char *,		/* classname;	- application class		*/
	XrmOptionDescRec *, /* urlist;	- options list			*/
	Cardinal,	/* num_urs;	- number of options		*/
	int *,		/* argc;	- pointer to argc		*/
	char **		/* argv;	- argv				*/
));

						/* Register help	*/
extern void
OlRegisterHelp OL_ARGS((
	OlDefine,	/* id_type;	- type of help being registered	*/
	XtPointer,	/* id;		- id of object registering help	*/
	String,		/* tag;		- string tag for the help msg.	*/
	OlDefine,	/* source_type;	- type of help message source	*/
	XtPointer	/* source;	- pointer to the message source	*/
));

			/* This procedure is used to override the default
			 * fatal error message procedure.		*/
extern void
OlSetVaDisplayErrorMsgHandler OL_ARGS((
	Display *,		/* display;	Display pointer or NULL	*/
	OlAppErrorMsgHandler	/* handler;	new handler or NULL	*/
));

			/* This procedure is used to override the default
			 * non-fatal error message procedure.		*/
extern void
OlSetVaDisplayWarningMsgHandler OL_ARGS((
	Display *,		/* display;	Display pointer or NULL	*/
	OlAppWarningMsgHandler	/* handler;	new handler or NULL	*/
));

	/* To register a procedure to be called on fatal errors:	*/
extern void
OlSetErrorHandler OL_ARGS((
	OlErrorHandler		/* handler;	- handler to be called	*/
));

	/* To register a procedure to be called on non-fatal errors:	*/
extern void
OlSetWarningHandler OL_ARGS((
	OlWarningHandler	/* handler;	- handler to be called	*/
));


			/* The OPEN LOOK toolkit's fatal error routine.
			 * This is a variable argument list routine
			 * where the first 5 parameters are mandatory	*/

extern void
OlVaDisplayErrorMsg OL_ARGS((
	Display *,	/* display;	Display pointer or NULL		*/
	String,		/* name;	message's resource name - 
					concatenated with the type	*/
	String,		/* type;	message's resource type - 
					concatenated to the name	*/
	String,		/* class;	class of message		*/
	String,		/* message;	the message string		*/
	...		/* parameters;	variable arguments to satisfy
					the message parameters		*/
));

			/* The OPEN LOOK toolkit's non-fatal error routine.
			 * This is a variable argument list routine
			 * where the first 5 parameters are mandatory	*/

extern void
OlVaDisplayWarningMsg OL_ARGS((
	Display *,	/* display;	Display pointer or NULL		*/
	String,		/* name;	message's resource name - 
					concatenated with the type	*/
	String,		/* type;	message's resource type - 
					concatenated to the name	*/
	String,		/* class;	class of message		*/
	String,		/* message;	the message string		*/
	...		/* parameters;	variable arguments to satisfy
					the message parameters		*/
));

					/* OPEN LOOK toolkit warning	*/
extern void
OlWarning OL_ARGS((
	String		/* error_msg;	- message string	*/
));

#endif /* _XtIntrinsic_h */

extern void _XtInherit();
static void (*OlInherit)() = _XtInherit;	/* needed to pulling libXt.sa */

#endif /* __Ol_OpenLook_h__ */
