#ifndef NOIDENT
#ident	"@(#)PrimitiveP.h	1.2 SMI"
#ident	"@(#)primitive:PrimitiveP.h	1.6"
#endif


/***********************************************************************
 *
 * Primitive Widget Private Data
 *
 ***********************************************************************/

#ifndef _OlPrimitiveP_h
#define _OlPrimitiveP_h


#include <X11/CoreP.h>

#include <Xol/ManagerP.h>
#include <Xol/Primitive.h>


typedef Boolean	(*OlCanAcceptFocusFunc)();
/*	Widget	w;		/* widget of interest */
/*	Time	time;		/* time stamp */


/***********************************************************************
 *
 * Class record
 *
 ***********************************************************************/

/* New fields for the PrimitiveWidget class record */
typedef struct {
    OlCanAcceptFocusFunc	can_accept_focus;
    OlHighlightProc		highlight_handler;
    OlUnitTypeList		unit_types;
    Cardinal			num_unit_types;
    OlHelpInfo *		help_info;
    OlDynamicResource *		dynamic_resources;
    Cardinal			num_dyn_resources;
    XtVersionType		version;
    XtPointer			extension;
} PrimitiveClassPart;

/* Full class record declaration */
typedef struct _PrimitiveClassRec {
    CoreClassPart	core_class;
    PrimitiveClassPart	primitive_class;
} PrimitiveClassRec;

extern PrimitiveClassRec	primitiveClassRec;


/***********************************************************************
 *
 * Instance record
 *
 ***********************************************************************/

/* New fields for the PrimitiveWidget record */
typedef struct _PrimitivePart {
    /* Resource-related data */
    Widget     	reference_widget;
    Boolean	traversal_on;
    XtPointer	user_data;
    OlDefine	unit_type;

    /* Non-resource-related data */
    Boolean	has_focus;
} PrimitivePart;


/* Full instance record declaration */
typedef struct _PrimitiveRec {
    CorePart		core;
    PrimitivePart	primitive;
} PrimitiveRec;


/***********************************************************************
 *
 * Constants
 *
 ***********************************************************************/

/* Constants for class procedure inheritance */
#define XtInheritCanAcceptFocus		((OlCanAcceptFocusFunc)_XtInherit)

#define _OL_IS_PRIMITIVE(w) (XtIsSubclass((w), primitiveWidgetClass))
#define _OL_HAS_FOCUS(w)    (((PrimitiveWidget)w)->primitive.has_focus)

#endif /* _OlPrimitiveP_h */
