#ifndef	NOIDENT
#ident	"@(#)ScrollbarP.h	1.2 SMI"
#ident	"@(#)scrollbar:include/openlook/ScrollP.h	1.16"
#endif

/*
 * ScrollbarP.h - Private definitions for Scrollbar widget
 *
 */

#ifndef	_ScrollbarP_h
#define	_ScrollbarP_h

/***********************************************************************
 *
 * Scroll Widget Private Data
 *
 ***********************************************************************/

#include <Xol/Scrollbar.h>
#include <Xol/PrimitiveP.h>	/* include superclasses's header */

/* New fields for the Scroll widget class record */
typedef	struct {int empty;} ScrollbarClassPart;

/* Full	class record declaration */
typedef	struct _ScrollbarClassRec {
	CoreClassPart		core_class;
	PrimitiveClassPart	primitive_class;
	ScrollbarClassPart	scroll_class;
} ScrollbarClassRec;

extern ScrollbarClassRec scrollbarClassRec;

/* New fields for the Scroll widget record */
typedef	struct {
	/* Public */
	int	sliderMin;		/* min slider in user scale */
	int	sliderMax;		/* max slider in user scale */
	int	sliderValue;		/* slider value	in user	scale */
	int	granularity;		/* granularity in user scale */
	int	scale;
	int	proportionLength;
	int	currentPage;
	int	repeatRate;
	int	initialDelay;
	Pixel	foreground_pixel;
	XtCallbackList	sliderMoved;
	OlDefine orientation;
	OlDefine showPage;

	/* Private */
	GC	normalGC;	/* Normal GC for drawing */
	GC	invertGC;	/* inverted GC for drawing */
	Pixel	parentbg;
	XtIntervalId timerid;
	XFontStruct *font;	/* for drawing elevator */
	XFontStruct *cfont;	/* for drawing text in page indicator */
	Widget	pane;
	Widget	popup;
	Widget	page_ind;
	Position dragbase;	/* starting pos. of ptr while dragging */
	Position absx;		/* abs x pos. used for displaying page ind */
	Position absy;		/* abs y pos. used for displaying page ind */
	Position sliderPValue;	/* slider value	in pixel */
	Position indPos;		/* indicator position in pixel */
	Position indLen;		/* indicator length in pixel */
	Dimension oldindLen;	/* old ind length, used in fast_moveslider */
	int	previous;	/* used	by "previous" menu button */
	int	XorY;		/* used	by menu	callback, set in menu()	*/
	Dimension length;		/* dimension that elev moves along */
	Dimension width;		/* the other dimension */
	Position  offset;		/* x offset of anchors and elevator */
	Boolean	warp_pointer;
	unsigned char type;	/* regular, abbreviated, or minimum */
	unsigned char opcode;	/* operation code while select is pressed */

	unsigned char anchwidth;/* anchor width	*/
	unsigned char anchlen;	/* anchor length */
	unsigned char anch_gap_elev;	/* gap size b. anchor and elevator */
	unsigned char elev_part_len;	/* length of a part in elevator	*/
	unsigned char linewidth;	/* line	width for all */
	unsigned char cablewidth;	/* cable width */
} ScrollbarPart;

/****************************************************************
 *
 * Full	instance record	declaration
 *
 ****************************************************************/

typedef	struct _ScrollbarRec {
	CorePart	core;
	PrimitivePart	primitive;
	ScrollbarPart	scroll;
} ScrollbarRec;

#endif
