#ifndef	NOIDENT
#ident	"@(#)ScrollingP.h	1.2 SMI"
#ident	"@(#)scrolllist:include/Xol/ListP.h	1.21"
#endif
/*
 ListP.h (C hdr file)
	Acc: 596865502 Tue Nov 29 22:58:22 1988
	Mod: 596865502 Tue Nov 29 22:58:22 1988
	Sta: 596865502 Tue Nov 29 22:58:22 1988
	Owner: 4777
	Group: 1985
	Permissions: 666
*/
/*
	START USER STAMP AREA
*/
/*
	END USER STAMP AREA
*/
/* 
 * ScrollingP.h - Private definitions for Scrolling List widget
 */

#ifndef _ScrollingP_h
#define _ScrollingP_h

#include <Xol/ScrollingL.h>	/* include my public header */
#include <Xol/FormP.h>		/* include superclass' header */

/***********************************************************************
 *
 *	Constants / Macros
 */

#define _OL_NODE_LABEL(token)	(OlListItemPointer(token)->label)

#define _OL_ListHead(node)	((node)->parent->sublist)

typedef OlListItem Item;

typedef struct _OlListToken {
    Item			item;		/* must be first */
    Dimension			widest_item;	/* per level */
    Dimension			tallest_item;	/* per level */
    Cardinal			count;		/* of sublist */
    struct _OlListToken *	parent;
    struct _OlListToken *	sublist;
    struct _OlListToken *	prev;
    struct _OlListToken *	next;
} Node, *List;

/***********************************************************************
 *
 *	External Functions
 */

extern Cardinal
_OlListLength();			/* return length of list */
	/* List		list; */

extern Node *
_OlListTail();				/* return tail of list */
	/* Node *	node; */

extern Cardinal
_OlNodeIndex();				/* return index (offset from head) */
	/* Node *	node; */

extern Node *
_OlOffsetNode();		/* return node which is 'offset' from 'node' */
	/* Node *	node; */
	/* int		offset; */

extern void
_OlPrintList();			/* print (to stderr) contents of list */
	/* Node *	node;	/* this will be flagged as the node passed in */

/***********************************************************************
 *
 *	Class structure
 */
/* New fields for the List widget class record */
typedef struct {
    int no_class_fields;	/* make compiler happy */
} ListClassPart;

/* Full class record declaration */
typedef struct _ListClassRec {
    CoreClassPart	core_class;
    CompositeClassPart 	composite_class;
    ConstraintClassPart	constraint_class;
    ManagerClassPart	manager_class;
    FormClassPart	form_class;
    ListClassPart	list_class;
} ListClassRec;

/* Class record variable */
externalref ListClassRec listClassRec;
extern WidgetClass listWidgetClass;

/***********************************************************************
 *
 *	Instance (widget) structure
 */

/* New fields for the List widget record */
typedef struct { 
    /* PUBLIC (resource) members */

    /* call-forward functions */
    Node *		(*applAddItem)();
    void		(*applDeleteItem)();
    void		(*applEditOpen)();
    void		(*applEditClose)();
    void		(*applTouchItem)();
    void		(*applUpdateView)();
    void		(*applViewItem)();

    /* widget-wide members */
    Pixel		foreground;
    Widget		text_field;	/* text field widget: in-line edits */

    /* callbacks */
    XtCallbackList	userAddItems;
    XtCallbackList	userDeleteItems;
    XtCallbackList	userMakeCurrent;

    /* PRIVATE members */

    /* widget-wide members */
    Boolean		editMode;	/* state of editMode (Open & Close) */

    /* sub-widgets */
    Widget		sbar;		/*  scrollbar */
    Widget		pane;		/*  pane */

    /* list members */
    Node *		listHead;	/* head of list */
    Node *		poolHead;	/* head of pool (available nodes) */
} ListPart;

/* Full instance record declaration */
typedef struct _ListRec {
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    ManagerPart		manager;
    FormPart		form;
    ListPart		list;
} ListRec;

typedef struct _ListRec *ListWidget;

/* constraint record */
typedef struct {
    int	no_fields;
} ListConstraintPart;

typedef struct _ListConstraintRec {
    FormConstraintRec	form;
    ListConstraintPart	list;
} ListConstraintRec, *ListConstraint;

#endif /* _ScrollingP_h */
