#ifndef	NOIDENT
#ident	"@(#)SliderP.h	1.2 SMI"
#ident	"@(#)slider:include/Xol/SliderP.h	1.8"
#endif

/* 
 * Slider.h - Private definitions for Slider widget
 * 
 */

#ifndef _SliderP_h
#define _SliderP_h

/***********************************************************************
 *
 * Slider Widget Private Data
 *
 ***********************************************************************/

#include <Xol/PrimitiveP.h>	/* include superclasses's header */
#include <Xol/Slider.h>

/* New fields for the Slider widget class record */
typedef struct {int empty;} SliderClassPart;

/* Full class record declaration */
typedef struct _SliderClassRec {
	CoreClassPart		core_class;
	PrimitiveClassPart	primitive_class;
	SliderClassPart		slider_class;
} SliderClassRec;

extern SliderClassRec sliderClassRec;

/* New fields for the Slider widget record */
typedef struct {
	/* Public */
        int	sliderMin; 
        int	sliderMax; 
        int	sliderValue; 
        int	granularity; 
	int	scale;
	int	repeatRate;
	int	initialDelay;
        OlDefine orientation; 
	Pixel   foreground_pixel;
        XtCallbackList	sliderMoved; 

	/* Private */
	GC	normalGC;
	GC	invertGC;
	Pixel	parentbg;
	XtIntervalId	timerid;
	XFontStruct	*font;
	Position	dragbase;
	Position	absx;
	Position	absy;
	Position	sliderPValue;
	Dimension	length;
	Dimension	width;
	Position	anch_offset;
	Position	elev_offset;
	Position	cable_offset;
	Boolean		warp_pointer;
	unsigned char type;
	unsigned char opcode;
	unsigned char anchlen;
	unsigned char anchwidth;
	unsigned char anch_gap_elev;
	unsigned char elev_part_len;
	unsigned char cablewidth;
	unsigned char elev_width;
	unsigned char roundlen;
} SliderPart;

/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _SliderRec {
	CorePart	core;
	PrimitivePart	primitive;
	SliderPart	slider;
} SliderRec;

#endif /* _SliderP_h */
