#ifndef NOIDENT
#ident	"@(#)buffutil.h	1.2 SMI"
#ident	"@(#)buffutil.h	1.2"
#endif

/*
 * buffutil.h
 *
 */

#ifndef _buffutil_h
#define _buffutil_h

#include <stdio.h>		/* for SEEK_SET */

#ifndef SEEK_SET
#define memmove(dest, src, n)  bcopy((char*)src, (char*)dest, (int)n)
#define SEEK_SET 0
#endif
typedef char BufferElement;

#define Bufferof(type) \
   struct \
      { \
      int    size; \
      int    used; \
      int    esize; \
      type * p; \
      }

typedef struct _Buffer
   {
   int    size;
   int    used;
   int    esize;
   BufferElement * p;
   } Buffer;

#define LNMIN       8
#define LNINCRE    24

#define BufferFilled(b)  (b-> size == b-> used)
#define BufferLeft(b)    (b-> size - b-> used)
#define BufferEmpty(b)   (b-> used == 0)

extern Buffer * AllocateBuffer();
extern void     GrowBuffer();
extern Buffer * CopyBuffer();
extern void     FreeBuffer();
extern int      InsertIntoBuffer();
extern int      ReadFileIntoBuffer();
extern int      ReadStringIntoBuffer();

extern Buffer * stropen();
extern int      strgetc();
extern void     strclose();

#endif
