/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef	NOIDENT
#ident	"@(#)scrolllist:examples/scrolllist/unit_test1.c	1.27"
#endif
/*
 unit_test1.c (C source file)
	Acc: 596865457 Tue Nov 29 22:57:37 1988
	Mod: 596865457 Tue Nov 29 22:57:37 1988
	Sta: 596865457 Tue Nov 29 22:57:37 1988
	Owner: 4777
	Group: 1985
	Permissions: 666
*/
/*
	START USER STAMP AREA
*/
/*
	END USER STAMP AREA
*/
/*	this program builds a basic list but is not interested in user
 *	interaction (callbacks).  although a basic list, the list is built
 *	with a head.  this head is passed to a print routine which prints
 *	the contents of the list as the widget sees it.  note that the
 *	head must be descended into.
 */

#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <math.h>

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <Xol/OpenLook.h>
#include <Xol/ControlAre.h>
#include <Xol/Form.h>
#include <Xol/FooterPane.h>
#include <Xol/OblongButt.h>
#ifdef APPL_PATCH
#include <X11/IntrinsicP.h>	/* necessary due to FormP.h deficiency */
#include <X11/ConstrainP.h>	/* necessary due to FormP.h deficiency */
#include <Xol/ScrollingP.h>
#else /* APPL_PATCH */
#include <X11/Intrinsic.h>
#include <Xol/ScrollingL.h>
#endif /* APPL_PATCH */
#include <Xol/StaticText.h>
#include <Xol/TextField.h>

static Arg		args[20];
static Cardinal		cnt;
static OlListToken	current_item = 0;
static Widget		current_lw = 0;
static Widget		footer;
static int		num_lists	= 1;
static int		rows		= 1;
static Boolean		selectable	= True;
static Cardinal		viewHeight	= 0;

static OlListToken	(*addItem)();
static void		(*deleteItem)();
static void		(*editOff)();
static void		(*editOn)();
static void		(*touch)();
static void		(*update)();
static void		(*view)();

void			CreateLists();
void			CutCB();
void			DebugCB();
void			DeleteCB();
void			EditCB();
void			QuitCB();
void			MakeCurrentCB();
void			Report();
void			Usage();
void			VerifyEditCB();

#define OFFSET 3


main(argc, argv)
    int		argc;
    char *	argv[];
{
    extern char *	optarg;
    extern int		optind;
    int			opterr = 0;
    int			opt;

    OlListToken	token;
    Widget	toplevel, panel, base;
    Widget	control, edit, delete, debug, quit;

    toplevel = OlInitialize(NULL, "SList", NULL, 0, &argc, argv);

    while ( (opt = getopt(argc, argv, "l:uv:?")) != -1)
	switch (opt) {
	case 'l':
	    num_lists = atoi(optarg);
	    if (num_lists <= 0) num_lists = 1;
	    break;
	case 'u':
	    selectable = FALSE;
	    break;
	case 'v':
	    viewHeight = atoi(optarg);
	    break;
	case '?':
	    opterr++;
	    break;
	}
    if (opterr)
	Usage(argv[0]);		/* report usage & exit */

    if (optind > argc)
	Usage(argv[0]);		/* report usage & exit */

    /* SINGLE CHILD OF TOPLEVEL */
    cnt = 0;
    panel = XtCreateManagedWidget("panel", footerPanelWidgetClass,
				  toplevel, args, cnt);

    /* "TOP" CHILD OF PANEL */
    cnt = 0;
    XtSetArg(args[cnt], XtNtraversalManager, True); cnt++;
    base = XtCreateManagedWidget("base", formWidgetClass,
				 panel, args, cnt);

    /* Button Control Area and Buttons */

    cnt = 0;
    XtSetArg(args[cnt], XtNlayoutType, OL_FIXEDROWS); cnt++;
    XtSetArg(args[cnt], XtNxAttachRight, True); cnt++;
    control = XtCreateManagedWidget("control", controlAreaWidgetClass,
				    base, args, cnt);

    cnt = 0;
    edit = XtCreateManagedWidget("edit", oblongButtonWidgetClass,
				 control, args, cnt);
    XtAddCallback(edit, XtNselect, EditCB, NULL);

    cnt = 0;
    delete = XtCreateManagedWidget("delete", oblongButtonWidgetClass,
				   control, args, cnt);
    XtAddCallback(delete, XtNselect, DeleteCB, NULL);

    cnt = 0;
    debug = XtCreateManagedWidget("debug", oblongButtonWidgetClass,
				  control, args, cnt);
    XtAddCallback(debug, XtNselect, DebugCB, NULL);

    cnt = 0;
    quit = XtCreateManagedWidget("quit", oblongButtonWidgetClass,
				  control, args, cnt);
    XtAddCallback(quit, XtNselect, QuitCB, NULL);

    CreateLists(control, optind, argc, argv);

    /* "FOOTER" CHILD OF PANEL */
    cnt = 0;
    footer = XtCreateManagedWidget("footer", staticTextWidgetClass,
				   panel, args, cnt);

    XtRealizeWidget(toplevel);

    XtMainLoop();
}

void
CreateLists(refWidget, optind, argc, argv)
    Widget	refWidget;
    int		optind;
    int		argc;
    char *	argv[];
{
#define Pos(row, col) ((cols * row) + col)
    int			col, row, rows, cols;
    DIR *		dir;
    struct dirent *	entry;
    OlListItem		item;
    OlListToken		token;
    static WidgetList	lists;
    static WidgetList	text_field;
    static OlListToken * tokens;

    lists	= (WidgetList)XtMalloc(num_lists * sizeof(Widget));
    text_field	= (WidgetList)XtMalloc(num_lists * sizeof(Widget));
    tokens	= (OlListToken *)XtMalloc(num_lists * sizeof(OlListToken));

    cols = (int)ceil(sqrt((double)num_lists));
    rows = (num_lists + cols - 1) / cols;

    for (row=0; row<rows; row++)
	for (col=0; col<cols; col++) {
	    if (Pos(row, col) >= num_lists)
		break;

	    cnt = 0;
	    XtSetArg(args[cnt], XtNselectable, selectable); cnt++;
	    XtSetArg(args[cnt], XtNtraversalOn, True); cnt++;
	    XtSetArg(args[cnt], XtNviewHeight, viewHeight); cnt++;

	    XtSetArg(args[cnt], XtNxOffset, OFFSET); cnt++;
	    XtSetArg(args[cnt], XtNxResizable, True); cnt++;
	    XtSetArg(args[cnt], XtNxVaryOffset, False); cnt++;
	    XtSetArg(args[cnt], XtNyOffset, OFFSET); cnt++;
	    XtSetArg(args[cnt], XtNyResizable, True); cnt++;
	    XtSetArg(args[cnt], XtNyVaryOffset, False); cnt++;

	    if (col > 0) {
		XtSetArg(args[cnt], XtNxRefWidget, lists[Pos(0, col-1)]); cnt++;
		XtSetArg(args[cnt], XtNxAddWidth, True); cnt++;
	    }
	    if (row > 0) {
		XtSetArg(args[cnt], XtNyRefWidget, lists[Pos(row-1, 0)]); cnt++;
		XtSetArg(args[cnt], XtNyAddHeight, TRUE); cnt++;
	    } else {
		XtSetArg(args[cnt], XtNyRefWidget, refWidget); cnt++;
		XtSetArg(args[cnt], XtNyAddHeight, True); cnt++;
	    }
	    if (row == rows - 1) {
		XtSetArg(args[cnt], XtNyAttachBottom, TRUE); cnt++;
	    }
	    if (col == cols - 1) {
		XtSetArg(args[cnt], XtNxAttachRight, TRUE); cnt++;
	    }

	    lists[Pos(row, col)] =
		XtCreateManagedWidget("slist", scrollingListWidgetClass,
				      XtParent(refWidget), args, cnt);

#ifdef APPL_PATCH
	    ((ScrollingListWidget)lists[Pos(row, col)])->list.listHead =
		(Node *)calloc(1, sizeof(Node));
	    ((ScrollingListWidget)lists[Pos(row, col)])->list.currentLevel =
		((ScrollingListWidget)lists[Pos(row, col)])->list.listHead;
#endif

	    cnt = 0;
	    if (row == 0 && col == 0) {	/* do these only once */
		XtSetArg(args[cnt], XtNapplAddItem, &addItem); cnt++;
		XtSetArg(args[cnt], XtNapplDeleteItem, &deleteItem); cnt++;
		XtSetArg(args[cnt], XtNapplEditClose, &editOff); cnt++;
		XtSetArg(args[cnt], XtNapplEditOpen, &editOn); cnt++;
		XtSetArg(args[cnt], XtNapplTouchItem, &touch); cnt++;
		XtSetArg(args[cnt], XtNapplUpdateView, &update); cnt++;
		XtSetArg(args[cnt], XtNapplViewItem, &view); cnt++;
	    }
	    XtSetArg(args[cnt], XtNtextField, &(text_field[Pos(row, col)])); cnt++;
	    XtGetValues(lists[Pos(row, col)], args, cnt);

/*
	    if ((dir = opendir(argv[optind])) == NULL) {
*/
	    if ((dir = opendir(".")) == NULL) {
		fprintf(stderr, "Couldn't open %s as directory \n", argv[optind]);
		Usage(argv[0]);	/* report usage & exit */
	    }
	    if (optind < argc - 1)
		optind++;

	    item.label_type = OL_STRING;
	    item.attr =		/* OL_LIST_ATTR_CURRENT; */ 0;
	    while ((entry = readdir(dir)) != NULL) {
		String name = XtMalloc(strlen(entry->d_name) + 1);
		strcpy(name, entry->d_name); /* save file name */
		item.label = name;
		token = (*addItem)(lists[Pos(row, col)], NULL, NULL, item);
	    }
	    tokens[Pos(row, col)] = token;
	    closedir(dir);

	    XtAddCallback(lists[Pos(row, col)], XtNuserMakeCurrent,
			  MakeCurrentCB, NULL);
	    XtAddCallback(lists[Pos(row, col)], XtNuserDeleteItems, CutCB, NULL);
	    XtAddCallback(text_field[Pos(row, col)], XtNverification,
			  VerifyEditCB, lists[Pos(row, col)]);
	}
}


static void
CutCB(lw, closure, call_data)
    Widget lw;				/* list widget */
    XtPointer closure, call_data;
{
    OlListDelete * data = (OlListDelete *) call_data;
    Cardinal	cnt = data->num_tokens;
    OlListToken *	tokens = data->tokens;

    (*update)(lw, FALSE);

    while (cnt--) {
	if (*tokens == current_item)
	    current_item = NULL;
	(*deleteItem)(lw, *tokens++);
    }
    (*update)(lw, TRUE);
}


static void
DebugCB(w, closure, call_data)
    Widget w;
    XtPointer closure, call_data;
{
#ifdef _OL_LIST_DEBUG
    _OlPrintList( (OlListToken)closure );
#endif	/* _OL_LIST_DEBUG */
}

static void
DeleteCB(w, closure, call_data)
    Widget w;
    XtPointer closure, call_data;
{
    if (current_item == NULL) {
	Report("No current-item selected");
	return;
    }

    (*deleteItem)(current_lw, current_item);

    current_item = NULL;
}

static void
EditCB(w, closure, call_data)
    Widget w;
    XtPointer closure, call_data;
{
    if (current_item == NULL) {
	Report("No current-item selected");
	return;
    }

    (*editOn)(current_lw, FALSE, current_item);
}

static void
QuitCB(w, closure, call_data)
    Widget w;
    XtPointer closure, call_data;
{
    fprintf(stderr, "bye \n");
    exit(0);
}

static void
MakeCurrentCB(lw, closure, call_data)
    Widget	lw;
    XtPointer	closure, call_data;
{
    OlListToken selected_item = (OlListToken) call_data;
    static char msg[100];

    if (current_item == selected_item && current_lw == lw)
	return;

    /* make previous current_item no longer current */
    if (current_item != NULL) {
	OlListItemPointer(current_item)->attr &= ~OL_B_LIST_ATTR_CURRENT;
	(*touch)(current_lw, current_item);
    }

    /* make the selected_item the current item */
    OlListItemPointer(selected_item)->attr |= OL_B_LIST_ATTR_CURRENT;
    (*touch)(lw, selected_item);
    (*view)(lw, selected_item);	/* make sure we're in view.  this is
				 * for keyboard searches, item is
				 * made current but may not be visible
				 */

    current_item= selected_item;	/* new current_item */
    current_lw	= lw;			/* new current widget */

    (void) strcpy(msg, "selected_item= ");
    (void) strcat(msg, OlListItemPointer(selected_item)->label);
    Report(msg);
}

void
Report(msg)
    String msg;
{
    Arg arg[1];

    XtSetArg(arg[0], XtNstring, msg);
    XtSetValues(footer, arg, XtNumber(arg));
}

void
Usage(name)
    char *	name;
{
    fprintf(stderr, "usage: %s [options] directory [directory, ]\n", name);
    fprintf(stderr, "\twhere options are: %s %s %s %s %s",
	    "\n\t\t-l	number of lists to generate",
	    "\n\t\t-u	turn off selection",
	    "\n\t\t-v#	view size (items in view)",
	    "\n\t\t-z	debug",
	    "\n"
	    );
    exit(1);
}

static void
VerifyEditCB(w, closure, call_data)
    Widget w;
    XtPointer closure, call_data;
{
    Widget		lw = (Widget)closure; /* list widget */
    OlTextFieldVerify *	data = (OlTextFieldVerify *) call_data;

    if (!data->ok) return;

    /* "touch" item: stuff new string in it */
    OlListItemPointer(current_item)->label = data->string;
    (*touch)(lw, current_item);
    (*view)(lw, current_item);	/* make sure we're in view */
    (*editOff)(lw);		/* turn off editing */
}
