/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/**
PROJECT:	The AT&T Xtk Test
NAME:		actions.c
MODULE:
CATEGORY:
SCCS INFO:	ID (release.level.branch.sequence) - 1.2
		Date newest applied delta created  - 6/19/90
		Date this file gotten - 6/19/90
HISTORY:	Date	 Version  Person	Modification
		11/23/88 1.00.00  sfbat!chang	initial coding
NOTES:
		Confidential, please do not disclose
**/

#include "sampler_ext.h"

static void unmap_child_in_form (flag)
	int			flag;
{
	XtUnmanageChild (t_wids[flag]);
	t_flags [flag] = T_UNMAP;
}

static void map_child_in_form (flag)
	int			flag;
{
	XtManageChild (t_wids[flag]);
	XtMapWidget (t_wids[flag]);
	t_flags[flag] = T_MAP;
}

void popup_callback (w, client_data, call_data)
	Widget			w;
	Widget			client_data;
	caddr_t			call_data;
{
	XtPopup (client_data, XtGrabNone);
}

void generic_callback (w, client_data, call_data)
	Widget			w;
	int			*client_data;
	char			*call_data;
{
	if (t_flags[*client_data] == T_UNMAP)
		map_child_in_form (*client_data);
	else
		unmap_child_in_form (*client_data);
}

void undo_callback (w, client_data, call_data)
	Widget			w;
	caddr_t			client_data,
				call_data;
{
	int i;

	for (i = 0; i < T_BUFS; i++)
		generic_callback (w, &i, NULL);
}

void done_callback (w, client_data, call_data)
	Widget			w;
	caddr_t			client_data,
				call_data;
{
}

XFontStruct *t_getfont (dpy, name)
	Display			*dpy;
	char			*name;
{
	XFontStruct		*fs;

	Font			fid;

	fid = XLoadFont(dpy, name);
	fs = XQueryFont(dpy, fid);

	if (fs == NULL)
	{
		fprintf (stderr, "Can't Load font `%s'\n", name);
		exit (1);
	}

	return (fs);
}

long t_get_pixel (dpy, color_name)
	Display			*dpy;
	char			*color_name;
{
	XColor			d1,
				d2;


	Status			ret;


	ret = XAllocNamedColor(
			dpy,
			XDefaultColormap(dpy, XDefaultScreen(dpy)),
			color_name,
			&d1,
			&d2
	);

	if (ret == False) {
		fprintf (stderr, "Can't allocate color `%s'\n", color_name);
		exit (1);
	}
	return (d2.pixel);
}
