/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/**
PROJECT:	The AT&T Xtk Test
NAME:		command.c
MODULE:
CATEGORY:
SCCS INFO:	ID (release.level.branch.sequence) - 1.2
		Date newest applied delta created  - 6/19/90
		Date this file gotten - 6/19/90
HISTORY:	Date	 Version  Person	Modification
		11/23/88 1.00.00  sfbat!chang	initial coding
		10/17/89 1.00.00  sfbat!chang	use gadget
NOTES:
		Confidential, please do not disclose
**/

#include "sampler_ext.h"
/**/
#include "Xol/PopupWindo.h"
#include "Xol/Caption.h"
#include "Xol/OblongButt.h"
#include "Xol/Slider.h"
#include "Xol/StaticText.h"

#define COLOR_BASE		256
#define MAX_COLOR_VALUE		(256 << 8) - 256
#define MIN_COLOR_VALUE		0

extern void	popup_callback ();

static void	apply_call(),
		apply_r(),
		apply_g(),
		apply_b();

static Widget	r_slider,
		g_slider,
		b_slider,
		footer_stext;


static char	r_buff [80],
		g_buff [80],
		b_buff [80],
		rgb_buff [100];

void command_window (menupane)
	Widget		menupane;
{
	Widget		cmd,
			parent,
			apply,
			red_capt,
			green_capt,
			blue_capt;

	Widget		low,
			upper,
			footer;


	T_INIT_ARGS;
	T_SET_ARGS (XtNdefault, True);
	T_SET_ARGS (XtNlabelType, OL_POPUP);
#ifdef OL2_0
	parent = T_CREATE_WIDGET(
			"Command Window",
                	oblongButtonGadgetClass,
                	menupane
			);
#else
	parent = T_CREATE_WIDGET(
			"Command Window",
                	oblongButtonWidgetClass,
                	menupane
			);
#endif

	T_INIT_ARGS;
	T_SET_ARGS (XtNtitle, "Command Window");
	cmd = T_CREATE_POPUP(
			"CmdWin",
			popupWindowShellWidgetClass,
			menupane
	);

	T_INIT_ARGS;
	T_SET_ARGS (XtNlowerControlArea, &low);
	T_SET_ARGS (XtNupperControlArea, &upper);
	T_SET_ARGS (XtNfooterPanel, &footer);
	T_GET_VALS (cmd);

	T_INIT_ARGS;
	T_SET_ARGS (XtNborderWidth, 0);
	T_SET_VALS (upper);

	T_INIT_ARGS;
	T_SET_ARGS (XtNheight, 80);
	T_SET_ARGS (XtNrecomputeSize, False);
	T_SET_ARGS (XtNborderWidth, 0);
	T_SET_VALS (low);

	T_INIT_ARGS;
#ifdef OL2_0
	apply = T_CREATE_WIDGET(
			"Change StaticText Color",
			oblongButtonGadgetClass,
			low
	);
#else
	apply = T_CREATE_WIDGET(
			"Change StaticText Color",
			oblongButtonWidgetClass,
			low
	);
#endif

	T_INIT_ARGS;
	T_SET_ARGS (XtNlabel, "Red Value:");
	T_SET_ARGS (XtNborderWidth, 0);
	red_capt = T_CREATE_WIDGET(
			"Red Label",
			captionWidgetClass,
			upper
	);

	T_INIT_ARGS;
	T_SET_ARGS (XtNsliderMin, MIN_COLOR_VALUE);
	T_SET_ARGS (XtNsliderMax, MAX_COLOR_VALUE);
	T_SET_ARGS (XtNorientation, OL_HORIZONTAL);
	T_SET_ARGS (XtNwidth, COLOR_BASE);
	T_SET_ARGS (XtNsliderValue, MIN_COLOR_VALUE);
	T_SET_ARGS (XtNgranularity, COLOR_BASE);
	r_slider = T_CREATE_WIDGET(
			"Red Value",
			sliderWidgetClass,
			red_capt
	);
	XtAddCallback (r_slider, XtNsliderMoved, apply_r, NULL);

	T_INIT_ARGS;
	T_SET_ARGS (XtNlabel, "Green Value:");
	T_SET_ARGS (XtNborderWidth, 0);
	green_capt = T_CREATE_WIDGET(
			"Green Label",
			captionWidgetClass,
			upper
	);

	T_INIT_ARGS;
	T_SET_ARGS (XtNsliderMin, MIN_COLOR_VALUE);
	T_SET_ARGS (XtNsliderMax, MAX_COLOR_VALUE);
	T_SET_ARGS (XtNorientation, OL_HORIZONTAL);
	T_SET_ARGS (XtNwidth, COLOR_BASE);
	T_SET_ARGS (XtNsliderValue, MIN_COLOR_VALUE);
	T_SET_ARGS (XtNgranularity, COLOR_BASE);
	g_slider = T_CREATE_WIDGET(
			"Green Value",
			sliderWidgetClass,
			green_capt
	);
	XtAddCallback (g_slider, XtNsliderMoved, apply_g, NULL);

	T_INIT_ARGS;
	T_SET_ARGS (XtNlabel, "Blue Value:");
	T_SET_ARGS (XtNborderWidth, 0);
	blue_capt = T_CREATE_WIDGET(
			"Blue Label",
			captionWidgetClass,
			upper
	);

	T_INIT_ARGS;
	T_SET_ARGS (XtNsliderMin, MIN_COLOR_VALUE);
	T_SET_ARGS (XtNsliderMax, MAX_COLOR_VALUE);
	T_SET_ARGS (XtNorientation, OL_HORIZONTAL);
	T_SET_ARGS (XtNwidth, COLOR_BASE);
	T_SET_ARGS (XtNsliderValue, MIN_COLOR_VALUE);
	T_SET_ARGS (XtNgranularity, COLOR_BASE);
	b_slider = T_CREATE_WIDGET(
			"Blue Value",
			sliderWidgetClass,
			blue_capt
	);
	XtAddCallback (b_slider, XtNsliderMoved, apply_b, NULL);

	strcpy (r_buff, "Red: 0");
	strcpy (g_buff, "Green: 0");
	strcpy (b_buff, "Blue: 0");
	sprintf (rgb_buff, "%s, %s, %s", r_buff, g_buff, b_buff);
	T_INIT_ARGS;
	T_SET_ARGS (XtNstring, rgb_buff);
	footer_stext = T_CREATE_WIDGET(
			"footerMessage",
			staticTextWidgetClass,
			footer
	);

	XtAddCallback (parent, XtNselect, popup_callback, cmd);
	XtAddCallback (apply, XtNselect, apply_call, NULL);

	XtRealizeWidget (cmd);

	return;
}

static void rgb_pixel (dpy, pixel)
	Display		*dpy;
	int		*pixel;
{
#ifdef tCOLOR
	int  r, g, b;

	XColor	    rgb_color;


	T_INIT_ARGS;
	T_SET_ARGS (XtNsliderValue, &r);
	T_GET_VALS (r_slider);

	T_INIT_ARGS;
	T_SET_ARGS (XtNsliderValue, &g);
	T_GET_VALS (g_slider);

	T_INIT_ARGS;
	T_SET_ARGS (XtNsliderValue, &b);
	T_GET_VALS (b_slider);

	rgb_color . flags = DoRed | DoGreen | DoBlue;
	rgb_color . red = r;
	rgb_color . green = g;
	rgb_color . blue = b;

	if (t_show_warning)
		fprintf (stderr,
			 "apply_call: r: %d, g: %d, b: %d, f: %d\n",
			 rgb_color.red,
			 rgb_color.green,
			 rgb_color.blue,
			 rgb_color.flags
			);

	if (XAllocColor (dpy,
                         XDefaultColormap(dpy, XDefaultScreen(dpy)),
			 &rgb_color) == 0)
	{
		fprintf (stderr,
			 "Can not alloc: red: %d, green: %d, blue: %d\n",
			 rgb_color.red,
			 rgb_color.green,
			 rgb_color.blue
			);
		*pixel = -1;
		exit (1);
	}
	if (t_show_warning)
		fprintf (stderr,
			 "apply_call: pixel: %d (r=%d, g=%d, b=%d, f=%d)\n",
			 rgb_color.pixel,
			 rgb_color.red,
			 rgb_color.green,
			 rgb_color.blue,
			 rgb_color.flags
			);
	
	*pixel = rgb_color . pixel;
#else
	extern long	t_get_pixel ();

	*pixel = (int) t_get_pixel (dpy, "black");
#endif

	return;
}

static void apply_call (w, client_data, call_data)
	Widget		w;
	caddr_t		client_data,
			call_data;
{
	int		pixel;
	XFontStruct	*fontPtr, *t_getfont ();

	rgb_pixel (XtDisplay (w), &pixel);

	fontPtr = t_getfont(
			XtDisplay (w),
#ifdef tOLFONT
			"b12lucid"
#else
			"fixed"
#endif
			);
	T_INIT_ARGS;
	T_SET_ARGS (XtNfont, fontPtr);
	T_SET_ARGS (XtNfontColor, pixel);
	T_SET_VALS (t_prp_chg_wids [T_STATIC_TEXT]);

	return;
}

static void apply_r (w, client_data, call_data)
	Widget	w;
	char	*client_data;
	int	*call_data;
{
	sprintf (r_buff, "Red: %d", *call_data);
	sprintf (rgb_buff, "%s, %s, %s", r_buff, g_buff, b_buff);
	if (t_show_warning)
		fprintf (stderr, "apply_r: %s\n", rgb_buff);

	T_INIT_ARGS;
	T_SET_ARGS (XtNstring, rgb_buff);
	T_SET_VALS (footer_stext);

	return;
}

static void apply_g (w, client_data, call_data)
	Widget	w;
	char	*client_data;
	int	*call_data;
{
	sprintf (g_buff, "Green: %d", *call_data);
	sprintf (rgb_buff, "%s, %s, %s", r_buff, g_buff, b_buff);
	if (t_show_warning)
		fprintf (stderr, "apply_g: %s\n", rgb_buff);

	T_INIT_ARGS;
	T_SET_ARGS (XtNstring, rgb_buff);
	T_SET_VALS (footer_stext);

	return;
}

static void apply_b (w, client_data, call_data)
	Widget	w;
	char	*client_data;
	int	*call_data;
{
	sprintf (b_buff, "Blue: %d", *call_data);
	sprintf (rgb_buff, "%s, %s, %s", r_buff, g_buff, b_buff);
	if (t_show_warning)
		fprintf (stderr, "apply_b: %s\n", rgb_buff);

	T_INIT_ARGS;
	T_SET_ARGS (XtNstring, rgb_buff);
	T_SET_VALS (footer_stext);

	return;
}
