/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/**
PROJECT:	The AT&T Xtk Test
NAME:		images.c
MODULE:
CATEGORY:
SCCS INFO:	ID (release.level.branch.sequence) - 1.2
		Date newest applied delta created  - 6/19/90
		Date this file gotten - 6/19/90
HISTORY:	Date	 Version  Person	Modification
		11/23/88 1.00.00  sfbat!chang	initial coding
NOTES:
		Confidential, please do not disclose
**/

#include <stdio.h>

#include "X11/Xlib.h"

extern long		t_get_pixel();

XImage *t_note (dpy)
	Display		*dpy;
{

#define NOTE_W		48
#define NOTE_H		36
#define NOS_PTS 	5
#ifdef tCOLOR
#define COLOR_S_1	"magenta"
#define COLOR_S_2	"yellow"
#define COLOR_S_3	"light grey"
#else
#define COLOR_S_1	"white"
#define COLOR_S_2	"white"
#define COLOR_S_3	"white"
#endif

	static GC	gc = 0;

	static XPoint	set_1 [] = {
				{ 4, 4 }, { 33, 18 },
	};

	static XPoint	set_2 [] = {
				{ 4, 22 }, { 10, 32 },
				{ 43, 32 }, { 37, 22 }, { 4, 22 },
	};

	static XPoint	set_3 [] = {
				{ 37, 4}, { 37, 22 },
				{ 43, 32 }, { 43, 14 }, { 37, 4 },
	};

	int		screen		= XDefaultScreen(dpy),
			depth		= XDefaultDepth(dpy, screen);

	Window		root		= XDefaultRootWindow(dpy, screen);

	static XImage	*image = 0;

	Pixmap		pid;

	long		my_color;

	int		foreground	= XWhitePixel(dpy, screen),
			black		= XBlackPixel(dpy, screen);


	if (image)
		return (image);

	if (!gc)
		gc = XCreateGC (dpy, root, 0, NULL);

	pid = XCreatePixmap(dpy, root, NOTE_W, NOTE_H, depth);
	XSetForeground (dpy, gc, foreground);
	XSetFillStyle (dpy, gc, FillSolid);
	XFillRectangle (dpy, pid, gc, 0, 0, NOTE_W, NOTE_H);

	XSetForeground (dpy, gc, t_get_pixel(dpy, COLOR_S_1));
	XFillRectangle (dpy, pid, gc,
			set_1[0].x, set_1[0].y, set_1[1].x, set_1[1].y);
	XSetForeground (dpy, gc, black);
	XDrawRectangle (dpy, pid, gc,
			set_1[0].x, set_1[0].y, set_1[1].x, set_1[1].y);

	XSetForeground (dpy, gc, t_get_pixel(dpy, COLOR_S_2));
	XFillPolygon (dpy, pid, gc, set_2, NOS_PTS, Convex, CoordModeOrigin);
	XSetForeground (dpy, gc, black);
	XDrawLines (dpy, pid, gc, set_2, NOS_PTS, CoordModeOrigin);

	XSetForeground (dpy, gc, t_get_pixel(dpy, COLOR_S_3));
	XFillPolygon (dpy, pid, gc, set_3, NOS_PTS, Convex, CoordModeOrigin);
	XSetForeground (dpy, gc, black);
	XDrawLines (dpy, pid, gc, set_3, NOS_PTS, CoordModeOrigin);

	image = XGetImage(
			dpy,
			pid,
			0,
			0,
			NOTE_W,
			NOTE_H,
			XAllPlanes(),
			XYPixmap
	);

	XFreePixmap (dpy, pid);

	return (image);
}

XImage *t_pen (dpy)
	Display		*dpy;
{

#define PEN_W	48
#define PEN_H	36
#ifdef tCOLOR
#define COLOR_SET_1	"black"
#define COLOR_SET_2	"light grey"
#define COLOR_SET_3	"skyblue"
#else
#define COLOR_SET_1	"black"
#define COLOR_SET_2	"black"
#define COLOR_SET_3	"black"
#endif
#define NOS_SET_2	4

	static GC	gc		= NULL;

	static XPoint	set_1 [] = {
				{ 1, 18 }, { 3, 18 },
	};

	static XPoint	set_2 [] = {
				{ 3, 18 }, { 12, 11 }, { 12, 25 }, { 3, 18 },
	};

	static XPoint	set_3 [] = {
				{ 12, 11 }, { 33, 14 },
	};

	int		screen		= XDefaultScreen(dpy),
			depth		= XDefaultDepth (dpy, screen);

	Window		root		= XDefaultRootWindow(dpy, screen);

	static XImage	*image		= NULL;

	Pixmap		pid;

	long		my_color;

	int		foreground	= XWhitePixel (dpy, screen),
			black		= XBlackPixel (dpy, screen);


	if (image != NULL)
		return (image);

	if (!gc)
		gc = XCreateGC (dpy, root, 0, NULL);

	pid = XCreatePixmap (dpy, root, PEN_W, PEN_H, depth);

	XSetForeground (dpy, gc, foreground);
	XSetFillStyle (dpy, gc, FillSolid);
	XFillRectangle (dpy, pid, gc, 0, 0, PEN_W, PEN_H);
	XDrawRectangle (dpy, pid, gc, 0, 0, PEN_W, PEN_H);

	XSetForeground (dpy, gc, black);
	XDrawLine (dpy, pid, gc,
		   set_1 [0].x, set_1 [0].y, set_1 [1].x, set_1 [1].y);

	XSetForeground (dpy, gc, t_get_pixel(dpy, COLOR_SET_2));
	XFillPolygon (dpy, pid, gc,
		      set_2, NOS_SET_2, Convex, CoordModeOrigin);
	XSetForeground (dpy, gc, t_get_pixel(dpy, COLOR_SET_3));
	XFillRectangle (dpy, pid, gc,
			set_3[0].x, set_3[0].y, set_3[1].x, set_3[1].y);

	image = XGetImage(
			dpy,
			pid,
			0,
			0,
			PEN_W,
			PEN_H,
			XAllPlanes(),
			XYPixmap
	);

	XFreePixmap (dpy, pid);

	return (image);
}

XImage *t_star (dpy)
	Display		*dpy;
{

#define THE_W		36
#define THE_H		15
#define NOS_COLORS	5
#define X1		THE_W/2
#define X2		THE_W/4
#define X3		3*X2
#define X4		THE_W
#define Y1		THE_H/3
#define Y2		THE_H

	typedef struct {
		short	x1,
			y1,
			x2,
			y2;
	}			Coord;

	static GC	gc		= 0;

	static char	*color_name[] = {
#ifdef tCOLOR
		 		"red",
		 		"orange",
		 		"blue",
		 		"sea green",
		 		"green",
#else
		 		"black",
		 		"black",
		 		"black",
		 		"black",
		 		"black",
#endif
	};

	static Coord	pts[NOS_COLORS] = {
				{ X1,  0, X2, Y2 },
				{ X2, Y2, X4, Y1 },
				{ X4, Y1,  0, Y1 },
				{  0, Y1, X3, Y2 },
				{ X3, Y2, X1,  0},
	};

	int		screen		= XDefaultScreen(dpy),
			depth		= XDefaultDepth(dpy, screen);

	Window		root		= XDefaultRootWindow(dpy, screen);

	static XImage	*image		= NULL;

	Pixmap		pid;

	XColor		colors[5],
			dummy;

	int		foreground	= XWhitePixel(dpy, screen),
			black		= XBlackPixel(dpy, screen),
			i;


	if (image != NULL)
		return (image);

	if (gc == NULL)
		gc = XCreateGC (dpy, root, 0, NULL);

	for (i = 0; i < NOS_COLORS; i++)
		colors[i].pixel = t_get_pixel(dpy, color_name[i]);

	pid = XCreatePixmap (dpy, root, THE_W, THE_H, depth);
	XSetForeground (dpy, gc, foreground);
	XSetFillStyle (dpy, gc, FillSolid);
	XFillRectangle (dpy, pid, gc, 0, 0, THE_W, THE_H);
	XDrawRectangle (dpy, pid, gc, 0, 0, THE_W, THE_H);

	for (i = 0; i < NOS_COLORS; i++) {
		XSetForeground (dpy, gc, colors [i]. pixel);
		XDrawLine (dpy, pid, gc,
			   pts[i].x1, pts[i].y1,
			   pts[i].x2, pts[i].y2);
	}

	image = XGetImage(
			dpy,
			pid,
			0,
			0,
			THE_W,
			THE_H,
			XAllPlanes(),
			XYPixmap
	);

	XFreePixmap (dpy, pid);

	return (image);
}
