/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/**
PROJECT:	The AT&T Xtk Test
NAME:		init.c
MODULE:
CATEGORY:
SCCS INFO:	ID (release.level.branch.sequence) - 1.2
		Date newest applied delta created  - 6/19/90
		Date this file gotten - 6/19/90
HISTORY:	Date	 Version  Person	Modification
		11/23/88 1.00.00  sfbat!chang	initial coding
NOTES:
		Confidential, please do not disclose
**/

#include "sampler_ext.h"

#include "X11/Shell.h"
/**/
#include "Xol/ButtonStac.h"
#include "Xol/BulletinBo.h"
#include "Xol/ControlAre.h"
#include "Xol/Exclusives.h"
#include "Xol/Form.h"
#include "Xol/Nonexclusi.h"
#include "Xol/OblongButt.h"
#include "Xol/StaticText.h"
#include "Xol/FooterPane.h"

static int trapxt_warnings (message)
	char		*message;
{
	if (t_show_warning)
		fprintf (stderr, "X Toolkit Warning: %s\n", message);

	return (1);
}

static int trapxol_warnings (message)
	char		*message;
{
	if (t_show_warning)
		fprintf (stderr, "OPEN LOOK Tkt Warning: %s\n", message);

	return (1);
}

static void init_array ()
{
	t_classes [T_BUTTSTACK] = buttonStackWidgetClass;
	t_classes [T_RECTE] = exclusivesWidgetClass;
	t_classes [T_RECTN] = nonexclusivesWidgetClass;
	t_classes [T_CHKBOXN] = nonexclusivesWidgetClass;
	t_classes [T_OBLONG] = oblongButtonWidgetClass;
	t_classes [T_CTLAREA] = controlAreaWidgetClass;
	t_classes [T_BULLETINBO] = bulletinBoardWidgetClass;

	return;
}

void init (argc, argv, toplevel)
	int		argc;
	char		*argv[];
	Widget		*toplevel;
{
	Display		*dpy;
	Pixmap		icon_pid;
	extern Pixmap	t_iconic();

	XtSetWarningHandler (trapxt_warnings);
	OlSetWarningHandler (trapxol_warnings);

	*toplevel = OlInitialize(
			"SAMPLER",
			"SAMpler",
			NULL,
			0,
			&argc,
			argv
	);

	dpy = XtDisplay(*toplevel);
	icon_pid = t_iconic (dpy);

	T_INIT_ARGS;
	T_SET_ARGS (XtNtitle, "OPEN LOOK(tm) Widgets");
	T_SET_ARGS (XtNiconPixmap, icon_pid);
	T_SET_VALS (*toplevel);

	init_array ();

	/*
	 * Footer Widget:
	 */

	T_INIT_ARGS;
	t_footer_panel = T_CREATE_WIDGET(
				"FooterPanel",
				footerPanelWidgetClass,
				*toplevel
	);

	T_INIT_ARGS;
	t_parent = T_CREATE_WIDGET(
			"Form",
			formWidgetClass,
			t_footer_panel
	);

	sprintf (t_status_buff,
		 "%s\nDebug Flag: %s",
		 T_ST_STRING,
		 t_show_dbg [t_show_warning]
	);
	T_INIT_ARGS;
	T_SET_ARGS (XtNstring, t_status_buff);
	t_status = T_CREATE_WIDGET(
			"Status",
			staticTextWidgetClass,
			t_footer_panel
	);

	return;
}
