/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/**
PROJECT:	The AT&T Xtk Test
NAME:		menu.c
MODULE:
CATEGORY:
SCCS INFO:	ID (release.level.branch.sequence) - 1.2
		Date newest applied delta created  - 6/19/90
		Date this file gotten - 6/19/90
HISTORY:	Date	 Version  Person	Modification
		11/23/88 1.00.00  sfbat!chang	initial coding
		10/17/89 1.00.00  sfbat!chang   use gadgets
NOTES:
		Confidential, please do not disclose
**/

#include "sampler_ext.h"
/**/
#include "Xol/ButtonStac.h"
#include "Xol/Menu.h"
#include "Xol/OblongButt.h"


extern void	generic_callback(),
		undo_callback();

void create_menu (menu)
	Widget	*menu;
{
	Widget	others,
		undo,
		menupane,
		others_ctl;

	int	i;

	/*
	 * Menu:
	 *
	 *	Create menu, which automatically creates a menupane.
	 *	Add controls (buttons, button stacks) to the menu pane.
	 */
	T_INIT_ARGS;
	T_SET_ARGS (XtNtitle, "OPEN LOOK(tm) Widgets");
	T_SET_ARGS (XtNpushpin, True);
	*menu = T_CREATE_POPUP(
			"Menu",
			menuShellWidgetClass,
			t_parent
	);

	T_INIT_ARGS;
	T_SET_ARGS (XtNmenuPane, &menupane);
	T_GET_VALS (*menu);

	command_window (menupane);

  	property_window (menupane);

	scrolled_window (menupane);

	scrolling_list (menupane);

	text_widget (menupane);

#ifdef OL2_0
	keybd_traversal (menupane);
	flat_chkbox (menupane);
#endif

	T_INIT_ARGS;
	T_SET_ARGS (XtNtitle, "Others");
	T_SET_ARGS (XtNpushpin, True);
#ifdef OL2_0
	others = T_CREATE_WIDGET(
			"Others",
			buttonStackGadgetClass,
			menupane
	);
#else
	others = T_CREATE_WIDGET(
			"Others",
			buttonStackWidgetClass,
			menupane
	);
#endif

	T_INIT_ARGS;
	T_SET_ARGS (XtNmenuPane, &others_ctl);
	T_GET_VALS (others);

	T_INIT_ARGS;
	T_SET_ARGS (XtNdefault, True);
#ifdef OL2_0
	undo = T_CREATE_WIDGET(
			"Undo",
			oblongButtonGadgetClass,
			others_ctl
	);
#else
	undo = T_CREATE_WIDGET(
			"Undo",
			oblongButtonWidgetClass,
			others_ctl
	);
#endif
	XtAddCallback (undo, XtNselect, undo_callback, NULL);

	for (i = 0; i < T_BUFS; i++)
	{
		Widget			awids[T_BUFS];

		T_INIT_ARGS;
#ifdef OL2_0
		awids [i] = T_CREATE_WIDGET(
				t_anames[i],
				oblongButtonGadgetClass,
				others_ctl
		);
#else
		awids [i] = T_CREATE_WIDGET(
				t_anames[i],
				oblongButtonWidgetClass,
				others_ctl
		);
#endif
		XtAddCallback (
			awids [i],
			XtNselect,
			generic_callback,
			&t_name_flags[i]
		);
		/*
		 *   create ith widget in Form
		 */
		create_widget (t_parent, i);
	}

	return;
}
