/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/**
PROJECT:	The AT&T Xtk Test
NAME:		pictures.c
MODULE:
CATEGORY:
SCCS INFO:	ID (release.level.branch.sequence) - 1.2
		Date newest applied delta created  - 6/19/90
		Date this file gotten - 6/19/90
HISTORY:	Date	 Version  Person	Modification
		11/23/88 1.00.00  sfbat!chang	initial coding
		10/17/89 1.00.00  sfbat!chang   use gadget
NOTES:
		Confidential, please do not disclose
**/

#include "sampler_ext.h"
/**/
#include "Xol/PopupWindo.h"
#include "Xol/ControlAre.h"
#include "Xol/OblongButt.h"
#include "Xol/Nonexclusi.h"
#include "Xol/RectButton.h"
#include "Xol/StaticText.h"

#ifdef tCOLOR
#define OLTMFG		"Black"
#define OLTMBG		"Green"
#define BARFG		"Black"
#define BARBG		"Grey"
#define TREKFG		"Cyan"
#define TREKBG		"Black"
#define BALLONFG	"Yellow"
#define BALLONBG	"Sky Blue"
#define SCFG		"Red"
#define SCBG		"Black"
#else
#define OLTMFG		"Black"
#define OLTMBG		"White"
#define BARFG		"Black"
#define BARBG		"White"
#define TREKFG		"Black"
#define TREKBG		"White"
#define BALLONFG	"Black"
#define BALLONBG	"White"
#define SCFG		"Black"
#define SCBG		"White"
#endif

extern void	popup_callback (),
		done_callback ();

extern long	t_get_pixel();

extern XImage	*t_oltm(),
		*t_balloon(),
		*t_bars(),
		*t_trek(),
		*t_sc();

static XImage	*oltmPtr,
		*balloonPtr,
		*barPtr,
		*trekPtr,
		*scPtr;

static long	oltmBG, oltmFG,
		balloonBG, balloonFG,
		barBG, barFG,
		trekBG, trekFG,
		scBG, scFG;

static Widget	stext;


static void init_colors (dpy)
	Display			*dpy;
{
	oltmPtr = t_oltm(dpy);
	oltmFG = t_get_pixel(dpy, OLTMFG);
	oltmBG = t_get_pixel(dpy, OLTMBG);

	barPtr = t_bars(dpy);
	barFG = t_get_pixel(dpy, BARFG);
	barBG = t_get_pixel(dpy, BARBG);

	trekPtr = t_trek(dpy);
	trekFG = t_get_pixel(dpy, TREKFG);
	trekBG = t_get_pixel(dpy, TREKBG);

	balloonPtr = t_balloon(dpy);
	balloonFG = t_get_pixel(dpy, BALLONFG);
	balloonBG = t_get_pixel(dpy, BALLONBG);

	scPtr = t_sc(dpy);
	scFG = t_get_pixel(dpy, SCFG);
	scBG = t_get_pixel(dpy, SCBG);

	return;
}

static void rect_call (w, client_data, call_data)
	Widget			w;
	caddr_t			client_data,
				call_data;
{
#define MAX_NOS_IMGS	5
	static int	step	= 0;

	char	buff[80];


	step = (step + 1) % MAX_NOS_IMGS;

	T_INIT_ARGS;

	switch (step + 1) {

	case 1: /* oltm */
		strcpy (buff, "OPEN LOOK (tm)");

		T_SET_ARGS (XtNlabelImage, oltmPtr);
		T_SET_ARGS (XtNforeground, oltmFG);
		T_SET_ARGS (XtNbackground, oltmBG);
		break;

	case 2: /* balloon */
		strcpy (buff, "Balloon");

		T_SET_ARGS (XtNlabelImage, balloonPtr);
		T_SET_ARGS (XtNforeground, balloonFG);
		T_SET_ARGS (XtNbackground, balloonBG);
		break;

	case 3: /* bars */
		strcpy (buff, "Bars");

		T_SET_ARGS (XtNlabelImage, barPtr);
		T_SET_ARGS (XtNforeground, barFG);
		T_SET_ARGS (XtNbackground, barBG);
		break;

	case 4: /* trek */
		strcpy (buff, "Star Trek");

		T_SET_ARGS (XtNlabelImage, trekPtr);
		T_SET_ARGS (XtNforeground, trekFG);
		T_SET_ARGS (XtNbackground, trekBG);
		break;

	case 5: /* sc */
	default:
		strcpy (buff, "by Sam Chang");

		T_SET_ARGS (XtNlabelImage, scPtr);
		T_SET_ARGS (XtNforeground, scFG);
		T_SET_ARGS (XtNbackground, scBG);
		break;
	}
	T_SET_VALS (w);

	T_INIT_ARGS;
	T_SET_ARGS (XtNstring, buff);
	T_SET_VALS (stext);

	return;
#undef MAX_NOS_IMGS
}

void create_pictures (parent)
	Widget		parent;
{
	Widget		ob,
			cmd,
			done_button,
			nonex,
			rect;

	Widget		upper,
			lower,
			footer;


	init_colors (XtDisplay(parent));

	T_INIT_ARGS;
	T_SET_ARGS (XtNdefault, True);
	T_SET_ARGS (XtNlabelType, OL_POPUP);
	ob = T_CREATE_WIDGET(
		"Pictures",
		oblongButtonWidgetClass,
		parent
	);

	T_INIT_ARGS;
	T_SET_ARGS (XtNtitle, "Pictures");
	cmd = T_CREATE_POPUP(
		"CmdWin",
		popupWindowShellWidgetClass,
		parent
	);
	XtAddCallback (ob, XtNselect, popup_callback, cmd);

	T_INIT_ARGS;
	T_SET_ARGS (XtNupperControlArea, &upper);
	T_SET_ARGS (XtNlowerControlArea, &lower);
	T_SET_ARGS (XtNfooterPanel, &footer);
	T_GET_VALS (cmd);

	T_INIT_ARGS;
	T_SET_ARGS (XtNborderWidth, 0);
	T_SET_VALS (upper);
	T_SET_VALS (lower);

	T_INIT_ARGS;
	nonex = T_CREATE_WIDGET(
		"NonEx",
		nonexclusivesWidgetClass,
		upper
	);

	T_INIT_ARGS;
	T_SET_ARGS (XtNlabelImage, oltmPtr);
	T_SET_ARGS (XtNforeground, oltmFG);
	T_SET_ARGS (XtNbackground, oltmBG);
	T_SET_ARGS (XtNlabelType, OL_IMAGE);
	T_SET_ARGS (XtNwidth, 96);
	T_SET_ARGS (XtNheight, 64);
	T_SET_ARGS (XtNrecomputeSize, False);
	rect = T_CREATE_WIDGET(
		"Rect",
		rectButtonWidgetClass,
		nonex
		);
	XtAddCallback (rect, XtNselect, rect_call, NULL);
	XtAddCallback (rect, XtNunselect, rect_call, NULL);

	T_INIT_ARGS;
	done_button = T_CREATE_WIDGET(
			"Done",
			oblongButtonWidgetClass,
			lower
		);
	XtAddCallback (done_button, XtNselect, done_callback, NULL);

	T_INIT_ARGS;
	T_SET_ARGS (XtNstring, "OPEN LOOK(tm)");
	stext = T_CREATE_WIDGET(
		"Stext",
		staticTextWidgetClass,
		footer
	);

	XtRealizeWidget (cmd);

	return;
}
