/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/**
PROJECT:	The AT&T Xtk Test
NAME:		property.c
MODULE:
CATEGORY:
SCCS INFO:	ID (release.level.branch.sequence) - 1.2
		Date newest applied delta created  - 6/19/90
		Date this file gotten - 6/19/90
HISTORY:	Date	 Version  Person	Modification
		11/23/88 1.00.00  sfbat!chang	initial coding
		10/17/89 1.00.00  sfbat!chang   use flat (non)exclusuves
						use gadget
NOTES:
		Confidential, please do not disclose
		1. Lloyd provides the callback's functionality
**/

#include "sampler_ext.h"
/**/
#include "Xol/OblongButt.h"
#include "Xol/PopupWindo.h"
#include "Xol/Caption.h"
#ifdef OL2_0
#include "Xol/FExclusive.h"
#include "Xol/FNonexclus.h"
#else
#include "Xol/Exclusives.h"
#include "Xol/Nonexclusi.h"
#include "Xol/RectButton.h"
#endif
#include "Xol/StaticText.h"

#ifdef tOLFONT
#define BOLD	"Bold"
#define ITALIC	"Italic"
#else
#define BOLD	"Fixed"
#define ITALIC	"Fixed"
#endif

#ifdef tCOLOR
#define BLACK	"Black"
#define RED	"Red"
#define CYAN	"Cyan"
#define GREEN	"Green"
#else
#define BLACK	"Black"
#define RED	"Black"
#define CYAN	"Black"
#define GREEN	"Black"
#endif


extern void		popup_callback ();
extern XFontStruct	*t_getfont ();
extern long		t_get_pixel();

static int		style_flag = 0,
			save_style_flag = 0,
			color_index = 0,
			save_color_index = 0;

static char		color_flag[10] = {
				'B', 'l', 'a', 'c', 'k', '\0'
			},
			save_color_flag[10] = {
				'B', 'l', 'a', 'c', 'k', '\0'
			};

static Widget		stext;

static Display		*dpy;


static void		do_stext_add(),
			apply_properties();

static void		apply_choices(),
			reset_choices(),
			set_color(),
			set_style(),
			unset_style();

static XtCallbackRec	apply_func [] = {
				{ apply_choices, NULL },
				{ NULL, NULL },
};

static XtCallbackRec	reset_func [] = {
				{ reset_choices, NULL },
				{ NULL, NULL },
};

#ifdef OL2_0
static	String		color_exc_fields [] = {
		XtNlabel, XtNfontColor, XtNselectProc, XtNclientData, XtNset,
};
static	XtArgVal	color_exc_items [20] = {
	(XtArgVal) BLACK, (XtArgVal) 0, (XtArgVal) set_color, (XtArgVal) 0,
		(XtArgVal) True,
	(XtArgVal) RED,   (XtArgVal) 0, (XtArgVal) set_color, (XtArgVal) 5,
		(XtArgVal) False,
	(XtArgVal) CYAN,  (XtArgVal) 0, (XtArgVal) set_color, (XtArgVal) 10,
		(XtArgVal) False,
	(XtArgVal) GREEN, (XtArgVal) 0, (XtArgVal) set_color, (XtArgVal) 15,
		(XtArgVal) False,
};
static	String		style_exc_fields [] = {
		XtNlabel, XtNselectProc, XtNunselectProc,
		XtNclientData, XtNset,
};
static	XtArgVal	style_exc_items [10] = {
	(XtArgVal) BOLD,  (XtArgVal) set_style, (XtArgVal) unset_style,
		(XtArgVal) 0, (XtArgVal) False,
	(XtArgVal) ITALIC,(XtArgVal) set_style,(XtArgVal) unset_style,
		(XtArgVal) 5, (XtArgVal) False,
};
static  Widget flat_ex, flat_nex;
#else
static Widget		colors[4],
			styles[2];
#endif

void property_window (menupane)
	Widget		menupane;
{
	Widget		prp,
			parent,
			c1,
			ex,
			c2,
			nex;

	Widget		p_ctl,
			p_footer;

	long		pixVal;
	int		i;


	T_INIT_ARGS;
	T_SET_ARGS (XtNlabelType, OL_POPUP);
#ifdef OL2_0
        parent = T_CREATE_WIDGET(
                	"Property Window",
                	oblongButtonGadgetClass,
                	menupane
        );
#else
        parent = T_CREATE_WIDGET(
                	"Property Window",
                	oblongButtonWidgetClass,
                	menupane
        );
#endif

	dpy = XtDisplay (parent);

	T_INIT_ARGS;
	T_SET_ARGS (XtNtitle, "Properties");
	T_SET_ARGS (XtNapply, apply_func);
	T_SET_ARGS (XtNreset, reset_func);
	prp = T_CREATE_POPUP(
			"PrpWin",
			popupWindowShellWidgetClass,
			menupane
	);
	XtAddCallback (parent, XtNselect, popup_callback, prp);

	T_INIT_ARGS;
	T_SET_ARGS (XtNupperControlArea, &p_ctl);
	T_SET_ARGS (XtNfooterPanel, &p_footer);
	T_GET_VALS (prp);

	T_INIT_ARGS;
	T_SET_ARGS (XtNborderWidth, 0);
	T_SET_ARGS (XtNlabel, "Color:");
	c1 = T_CREATE_WIDGET(
			"C1",
			captionWidgetClass,
			p_ctl
	);
#ifdef OL2_0
{
	int	i;

	for (i = 1; i < 20; i+=5 )
		color_exc_items [i] = (XtArgVal)t_get_pixel(
						XtDisplay(c1),
						color_exc_items[i-1]);

	T_INIT_ARGS;
	T_SET_ARGS (XtNitems, color_exc_items);
	T_SET_ARGS (XtNnumItems, 4);
	T_SET_ARGS (XtNitemFields, color_exc_fields);
	T_SET_ARGS (XtNnumItemFields, 5);
	T_SET_ARGS (XtNlayoutType, OL_FIXEDROWS);
	flat_ex = T_CREATE_WIDGET(
			"FExcl",
			flatExclusivesWidgetClass,
			c1
	);
}
#else
	T_INIT_ARGS;
	T_SET_ARGS (XtNlayoutType, OL_FIXEDROWS);
	ex = T_CREATE_WIDGET(
			"Excl",
			exclusivesWidgetClass,
			c1
	);

	i = 0;

	pixVal = t_get_pixel(XtDisplay(ex), BLACK);
	T_INIT_ARGS;
	T_SET_ARGS (XtNforeground, pixVal);
	colors[i] = T_CREATE_WIDGET(
			BLACK,
			rectButtonWidgetClass,
			ex
	);
	XtAddCallback (colors[i], XtNselect, set_color, i);
	i++;

	pixVal = t_get_pixel(XtDisplay(ex), RED);
	T_INIT_ARGS;
	T_SET_ARGS (XtNforeground, pixVal);
	colors[i] = T_CREATE_WIDGET(
			RED,
			rectButtonWidgetClass,
			ex
	);
	XtAddCallback (colors[i], XtNselect, set_color, i);
	i++;

	pixVal = t_get_pixel(XtDisplay(ex), CYAN);
	T_INIT_ARGS;
	T_SET_ARGS (XtNforeground, pixVal);
	colors[i] = T_CREATE_WIDGET(
			CYAN,
			rectButtonWidgetClass,
			ex
	);
	XtAddCallback (colors[i], XtNselect, set_color, i);
	i++;

	pixVal = t_get_pixel(XtDisplay(ex), GREEN);
	T_INIT_ARGS;
	T_SET_ARGS (XtNforeground, pixVal);
	colors[i] = T_CREATE_WIDGET(
			GREEN,
			rectButtonWidgetClass,
			ex
	);
	XtAddCallback (colors[i], XtNselect, set_color, i); 
#endif

	T_INIT_ARGS;
	T_SET_ARGS (XtNborderWidth, 0);
	T_SET_ARGS (XtNlabel, "Style:");
	c2 = T_CREATE_WIDGET(
			"C2",
			captionWidgetClass,
			p_ctl
	);
#ifdef OL2_0
{
	T_INIT_ARGS;
	T_SET_ARGS (XtNitems, style_exc_items);
	T_SET_ARGS (XtNnumItems, 2);
	T_SET_ARGS (XtNitemFields, style_exc_fields);
	T_SET_ARGS (XtNnumItemFields, 5);
	T_SET_ARGS (XtNlayoutType, OL_FIXEDROWS);
	flat_nex = T_CREATE_WIDGET(
			"FNonExcl",
			flatNonexclusivesWidgetClass,
			c2
	);
}
#else
	T_INIT_ARGS;
	T_SET_ARGS (XtNlayoutType, OL_FIXEDROWS);
	nex = T_CREATE_WIDGET(
			"NonExcl",
			nonexclusivesWidgetClass,
			c2
	);

	i = 0;

	T_INIT_ARGS;
	styles[i] = T_CREATE_WIDGET(
			BOLD,
			rectButtonWidgetClass, 
			nex
	);
	XtAddCallback (styles[i], XtNselect, set_style, i);
	XtAddCallback (styles[i], XtNunselect, unset_style, NULL);
	i++;

	T_INIT_ARGS;
	styles[i] = T_CREATE_WIDGET(
			ITALIC,
			rectButtonWidgetClass, 
			nex
	);
	XtAddCallback (styles[i], XtNselect, set_style, NULL);
	XtAddCallback (styles[i], XtNunselect, unset_style, NULL);
#endif

	T_INIT_ARGS;
	T_SET_ARGS (XtNstring, "Here is the result");
	stext = T_CREATE_WIDGET(
			"S3",
			staticTextWidgetClass,
			p_footer
	);

	do_stext_add ();

	XtRealizeWidget (prp);

	return;
}

static char	*label;

static Arg	to_get [] = {
			{ XtNlabel,	(XtArgVal) &label },
};

static char	*font_names [] = {
#ifdef tOLFONT
			"b12lucid",
			"a12bluci",
			"a12iluci",
			"a12biluc",
#else
			"fixed",
			"fixed",
			"fixed",
			"fixed",
#endif
};

static void do_stext_add ()
{
	XFontStruct		*fontPtr;
	long			pixVal;

	fontPtr = t_getfont(dpy, font_names[style_flag]);
	pixVal = t_get_pixel(dpy, color_flag);

	T_INIT_ARGS;
	T_SET_ARGS (XtNfont, fontPtr);
	T_SET_ARGS (XtNfontColor, pixVal);
	T_SET_VALS (stext);
}

static void set_color (w, client_data, call_data)
	Widget		w;
	int		client_data;
	caddr_t		call_data;
{
	char		*label;

	color_index = client_data;
#ifdef OL2_0
	label = (char *) color_exc_items [color_index];
#else
	T_INIT_ARGS;
	T_SET_ARGS (XtNlabel, &label);
	T_GET_VALS (w);
#endif
	strcpy (color_flag, label);
	do_stext_add ();

	return;
}

static void set_style (w, client_data, call_data)
	Widget		w;
	int		client_data;
	caddr_t		call_data;
{
	char		*label;

#ifdef OL2_0
	label = (char *) style_exc_items [client_data];
#else
	T_INIT_ARGS;
	T_SET_ARGS (XtNlabel, &label);
	T_GET_VALS (w);
#endif
	if (strcmp(BOLD, label) == 0)
		style_flag |= 01;
	else	/* must be ITALIC */
		style_flag |= 02;

	do_stext_add ();

	return;
}

static void unset_style (w, client_data, call_data)
	Widget		w;
	int		client_data;
	caddr_t		call_data;
{
	char		*label;
#ifdef OL2_0
	label = (char *) style_exc_items [client_data];
#else
	T_INIT_ARGS;
	T_SET_ARGS (XtNlabel, &label);
	T_GET_VALS (w);
#endif
	if (strcmp(BOLD, label) == 0)
		style_flag &= ~01;
	else	/* must be ITALIC */
		style_flag &= ~02;

	do_stext_add ();

	return;
}

static void apply_choices (w, client_data, call_data)
	Widget			w;
	caddr_t			client_data,
				call_data;
{
	save_color_index = color_index;
	strcpy (save_color_flag, color_flag);
	save_style_flag = style_flag;

	apply_properties ();

	return;
}

static void reset_choices (w, client_data, call_data)
	Widget			w;
	caddr_t			client_data,
				call_data;
{
	int			i, the_sub_object;

	Arg			set[1],
				unset[1];

	XtSetArg (set[0], XtNset, TRUE);
	XtSetArg (unset[0], XtNset, FALSE);

	strcpy (color_flag, save_color_flag);
	color_index = save_color_index; 
	style_flag = save_style_flag; 

#ifdef OL2_0
	the_sub_object = color_index / 4;

	for (i = 0; i < 4; i++)
		if (i == the_sub_object)
			OlFlatSetValues (flat_ex, i, set, 1);
		else
			OlFlatSetValues (flat_ex, i, unset, 1);

	switch (style_flag)
	{
		case 0:
			OlFlatSetValues (flat_nex, 0, unset, 1);
			OlFlatSetValues (flat_nex, 1, unset, 1);
			break;
		case 1:
			OlFlatSetValues (flat_nex, 0, set, 1);
			OlFlatSetValues (flat_nex, 1, unset, 1);
			break;
		case 2:
			OlFlatSetValues (flat_nex, 0, unset, 1);
			OlFlatSetValues (flat_nex, 1, set, 1);
			break;
		case 3:
			OlFlatSetValues (flat_nex, 0, set, 1);
			OlFlatSetValues (flat_nex, 1, set, 1);
			break;
	}
	OlFlatSetValues (flat_nex, 1, NULL, 0);
#else
/*
	strcpy (color_flag, save_color_flag);
	color_index = save_color_index; 
	style_flag = save_style_flag; 
*/
	XtSetValues (colors[color_index], set, 1);
	for (i = 0; i < 4; i++)
		if (i != color_index)
			XtSetValues (colors[i], unset, 1);

	switch (style_flag) {

	case 0: 
		XtSetValues (styles [0], unset, 1);
		XtSetValues (styles [1], unset, 1);
		break;

	case 1: 
		XtSetValues (styles [0], set, 1);
		XtSetValues (styles [1], unset, 1);
		break;

	case 2: 
		XtSetValues (styles [0], unset, 1);
		XtSetValues (styles [1], set, 1);
		break;

	case 3: 
		XtSetValues (styles [0], set, 1);
		XtSetValues (styles [1], set, 1);
		break;

	}
#endif

	do_stext_add ();

	return;
}

static void apply_properties ()
{
	XFontStruct *fontPtr;
	long	pixVal;

	fontPtr = t_getfont(dpy, font_names[style_flag]);
	pixVal = t_get_pixel(dpy, color_flag);

	T_INIT_ARGS;
	T_SET_ARGS (XtNfont, fontPtr);
	T_SET_ARGS (XtNfontColor, pixVal);
	T_SET_VALS (t_prp_chg_wids[T_STATIC_TEXT]);

	return;
}
