/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/**
PROJECT:	The AT&T Xtk Test
NAME:		quit.c
MODULE:
CATEGORY:
SCCS INFO:	ID (release.level.branch.sequence) - 1.2
		Date newest applied delta created  - 6/19/90
		Date this file gotten - 6/19/90
HISTORY:	Date	 Version  Person	Modification
		11/23/88 1.00.00  sfbat!chang	initial coding
		10/17/89 1.00.00  sfbat!chang   use gadget
NOTES:
		Confidential, please do not disclose
**/

#include "sampler_ext.h"
/**/
#include "Xol/AbbrevStac.h"
#include "Xol/ControlAre.h"
#include "Xol/OblongButt.h"
#include "Xol/Notice.h"
#include "Xol/StaticText.h"


extern void	popup_callback();

static void exit_sampler (w, shell, call_data)
	Widget			w,
				*shell;
	caddr_t			call_data;
{
	exit (0);
}

static void attach_notice (parent, r_parent)
	Widget		parent, r_parent;
{
	Widget		ok,
			cancel,
			ctl_area;

	static Widget	notice;


	T_INIT_ARGS;
	T_SET_ARGS (XtNstring, "Do you want to exit ?");
	notice = T_CREATE_POPUP(
			"Notice",
			noticeShellWidgetClass,
			r_parent
		);
	XtAddCallback (parent, XtNselect, popup_callback, notice);

	T_INIT_ARGS;
	T_SET_ARGS (XtNcontrolArea, &ctl_area);
	T_GET_VALS (notice);

	T_INIT_ARGS;
#ifdef OL2_0
	ok = T_CREATE_WIDGET(
			"Yes",
			oblongButtonGadgetClass,
			ctl_area
	);
#else
	ok = T_CREATE_WIDGET(
			"Yes",
			oblongButtonWidgetClass,
			ctl_area
	);
#endif

	T_INIT_ARGS;
	T_SET_ARGS (XtNdefault, True);
#ifdef OL2_0
	cancel = T_CREATE_WIDGET(
			"No",
			oblongButtonGadgetClass,
			ctl_area
	);
#else
	cancel = T_CREATE_WIDGET(
			"No",
			oblongButtonWidgetClass,
			ctl_area
	);
#endif
	XtAddCallback (ok, XtNselect, exit_sampler, &notice);

	XtRealizeWidget (notice);

	return;
}

void create_quit_button ()
{
	Widget		parent_quit,
			abb_quit,
			stext_quit,
			ob_quit,
			abb_mp;

	T_INIT_ARGS;
	T_SET_ARGS (XtNborderWidth, 0);
	T_SET_ARGS (XtNxRefName, "Form");
	T_SET_ARGS (XtNyRefName, "Form");
	T_SET_ARGS (XtNyOffset, 5);
	T_SET_ARGS (XtNx, 5);
	parent_quit = T_CREATE_WIDGET(
			"Quit",
			controlAreaWidgetClass,
			t_parent
		);

	T_INIT_ARGS;
	abb_quit = T_CREATE_WIDGET(
			"AbbQuit",
			abbrevStackWidgetClass,
			parent_quit
	);

	T_INIT_ARGS;
	T_SET_ARGS (XtNborderWidth, 0);
	T_SET_ARGS (XtNstring, "Show Quit Button Here");
	stext_quit = T_CREATE_WIDGET(
			"StextQuit",
			staticTextWidgetClass,
			parent_quit
		);

	T_INIT_ARGS;
	T_SET_ARGS (XtNmenuPane, &abb_mp);
	T_GET_VALS (abb_quit);

	T_INIT_ARGS;
	ob_quit = T_CREATE_WIDGET(
			"Quit",
			oblongButtonWidgetClass,
			abb_mp
	);

	T_INIT_ARGS;
	T_SET_ARGS (XtNpreviewWidget, stext_quit);
	T_SET_VALS (abb_quit);

/* use stext_quit as the parent of the notice box.
   to use ob_quit as the parent of the notice box will fall into
   an infinite loop when SELECT on an abbreviate button
*/
	attach_notice (ob_quit, abb_quit);

	return;
}
