/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/**
PROJECT:	The AT&T Xtk Test
NAME:		widgets.c
MODULE:
CATEGORY:
SCCS INFO:	ID (release.level.branch.sequence) - 1.2
		Date newest applied delta created  - 6/19/90
		Date this file gotten - 6/19/90
HISTORY:	Date	 Version  Person	Modification
		11/23/88 1.00.00  sfbat!chang	initial coding
NOTES:
		Confidential, please do not disclose
**/

#include "sampler_ext.h"
/**/
#include "Xol/Form.h"
#include "Xol/RectButton.h"
#include "Xol/Caption.h"
#include "Xol/OblongButt.h"
#include "Xol/TextField.h"
#include "Xol/CheckBox.h"
#include "Xol/ControlAre.h"

#ifdef tCOLOR
#define RED	"red"
#else
#define RED	"black"
#endif

extern long	t_get_pixel();

extern XImage	*t_star(),
		*t_brick(),
		*t_note(),
		*t_pen();

static XImage	*starPtr = NULL,
		*brickPtr = NULL,
		*notePtr = NULL,
		*penPtr = NULL;

static void yes_no_toggle (w, client_data, call_data)
	Widget			w;
	caddr_t			client_data,
				call_data;
{
	t_show_warning = !t_show_warning;
	sprintf (t_status_buff,
		 "%s\nDebug Flag: %s",
		 T_ST_STRING,
		 t_show_dbg [t_show_warning]
	);
	T_INIT_ARGS;
	T_SET_ARGS (XtNstring, t_status_buff);
	T_SET_VALS (t_status);

/*
	if (t_show_warning)
		fprintf (stderr,
			 "yes_no_toggle: t_show_warning: %d\n",
			 t_show_warning);
*/

	return;
}

static void X_No_toggle (w, client_data, call_data)
	Widget		w;
	caddr_t		client_data,
			call_data;
{
	static int	is_image = 1;

	T_INIT_ARGS;
	if (is_image)
	{
		T_SET_ARGS (XtNlabel, "X");
	}
	else
	{
		T_SET_ARGS (XtNlabel, "No");
	}

	T_SET_VALS (w);

	is_image = !is_image;

	return;
}

static void Yes_O_toggle (w, client_data, call_data)
	Widget		w;
	caddr_t		client_data,
			call_data;
{
	static int	is_image = 1;

	T_INIT_ARGS;
	if (is_image)
	{
		T_SET_ARGS (XtNlabel, "O");
	}
	else
	{
		T_SET_ARGS (XtNlabel, "Yes");
	}

	T_SET_VALS (w);

	is_image = !is_image;

	return;
}

static void pen_img_toggle (w, client_data, call_data)
	Widget		w;
	caddr_t		client_data,
			call_data;
{
	static int	is_image = 1;

	T_INIT_ARGS;
	if (is_image)
	{
		T_SET_ARGS (XtNlabel, "Pen");
		T_SET_ARGS (XtNlabelType, OL_STRING);
	}
	else
	{
		T_SET_ARGS (XtNlabelImage, penPtr);
		T_SET_ARGS (XtNlabelType, OL_IMAGE);
	}
	T_SET_VALS (w);

	is_image = !is_image;

	return;
}

static void pad_img_toggle (w, client_data, call_data)
	Widget		w;
	caddr_t		client_data,
			call_data;
{
	static int	is_image = 1;

	T_INIT_ARGS;
	if (is_image)
	{
		T_SET_ARGS (XtNlabel, "Pad");
		T_SET_ARGS (XtNlabelType, OL_STRING);
	}
	else
	{
		T_SET_ARGS (XtNlabelImage, notePtr);
		T_SET_ARGS (XtNlabelType, OL_IMAGE);
	}
	T_SET_VALS (w);

	is_image = !is_image;

	return;
}

static void star_img_toggle (w, client_data, call_data)
	Widget		w;
	caddr_t		client_data,
			call_data;
{
	static Arg	str_args [] = {
				{ XtNlabelImage,	(XtArgVal) NULL },
				{ XtNlabel,		(XtArgVal) "Star" },
				{ XtNlabelType,		(XtArgVal) OL_STRING },
				{ XtNrecomputeSize,	(XtArgVal) FALSE },
	};
	static Arg	img_args [] = {
				{ XtNlabelImage,	(XtArgVal) NULL },
/* set this will cause core dump on sun
				{ XtNlabel,		(XtArgVal) NULL },
*/
				{ XtNlabelType,		(XtArgVal) OL_IMAGE },
	};
	static int	is_image = 1;


	T_INIT_ARGS;
	if (is_image)
	{
		T_SET_ARGS (XtNlabel, "Star");
		T_SET_ARGS (XtNlabelType, OL_STRING);
		T_SET_ARGS (XtNrecomputeSize, False);
	}
	else
	{
		T_SET_ARGS (XtNlabelImage, starPtr);
		T_SET_ARGS (XtNlabelType, OL_IMAGE);
	}
	T_SET_VALS (w);

	is_image = !is_image;

	return;
}

static void brick_img_toggle (w, client_data, call_data)
	Widget		w;
	caddr_t		client_data,
			call_data;
{
	static int	is_image = 1;

	T_INIT_ARGS;
	if (is_image)
	{
		T_SET_ARGS (XtNlabel, "Brick");
		T_SET_ARGS (XtNlabelType, OL_STRING);
	}
	else
	{
		T_SET_ARGS (XtNlabelImage, brickPtr);
		T_SET_ARGS (XtNlabelType, OL_IMAGE);
	}
	T_SET_VALS (w);

	is_image = !is_image;

	return;
}

void create_widget (parent, flag)
	Widget		parent;
	int		flag;
{
	Widget		t1,
			t2;

	Display		*dpy;

	dpy = XtDisplay (parent);

	if (brickPtr == NULL)
		brickPtr = t_brick (dpy, 16, 16);

	if (starPtr == NULL)
		starPtr = t_star (dpy);

	if (notePtr == NULL)
		notePtr = t_note (dpy);

	if (penPtr == NULL)
		penPtr = t_pen (dpy);

	if (t_wids[flag] == NULL)
	{

		T_INIT_ARGS;
		t_wids[flag] = T_CREATE_WIDGET(
					t_names[flag],
					t_classes[flag],
					parent
		);

		T_INIT_ARGS;
		T_SET_ARGS (XtNxRefWidget, t_refs [t_refs_idx]);
		T_SET_ARGS (XtNyRefWidget, t_refs [t_refs_idx]);
		T_SET_ARGS (XtNyAddHeight, True);

		if (flag != T_OBLONG)
		{
			T_SET_ARGS (XtNyOffset, 5);
		}
		else
		{
#ifndef OL2_0
			T_SET_ARGS (XtNyOffset, -18);
#else
			T_SET_ARGS (XtNyOffset, -12);
#endif
		}
		T_SET_VALS (t_wids [flag]);

		t_refs [++t_refs_idx] = t_wids [flag];

		switch (flag) {
		case T_OBLONG:
		{
			long	pixVal;

			pixVal = t_get_pixel (dpy, RED);

			T_INIT_ARGS;
			T_SET_ARGS (XtNforeground, pixVal);
			T_SET_ARGS (XtNlabelImage, brickPtr);
			T_SET_ARGS (XtNlabelType, OL_IMAGE);
			T_SET_ARGS (XtNlabelTile, True);
			T_SET_ARGS (XtNwidth, 160);
			T_SET_ARGS (XtNheight, 48);
			T_SET_ARGS (XtNrecomputeSize,False);
			T_SET_VALS (t_wids [flag]);

			XtAddCallback(
				t_wids [flag],
				XtNselect,
				brick_img_toggle,
				NULL
			);
			break;
		}
		case T_BUTTSTACK:
		{
			Widget		bs_ctl;

			T_INIT_ARGS;
			T_SET_ARGS (XtNmenuPane, &bs_ctl);
			T_GET_VALS (t_wids [flag]);

			create_pictures (bs_ctl);
			break;
		}
		case T_RECTE:
			T_INIT_ARGS;
			T_SET_ARGS (XtNlayoutType, OL_FIXEDROWS);
			T_SET_VALS (t_wids [flag]);

			T_INIT_ARGS;
			t1 = T_CREATE_WIDGET(
					"Yes",
					rectButtonWidgetClass,
					t_wids[flag]
			);
			t2 = T_CREATE_WIDGET(
					"No",
					rectButtonWidgetClass,
					t_wids[flag]
			);
			XtAddCallback (t1, XtNselect, Yes_O_toggle, NULL);
			XtAddCallback (t2, XtNselect, X_No_toggle, NULL);
			break;
		case T_RECTN:
		{
			T_INIT_ARGS;
			T_SET_ARGS (XtNlayoutType, OL_FIXEDROWS);
			T_SET_VALS (t_wids [flag]);

			T_INIT_ARGS;
			T_SET_ARGS (XtNlabelImage, penPtr);
			T_SET_ARGS (XtNlabelType, OL_IMAGE);
			T_SET_ARGS (XtNwidth, 48);
			T_SET_ARGS (XtNheight, 36);
			T_SET_ARGS (XtNrecomputeSize, False);
			t1 = T_CREATE_WIDGET(
					"Nrect1",
					rectButtonWidgetClass,
					t_wids[flag]
			);
			T_INIT_ARGS;
			T_SET_ARGS (XtNlabelImage, notePtr);
			T_SET_ARGS (XtNlabelType, OL_IMAGE);
			T_SET_ARGS (XtNwidth, 48);
			T_SET_ARGS (XtNheight, 36);
			T_SET_ARGS (XtNrecomputeSize, False);
			t2 = T_CREATE_WIDGET(
					"Nrect2",
					rectButtonWidgetClass,
					t_wids[flag]
			);
			XtAddCallback (t1, XtNselect, pen_img_toggle, NULL);
			XtAddCallback (t1, XtNunselect, pen_img_toggle, NULL);
			XtAddCallback (t2, XtNselect, pad_img_toggle, NULL);
			XtAddCallback (t2, XtNunselect, pad_img_toggle, NULL);
			break;
		}
		case T_CHKBOXN:
			T_INIT_ARGS;
			t1 = T_CREATE_WIDGET (
					t_names[flag],
					checkBoxWidgetClass,
					t_wids[flag]
			);
			XtAddCallback (t1, XtNselect, yes_no_toggle, NULL);
			XtAddCallback (t1, XtNunselect, yes_no_toggle, NULL);
			break;
		case T_CTLAREA:
			T_INIT_ARGS;
			T_SET_ARGS (XtNborderWidth, 0);
			T_SET_VALS(t_wids [flag]);

			T_INIT_ARGS;
			T_SET_ARGS (XtNborderWidth, 0);
			T_SET_ARGS (XtNlabel, "Caption in ControlArea");
			t1 = T_CREATE_WIDGET(
				t_names[flag],
				captionWidgetClass,
				t_wids[flag]
			);

			T_INIT_ARGS;
			T_SET_ARGS (XtNlabelImage, starPtr);
			T_SET_ARGS (XtNlabelType, OL_IMAGE);
			t2 = T_CREATE_WIDGET(
				"Oblong in Caption",
				oblongButtonWidgetClass,
				t1
			);

			XtAddCallback (t2, XtNselect, star_img_toggle, NULL);
			break;
		case T_BULLETINBO:
		{
			static char	buff[81];

			T_INIT_ARGS;
			T_SET_ARGS (XtNborderWidth, 0);
			T_SET_VALS (t_wids [flag]);

			T_INIT_ARGS;
			T_SET_ARGS (XtNborderWidth, 0);
			T_SET_ARGS (XtNlabel, "Caption in BulletinBoard:");
			T_SET_ARGS (XtNx, 5);
			t1 = T_CREATE_WIDGET(
				t_names[flag],
				captionWidgetClass,
				t_wids[flag]
			);

			strcpy (buff, "The Sampler Program");
			T_INIT_ARGS;
			T_SET_ARGS (XtNstring, buff);
			T_SET_ARGS (XtNborderWidth, 0);
			T_SET_ARGS (XtNwidth, 120);
			t2 = T_CREATE_WIDGET(
				t_names[flag],
				textFieldWidgetClass,
				t1
			);
			break;
		}
		default:
			break;
		}
	}

	return;
}
