 /*
 * sausage.c - 
 * Demonstration of smooth(er) animation of postscript using offscreen buffers
 * - Henry Krempel Sun DAE ISV Engineering <krempel@sun.com>
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <xvps/pscanvas.h>
#include "sausage_ui.h"
#include "Hello.h"

#ifdef MAIN

/*
 * Instance XV_KEY_DATA key.  An instance is a set of related
 * user interface objects.  A pointer to an object's instance
 * is stored under this key in every object.  This must be a
 * global variable.
 */
Attr_attribute	INSTANCE;
void drawline();
	sausage_window1_objects	*sausage_window1;

extern Display *xv_default_display;

void
main(argc, argv)
	int		argc;
	char		**argv;
{
  Xv_Window NeWSwin;
  int xid;

  /*
   * Initialize XView.
   */
  xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, 0);
  INSTANCE = xv_unique_key();

  /*
   * Initialize user interface components.
   */
  sausage_window1 = sausage_window1_objects_initialize(NULL, NULL);

  /* give the slider an initial value */
  xv_set(sausage_window1->slider1, PANEL_VALUE, 4,
	 PANEL_NOTIFY_LEVEL, PANEL_ALL, 0);

  /* Initial setup,  place the canvas where NeWS can get at it */
  PS_name_token("NeWScan",(NeWStoken) xv_get(sausage_window1->canvas1,
					     PSCANVAS_NEWSTOKEN));
  Define_Sausage_Handler();
  /*
   * Turn control over to XView.
   */
  xv_main_loop(sausage_window1->window1);
  exit(0);
}

#endif

/*
 * Event callback function for `canvas1'.
 */
Notify_value
handle_X_events(win, event, arg, type)
	Xv_Window	win;
	Event		*event;
	Notify_arg	arg;
	Notify_event_type type;
{
  sausage_window1_objects	*ip =
    (sausage_window1_objects *) xv_get(win, XV_KEY_DATA, INSTANCE);
  switch (event_action(event)) {
    
  case ACTION_SELECT:
  case ACTION_ADJUST:
    ps_setcanvas(xv_get(ip->canvas1, PSCANVAS_NEWSTOKEN));
  case LOC_DRAG:
    drawline(event_x(event) / 4 );
    break;
  default:
    break;
  }
  return notify_next_event_func(win, event, arg, type);
}

static lastwidth=0;
void drawline(width)
     int width;
{
  if ( width > lastwidth ) DrawLargerLine(width);
  else DrawSmallerLine(width);
  lastwidth=width;
  ps_flush_PostScript();
}
/*
 * Repaint callback function for `canvas1'.
 */
void
mypaint(canvas, NeWSwin, display, xid, rects)
	PScanvas		canvas;
        NeWStoken	NeWSwin;
	Display		*display;
	Window		xid;
	Xv_xrectlist	*rects;
{
  PS_PostScript(" clippath pathbbox rectpath RenderCan reshapecanvas");
  PS_fillcanvas("white");
  drawline(xv_get(sausage_window1->slider1, PANEL_VALUE, 0));
  ps_flush_PostScript();


}

/*
 * Notify callback function for `slider1'.
 */
void
slider_handler(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
  char error[500]; int flag;
  sausage_window1_objects	*ip =
	  (sausage_window1_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
  ps_setcanvas( (NeWStoken) xv_get(ip->canvas1, PSCANVAS_NEWSTOKEN));
  if (value != lastwidth) drawline(value);
}
