/*
 *
 * simple.c -- a short example using the XView/NeWS library
 * 
 * A PSCANVAS is created, then NeWS PostScript rendering 
 * is used to displaythe word "NeWS" at an angle. 
 * The text remains centered when the window is resized.
 *
 */
#include <xview/xview.h>
#include <xvps/pscanvas.h>
#include "simple.h"
Frame frame;
void pscanvas_repaint_proc(pscanvas, newstoken, dpy, xid, xrects)
     PScanvas	pscanvas;
     NeWStoken	newstoken;
     Display	*dpy;
     Window	xid;
     Xv_xrectlist *xrects;
{
  xv_set(pscanvas, PSCANVAS_CLIPRECTS, xrects, NULL);
  pscanvas_flip();
  simple_setup();
  ps_findfont("Bembo-Bold");
  ps_scalefont(97);
  ps_setfont();
  ps_show("NeWS");
}
main(argc, argv)
	int             argc;
	char          **argv;
{
  xv_init(XV_INIT_ARGS, argc, argv, 0);
  frame=xv_create(NULL, FRAME,
		  FRAME_LABEL, "Simple XView/NeWS Library Example",
		  NULL);
  xv_create(frame, PSCANVAS,
	    PSCANVAS_REPAINT_PROC, pscanvas_repaint_proc,
	    PSCANVAS_SYNC, 5, NULL);
  window_fit(frame);
  xv_main_loop(frame);
}
