/*
 *
 * spiral.c -- a short example using the XView/NeWS library
 * 
 * A PSCANVAS is created, then NeWS PostScript rendering 
 * is used to draw a spiral
 *
 */
#include <xview/xview.h>
#include <xvps/pscanvas.h>
#include "lines.h"
Frame frame;
Icon icon;
NeWStoken icon_canvas;

void paint_spiral()
{
  float i;
  clear();

  scale_to_fit();

  center();
  scale(.85, .85);
  rotate(89.0);
  for ( i=0; i<= 1; i= i+ 0.040)
    {
      set_color(i);
      ps_newpath();
      moveto(0.0, .9);
      arc_shape();
      ps_gsave();
      ps_fill();
      ps_grestore();
      set_color(.0);
      ps_stroke();
      scale(.88, .88);
      rotate(22.5);
     }
  }
void pscanvas_repaint_proc(pscanvas, newstoken, dpy, xid, xrects)
     PScanvas	pscanvas;
     NeWStoken	newstoken;
     Display	*dpy;
     Window	xid;
     Xv_xrectlist *xrects;
{
  xv_set(pscanvas, PSCANVAS_CLIPRECTS, xrects);
  pscanvas_flip();
  paint_spiral();
}

static initialized=0;
/*
 * Handle icon events.
 */
Notify_value
  icon_proc(win, evnt, arg, type)
	Xv_Window       win;
	Event          *evnt;
	Notify_arg      arg;
	Notify_event_type type;
{

  /* this procedure finds the NeWS canvas for the Icon, first time through */
  if (initialized) ps_setcanvas(icon_canvas);
  else {
    /* Otherwise get the NeWS canvas and store it in "icon_canvas" */
    
    if ((ps_token_from_xid(xv_get(win, XV_XID),&icon_canvas)))
      {
	int x,y;
	ps_setcanvas(icon_canvas);
	ps_getcanvaslocation(icon_canvas, &x, &y);
	circleat(x, y);
	ps_reshapecanvas(icon_canvas);
	initialized=1;
      }
  }
  if (event_id(evnt) == WIN_REPAINT) {
    ps_setcanvas(icon_canvas);
    pscanvas_flip();
    paint_spiral();
  }

  return (notify_next_event_func(win, evnt, arg, type));
}

main(argc, argv)
	int             argc;
	char          **argv;
{
  xv_init(XV_INIT_ARGS, argc, argv, 0);
  icon=xv_create(XV_NULL, ICON,
		 XV_VISUAL_CLASS, StaticColor,
		 XV_LABEL, " ",
		 NULL);

  frame=xv_create(NULL, FRAME,
		  FRAME_LABEL, "XView/NeWS Library Example: Spiral",
		  FRAME_ICON, icon,
		  NULL);
  xv_create(frame, PSCANVAS,
	    XV_VISUAL_CLASS, StaticColor,
	    PSCANVAS_REPAINT_PROC, pscanvas_repaint_proc,
	    PSCANVAS_SYNC, 5, NULL);
  notify_interpose_event_func(icon,
			      icon_proc, NOTIFY_SAFE);

  window_fit(frame);
  xv_main_loop(frame);
}
