%
% This file is a product of Sun Microsystems, Inc. and is provided for
% unrestricted use provided that this legend is included on all tape
% media and as a part of the software program in whole or part.  Users
% may copy or modify this file without charge, but are not authorized to
% license or distribute it to anyone else except as part of a product
% or program developed by the user.
% 
% THIS FILE IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
% WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
% PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
% 
% This file is provided with no support and without any obligation on the
% part of Sun Microsystems, Inc. to assist in its use, correction,
% modification or enhancement.
% 
% SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
% INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY THIS FILE
% OR ANY PART THEREOF.
% 
% In no event will Sun Microsystems, Inc. be liable for any lost revenue
% or profits or other special, indirect and consequential damages, even
% if Sun has been advised of the possibility of such damages.
% 
% Sun Microsystems, Inc.
% 2550 Garcia Avenue
% Mountain View, California  94043
%
%
% "@(#)NeWSico.cps 23.2 90/06/19
%
% Copyright (c) 1985 by Sun Microsystems, Inc.
%


#define BORDER 20
#define SIZETAG 50
#define PAINTTAG 51
#define SYNCTAG 52
cdef ps_whiteonblack()
	/fgcolor 1 1 1 rgbcolor def
	/bgcolor 0 0 0 rgbcolor def
cdef ps_blackonwhite()
	/bgcolor 1 1 1 rgbcolor def
	/fgcolor 0 0 0 rgbcolor def
cdef ps_initialize()
	/IcoCanvas ClassCanvas dictbegin
	    /ConnectionFile	null	def
	    /DoubleBuffer?	false	def
	    /FullScreen?	false	def
	    /IcoW		0	def
	    /IcoH		0	def
	    /TransparentCanvas	null	def
	    /DoubleCanvas	null	def
	dictend classbegin

	    /FillColor      bgcolor    def
	    /StrokeColor    fgcolor    def
	    /CursorImage	{FullScreen? {/nouse} {null} ifelse}	def
	    /CursorMask		{FullScreen? {/nouse} {null} ifelse}	def

	    /MakeInterests { % - => event
		FullScreen? {
		    Canvas soften null
		    1 dict dup begin
			/LeftMouseButton    /GoAway self soften buildsend def
		    end
		    /new ClassInterest send
		} if
		[
		    DoubleBuffer? {
			(Use direct rendering)
		    } {
			(Use image canvas)
		    } ifelse
		    null /ToggleRender self soften buildsend
		] framebuffer /newdefault ClassMenu send
		/setmenu self send
	    } def

	    /ToggleRender { % event => -
		pop
		DoubleBuffer? not /DoubleBuffer? 1 index def
		{(Use direct rendering)} {(Use image canvas)} ifelse
		0 exch null /ToggleRender self soften buildsend
		    /change CanvasMenu send
	    } def

	    /GoAway { % event => -
		pop /destroy self send
	    } def

	    /newinit { % dblbuf? full? => -
		/FullScreen? exch def
		/DoubleBuffer? exch def
		/ConnectionFile currentfile def
		/newinit super send
	    } def

	    % override /destroy to shutdown the connection to the client.
	    % This is not the most graceful protocol for terminating this
	    % application, it was inherrited.
	    /destroy { % - => -
		/destroy super send
		/TransparentCanvas null def
		/DoubleCanvas null def
		ConnectionFile closefile
	    } def

	    /PaintCanvas {
		% tell the C client that it needs to repaint
		PAINTTAG ConnectionFile tagprint
	    } def

	    /minsize { % - => w h
		/minsize super send
		128 max exch
		128 max exch
	    } def

	    /preferredsize { % - => w h
		/preferredsize super send
		256 max exch
		256 max exch
	    } def

	    /kickit { % x y {lines} => -
		DoubleBuffer? {
		    DoubleCanvas setcanvas
		    clippath FillColor setcolor fill
		    exec
		    StrokeColor setcolor stroke
		    TransparentCanvas setcanvas
		    movecanvas
		    DoubleCanvas imagecanvas
		} {
		    Canvas setcanvas
		    3 1 roll translate
		    newpath exec
			gsave
			newpath BORDER neg dup icoW icoH rectpath
			FillColor setcolor fill
			grestore
		    StrokeColor setcolor stroke
		} ifelse
	    } def

	    /seticodims { % w h => -
		BORDER 2 mul add /icoH exch def
		BORDER 2 mul add /icoW exch def
		Canvas setcanvas
		/TransparentCanvas Canvas newcanvas dup begin
		    /Transparent true def
		    /Mapped true def
		end def
		/DoubleCanvas Canvas newcanvas dup begin
		    /Mapped false def
		    /Transparent false def
		    /Retained true def
		end def
		0 0 icoW icoH rectpath
		BORDER BORDER translate
		gsave DoubleCanvas reshapecanvas grestore
		TransparentCanvas reshapecanvas
		%/DoubleCanvas icoW icoH 1
		%TransparentCanvas setcanvas matrix currentmatrix
		%null buildimage def
	    } def

	classend def

	/RS { 	cv setcanvas
		clippath bgcolor setcolor fill
		/size cv send
		SIZETAG tagprint
		typedprint typedprint
	} def
	/KI { /kickit cv send } def
	/SID { /seticodims cv send } def

cdef ps_createwindow(doublebuffer)
	%   We have to define a nested server here to catch the error when
	%   the server connection goes away.
	/AbortProc {
	    % If we still have win around, destroy it.
	    /win where {
		pop
		/destroy win send
	    } if
	} def
	/NestedServer {currentfile cvx exec AbortProc} def
	NestedServer

	/win [doublebuffer 0 ne false IcoCanvas] []
	     framebuffer /newdefault ClassBaseFrame send def
	(Icosahedron) /setlabel win send
	/hello_world /seticon win send

	/place win send	    % shape it.
	/activate win send
	/map win send pause pause pause	    % Map the window.
	/cv /client win send def

cdef ps_screensavewindow(doublebuffer)
	/cv doublebuffer 0 ne true framebuffer /new IcoCanvas send def
	cv /Transparent false put
	framebuffer setcanvas clippath pathbbox /reshape cv send
	/activate cv send
	/map cv send pause		    % Map the window.

cdef ps_resize() => PAINTTAG
cdef ps_restart(w,h) => SIZETAG (h,w) RS
cdef ps_synchronize() => SYNCTAG () SYNCTAG tagprint
cdef ps_startlines(x, y) x y {
cdef ps_kickit() } KI
cdef ps_seticodims(w, h) w h SID
