#ifndef lint
static char *sccsid = "@(#)connector.c 23.2 90/06/19";
#endif

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>

#define CHALKPORT 2001
#define BUFSIZE 20

/*
*
*   Connect to a ChalkTalk dispatcher, join a session
*
*	Josh Axelrod
*	2/9/89
*
*/
void usage()
{
  (void) fprintf(stderr, "Usage:connector [-p portnumber] host\n");
  exit(1);
}

main (argc, argv)
int	argc;
char	*argv[];
{
  struct sockaddr_in name;
  struct hostent *host;
  int s, nread;
  int portnumber = CHALKPORT;
  char buf[BUFSIZE];

  if (argc < 2)
    usage();

  argv++;
  while (*argv) {
    if (**argv == '-') {
      switch (*(*argv + 1)) {
       case 'p':
	if (argv[1]) {
	  argv++;
	  portnumber = atoi(*argv);
	}
	else
	  usage();
	break;
       default:
	usage();
	break;
      }
      argv++;
    }
    else
      break;
  }


  if (*argv) {
    if ((host = gethostbyname(*argv)) == (struct hostent *) NULL) {
      (void) fprintf(stderr, "main:gethostbyname\n");
      exit(1);
    }
  }
  else 
    usage();
  

  bzero((char *) &name, sizeof(name));
  bcopy((char *) host->h_addr, (char *) &name.sin_addr.s_addr,
    host->h_length);
  name.sin_family = AF_INET;
  name.sin_port = htons(portnumber);

  if ((s = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    perror("main:socket");
    exit(1);
  }

  if (connect(s, (struct sockaddr *) & name, sizeof(name)) == -1) {
    perror("main:connect");
    exit(1);
  }

  bzero(buf, BUFSIZE);

  if ((nread = read(s, buf, BUFSIZE)) == -1) {
    perror("main:read");
    exit(1);
  }

  if (nread)
    (void) printf("%s\n", buf);
}
