#ifndef lint
static char sccsid[] = "@(#)deck.c 23.2 90/06/19";
#endif

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */

/*-
 *	IO handlers for HyperView decks.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <ctype.h>
#include "deck.h"

extern long verbose;

hvd_readdir(filename, deckname)
    char       *filename,
               *deckname;
{
    struct hyperview_deck *d = 0;
    struct file_header ft;
    struct stat dfdstat, fdstat;
    register    fd = open(filename, 0);
    register    dfd = -1;
    char        nmbuf[1000];

    if (fd < 0)
	return -1;
    sprintf(nmbuf, "%sdir", filename);
    if ((dfd = open(nmbuf, 0)) < 0) {
failure:
	close(fd);
	if (dfd >= 0)
	    close(dfd);
	if (d)
	    free(d);
	return 0;
    }
    if (fstat(dfd, &dfdstat) < 0)
	goto failure;
    d = (struct hyperview_deck *) malloc(sizeof(struct hyperview_deck)
				       + strlen(filename)
				       + strlen(deckname) + 2
				       + dfdstat.st_size);
    if (d == 0)
	return 0;
    if (read(dfd, &d->h, dfdstat.st_size) != dfdstat.st_size)
	goto failure;
    close(dfd);
    dfd = -1;
    swapblock(&d->h, sizeof(struct file_header));
    d->filename = (char *) d + sizeof *d + dfdstat.st_size;
    d->deckname = d->filename + strlen(filename) + 1;
    if (fstat(fd, &fdstat) < 0)
	goto failure;
    if (fdstat.st_size != d->h.filesize)
	goto failure;
    if (dfdstat.st_mtime < fdstat.st_mtime)
	goto failure;
    if (d->h.magic != HYPERVIEW_MAGIC)
	goto failure;
    swapblock(&d->h + 1, d->h.dsize * sizeof(struct hv_dir)
	      + d->h.tsize * sizeof(struct hv_tag));
    strcpy(d->filename, filename);
    strcpy(d->deckname, deckname);
    d->dirs = (struct hv_dir *) (&d->h + 1);
    d->tags = (struct hv_tag *) (d->dirs + d->h.dsize);
    d->fd = fd;
    d->next = hyperview_root;
    hyperview_root = thisdeck = d;
    return 1;
}

tag_compare(s1, s2)
    register struct hv_tag *s1,
               *s2;
{
    return strcmp((char *) &thisdeck->h + s1->string_offset,
		  (char *) &thisdeck->h + s2->string_offset);
}

hvd_parsedir(filename, deckname)
    char       *filename,
               *deckname;
{
    register FILE *f = fopen(filename, "r");
    struct hv_dir *dirbuf = 0;
    long        dirsize = 0;
    struct hv_tag *tagbuf = 0;
    long        tagsize = 0;
    long        npages = 0;
    long        ntags = 0;
    char        line[2000];
    register char *p;
    register char *tagst;
    register    c;
    long        pageno = 0;
    long        nextpageno = 1;
    long        filepos = 0;
    long        pagestart = 0;
    long        maxpage = 0;
    long        maxtag = 0;
    struct hyperview_deck *d = 0;
    struct file_header ft;
    long        fd;
    if (f == 0)
	return -1;
    d = (struct hyperview_deck *) malloc(sizeof *d);
    while (1) {
	register    newpage = 0;
	p = line;
	tagst = 0;
	while (p < line + sizeof line - 1 && (c = getc(f)) != EOF) {
	    *p++ = c;
	    if (c == '\n')
		break;
	}
	*p = 0;
	if (line[0] == 014 || c == EOF)
	    newpage = 1;
	if (line[0] == '%' && line[1] == '%') {
	    register char *sp = line + 2;
	    while (isspace(*sp))
		sp++;
	    if (strncmp(sp, "Page:", 5) == 0) {
		tagst = sp + 5;
		newpage = 1;
	    }
	    if (strncmp(sp, "Tag:", 4) == 0)
		tagst = sp + 4;
	}
	if (newpage) {
	    if (pageno >= dirsize)
		if (dirsize) {
		    dirbuf = (struct hv_dir *) realloc(dirbuf,
					      pageno * 2 * sizeof dirbuf[0]);
		    bzero(dirbuf + dirsize, (pageno * 2 - dirsize) * sizeof dirbuf[0]);
		    dirsize = pageno * 2;
		} else {
		    dirbuf = (struct hv_dir *) malloc((pageno + 2) * sizeof dirbuf[0]);
		    bzero(dirbuf, (pageno + 2) * sizeof dirbuf[0]);
		    dirsize = pageno + 2;
		}
	    dirbuf[pageno].filepos = pagestart;
	    if ((dirbuf[pageno].size = filepos - pagestart) > 2) {
		pageno = nextpageno;
		nextpageno++;
		if (pageno > maxpage)
		    maxpage = pageno;
	    }
	    pagestart = filepos;
	    if (c == EOF)
		break;
	}
	filepos += p - line;
	if (tagst) {
	    register char *newstr,
	               *strend;
	    while (*tagst <= ' ' && *tagst)
		tagst++;
	    for (strend = tagst; *strend > ' '; strend++);
	    if (strend == tagst)
		continue;
	    if ('0' <= tagst[0] && tagst[0] <= '9') {
		char        tpageno[30];
		sprintf(tpageno, "%d", pageno);
		if (strncmp(tpageno, tagst, strend - tagst) == 0)
		    continue;
	    }
	    if (maxtag >= tagsize)
		if (tagsize == 0)
		    tagbuf = (struct hv_tag *) malloc((tagsize = 5) * sizeof tagbuf[0]);
		else
		    tagbuf = (struct hv_tag *) realloc(tagbuf,
			   (tagsize = (tagsize * 2) + 5) * sizeof tagbuf[0]);
	    tagbuf[maxtag].cardnumber = pageno;
	    newstr = (char *) malloc(strend - tagst + 1);
	    bcopy(tagst, newstr, strend - tagst);
	    newstr[strend - tagst] = 0;
	    tagbuf[maxtag].string_offset = (int) newstr - (int) &d->h;
	    maxtag++;
	}
    }
    if (d == 0) {
	fclose(f);
	return 0;
    }
    d->dirs = dirbuf;
    d->tags = tagbuf;
    d->fd = fileno(f);
    d->filename = (char *) malloc(strlen(filename) + 1);
    strcpy(d->filename, filename);
    d->deckname = (char *) malloc(strlen(deckname) + 1);
    strcpy(d->deckname, deckname);
    d->next = hyperview_root;
    hyperview_root = thisdeck = d;
    d->h.magic = HYPERVIEW_MAGIC;
    d->h.filesize = filepos;
    d->h.dsize = maxpage;
    d->h.tsize = maxtag;
    qsort(d->tags, d->h.tsize, sizeof d->tags[0], tag_compare);
    return 1;
}

hvd_writedir(d)
    register struct hyperview_deck *d;
{
    char        fnbuf[1000];
    register struct hv_tag *t;
    int         fd;
    register    pos;
    register    i;
    register    hsize,
                dsize,
                tsize;
    sprintf(fnbuf, "%sdir", d->filename);
    if ((fd = creat(fnbuf, 0666)) < 0) {
	if (compileonly) {
	    printf(stderr, "Couldn't create %s\n", fnbuf);
	    exit(1);
	}
	return;
    }
    if (verbose || compileonly) printf("\tWriting %s\n", fnbuf);
    hsize = sizeof d->h;
    dsize = d->h.dsize * sizeof(struct hv_dir);
    tsize = d->h.tsize * sizeof(struct hv_tag);
    swapblock(&d->h, hsize);
    write(fd, &d->h, hsize);
    swapblock(&d->h, hsize);
    swapblock(d->dirs, dsize);
    write(fd, d->dirs, dsize);
    swapblock(d->dirs, dsize);
    pos = hsize + dsize + tsize;
    t = (struct hv_tag *) malloc(tsize);
    bcopy(d->tags, t, tsize);
    for (i = 0; i < d->h.tsize; i++) {
	t[i].string_offset = pos;
	pos += strlen((char *) &d->h + d->tags[i].string_offset) + 1;
    }
    swapblock(t, tsize);
    write(fd, t, tsize);
    free(t);
    for (i = 0; i < d->h.tsize; i++)
	write(fd,
	      (char *) &d->h + d->tags[i].string_offset,
	      strlen((char *) &d->h + d->tags[i].string_offset) + 1);
    close(fd);
}

register struct hyperview_deck *
deck_lookup(deck)
    register char *deck;
{
    static char *dpath;
    register struct hyperview_deck *pcd;
    register char *p0,
               *p;
    int decknamelen = strlen(deck);
    for (pcd = hyperview_root; pcd; pcd = pcd->next)
	if (strcmp(deck, pcd->deckname) == 0)
	    return thisdeck = pcd;
    if (dpath == 0) {
	extern char *getenv();
	dpath = getenv("DECKPATH");
	if (dpath == 0) {
	    static char dfpath[300];
	    dpath = (char *) getenv("OPENWINHOME");
	    if (dpath == 0) dpath = "/usr";
	    sprintf(dfpath, ":%s/hyperdecks:%s/etc/NeWS/hyperdecks",
		    getenv("HOME"), dpath);
	    dpath = dfpath;
	}
    }
    if (verbose) printf("DECKPATH=%s\n", dpath);
    if (strcmp(&deck[decknamelen-3], ".hv") == 0)
	deck[decknamelen-3] = 0;
    for (p = deck[0]=='/' ? "" : dpath;; p++) {
	char        fnbuf[1000];
	p0 = p;
	while (*p && *p != ':')
	    p++;
	if (p > p0)
	    sprintf(fnbuf, "%.*s/%s.hv", p - p0, p0, deck);
	else
	    sprintf(fnbuf, "%s.hv", deck);
	if (verbose) printf("Trying %s\n", fnbuf);
#ifndef sun386
	switch (hvd_readdir(fnbuf, deck)) {
	case 0:
	    if (verbose) printf("\tDeck but no directory, reading\n");
	    if (hvd_parsedir(fnbuf, deck) <= 0)
		break;
	    hvd_writedir(hyperview_root);
	case 1:
	    return thisdeck = hyperview_root;
	case -1:
	    break;
	}
#else
	if (hvd_parsedir(fnbuf, deck) > 0)
	    return thisdeck = hyperview_root;
#endif
	if (*p == 0)
	    break;
    }
    return thisdeck = 0;
}

print_deck(d)
    register struct hyperview_deck *d;
{
    register    i;
    if (d == 0) {
	printf("No deck\n");
	return;
    }
    printf("deck %s, file %s, fd=%d, dsize=%d, tsize=%d, fsize=%d\n",
	   d->deckname, d->filename, d->fd,
	   d->h.dsize, d->h.tsize, d->h.filesize);
    for (i = 0; i < d->h.dsize; i++)
	printf("%3d %7d %7d\n", i,
	       d->dirs[i].filepos,
	       d->dirs[i].size);
    for (i = 0; i < d->h.tsize; i++)
	printf("%3d %7d %s\n", i,
	       d->tags[i].cardnumber,
	       (char *) &d->h + d->tags[i].string_offset);
}
