/*	@(#)deck.h 23.2 90/06/19 SMI	*/

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */

/*-
 *	NeWS hypertext system
 */

#if defined(i386) | defined(vax)
#define LITTLEENDIAN
#else
#define BIGENDIAN
#endif

#define longswap(l) \
	  ((l)<<24) \
	| ((l)<<8)&0xFF0000 \
        | ((l)>>8)&0xFF00 \
	| ((unsigned)(l)>>24)

#ifdef LITTLEENDIAN
#define swapblock(block, size) { \
    register long *p = (long *) (block); \
    register long n = size/sizeof(long); \
    while (--n>=0) { \
	register long v = *p; \
	*p = longswap(v); \
	p++; \
    } \
}
#else
#define swapblock(block, size) {}
#endif

/*
 * Magic Number is "HVD" for HyperViewDeck, followed by an ascii "0" 0x30.
 * The "0" should be bumped to "1" etc... as the file format changes.
 */
/*			  H V D 0 				*/
#define HYPERVIEW_MAGIC 0x48564430

struct file_header {
    long        magic;
    long        filesize;	/* The size of the file: this is used for
				 * checking to see if the file has changed
				 * since the directory was created */
    long        dsize;		/* The number of entries in the directory */
    long	tsize;		/* The number of entries in the tag table */
};

#define dent_deleted(lp) ((*(lp)&1) != 0)
#define dent_offset(lp) (*(lp)>>1)
#define dent_size(lp) (((lp)[1]-(lp)[0])>>1)
#define dent_pack(offset,deleted) (((offset)<<1)|(deleted))

struct hv_dir {
    long        filepos;
    long        size;
};

struct hv_tag {
    long string_offset;		/* From the beginning of the header */
    long cardnumber;
};

struct hyperview_deck {		/* The in-memory representation of a deck */
    struct hv_dir *dirs;
    struct hv_tag *tags;
    char        fd;
    char       *filename;
    char       *deckname;
    struct hyperview_deck *next;
    struct file_header h;
};

struct hyperview_deck *hyperview_root, *thisdeck;
long	    compileonly;
