#ifndef lint
static char sccsid[] = "@(#)hyperview.c 23.2 90/06/19";
#endif

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */

/*
 * HyperView.c - NeWS Toolkit HyperText program.
 *
 */

#include	<stdio.h>
#include	<strings.h>
#include	"deck.h"
#include	"hyperview.h"

#define		NEXT_CARD	1
#define		PREV_CARD	2
#define		FIRST_CARD	3
#define		LAST_CARD	4
#define		FIND_CARD	5
#define		LIST_CARD	6
#define		PRINT_CARD	7
#define		DELETE_CARD	8
#define		UNDELETE_CARD	9
#define		NEW_CARD	10
#define		SORT_CARDS	11
#define		FORWARD		12
#define		REVERSE		13
#define		GOTO_CARD	14
#define		GO_BACK		15
#define		QUIT		16

void        show_card(), save_card(), goback(), find_it(), goto_it();
int         command_switch();
int         direction;
char        to_goto[1];
char        to_find[BUFSIZ];
char        buf[1024];

long        current,
            saved;
static struct hyperview_deck *currentdeck;
long        verbose;
char       *deckname;
long        first,
            last;

main(argc, argv)
    int         argc;
    char       *argv[];
{
    int         index;

    while (--argc > 0) {
	if (**(++argv) == '-') {
	    switch (argv[0][1]) {
	    case 'V':
		close(1);
		creat("/tmp/hyperlog", 0666);
		dup2(1, 2);
		verbose++;
		break;
	    case 'v':
		verbose++;
		break;
	    case 'c':
		compileonly++;
		break;
	    default:
		fprintf(stderr, "hyperview: illegal switch %s\n", argv[0]);
		exit(1);
	    }
	} else {
	    deckname = argv[0];
	    if (compileonly) {
		if (deck_lookup(deckname) == 0)
		    fprintf(stderr, "Cannot open %s\n", deckname);
		exit(0);
	    }
	}
    }
    if (ps_open_PostScript() == 0) {
	fprintf(stderr, "Can't contact NeWS server\n");
	exit(0);
    }
    ps_initialize(to_find);
    if (verbose && to_find[0])
	printf("Initial target: %s\n", to_find);
    saved = 0;
    current = -1;
    first = 0;
    if (to_find[0] != 0 && deckname == 0)
	find_it();
    if (thisdeck == 0) {
	if (deckname == 0)
	    deckname = "HomeDeck";
	if (deck_lookup(deckname) == 0) {
	    fprintf(stderr, "Can't open HyperDeck file: %s\n", deckname);
	    fflush(stdout);
	    fflush(stderr);
	    ps_shutdown();
	    ps_flush_PostScript();
	    write(open("/dev/console", 1), "hyperview: Can't locate deck", 28);
	    exit(0);
	}
	last = thisdeck->h.dsize - 1;
	show_init_card();
	first = 1;
	show_card(1);
	{
	    char       *temp = rindex(deckname, '/');
	    ps_set_deck_name(temp ? ++temp : deckname);
	}
    }
    direction = FORWARD;
    while (!psio_eof(PostScriptInput)) {
	if (ps_command(&index)) {
	    if (command_switch(index))
		break;
	} else if (ps_find_command(to_find))
	    find_it();
	else
	    break;
    }
    if (PostScript && !psio_error(PostScript)) {
	ps_shutdown();
	ps_flush_PostScript();
    }
    exit(0);
}

int
command_switch(index)
    int         index;
{
    if (verbose)
	printf("index=%d\n", index);
    switch (index) {
    case NEXT_CARD:
	save_card();
	show_card(current + 1);
	break;
    case PREV_CARD:
	save_card();
	show_card(current - 1);
	break;
    case FIRST_CARD:
	save_card();
	show_card(first);
	break;
    case LAST_CARD:
	save_card();
	show_card(last - 1);
	break;
    case GOTO_CARD:
	if (!psio_eof(PostScriptInput)) {
	    ps_to_goto(to_goto);
	    goto_it();
	}
	break;
    case GO_BACK:
	goback();
	break;
    case QUIT:
	ps_close_PostScript();
	return 1;
    default:
	break;
    };
    return 0;
}

void
show_card(card)
{
    static char *cbuf;
    static      size;

    if (card < first)
	card = first;
    if (card > last)
	card = last;
    if (card == current && thisdeck == currentdeck)
	return;
    current = card;
    currentdeck = thisdeck;
    if (size < thisdeck->dirs[current].size) {
	if (cbuf)
	    free(cbuf);
	cbuf = (char *) malloc(size = thisdeck->dirs[current].size);
    }
    lseek(thisdeck->fd, thisdeck->dirs[current].filepos, 0);
    read(thisdeck->fd, cbuf, thisdeck->dirs[current].size);
    if (verbose)
	printf("show_card(\"%.15s...%.10s\");\n",
	       cbuf, cbuf + thisdeck->dirs[current].size - 10);
    ps_show_card(saved, current, cbuf, thisdeck->dirs[current].size);
}

show_init_card()
{
    static char *cbuf;
    static      size;
    first = 0;
    last = thisdeck->h.dsize - 1;
    if (size < thisdeck->dirs[0].size) {
	if (cbuf)
	    free(cbuf);
	cbuf = (char *) malloc(size = thisdeck->dirs[0].size);
    }
    lseek(thisdeck->fd, thisdeck->dirs[0].filepos, 0);
    read(thisdeck->fd, cbuf, thisdeck->dirs[0].size);
    if (verbose)
	printf("show_0(\"%.15s...%.10s\");\n",
	       cbuf, cbuf + thisdeck->dirs[0].size - 10);
    ps_show_init_card(0, cbuf, thisdeck->dirs[0].size);
    first = 1;
}



void
find_it()
{
    register long p;
    register char *d;
    for (d = to_find; *d && *d != ':'; d++);
    if (*d && d[1]) {
	struct hyperview_deck *prev = thisdeck;
	*d++ = 0;
	if (thisdeck == 0 || strcmp(to_find, thisdeck->deckname) != 0)
	    if (deck_lookup(to_find)) {
		show_init_card();
		ps_set_deck_name(to_find);
		if (verbose)
		    printf("Deck: %s\n", to_find);
	    } else {
		thisdeck = prev;
		if (verbose)
		    printf("Missing deck: %s\n", to_find);
		return;
	    }
    } else
	d = to_find;
    if (thisdeck == 0)
	return;
    if (verbose)
	printf("Tag: %s\n", d);
    for (p = 0; p < thisdeck->h.tsize; p++)
	if (strcmp((char *) &thisdeck->h + thisdeck->tags[p].string_offset,
		   d) == 0) {
	    save_card();
	    show_card(thisdeck->tags[p].cardnumber);
	    break;
	}
}

void
goto_it()
{
    save_card();
    show_card((int) to_goto[0]);
}

#define SAVE_LIMIT 16

static long save_buffer[SAVE_LIMIT];
static struct hyperview_deck *decksave_buffer[SAVE_LIMIT];

static int  recall_next = 0;
static int  recall_first = -1;

void
show_buffer()
{
    register int i;

    printf("[%d..%d] ", recall_first, recall_next);
    for (i = 0; i < SAVE_LIMIT; i++) {
	if (i == recall_first)
	    printf("<");
	if (i == recall_next)
	    printf(">");
	printf("%3d", save_buffer[i]);
    }
    printf("\n");
}

void
save_card()
{
    int         stomp;

    if (current <= 0 || current >= currentdeck->h.dsize || currentdeck == 0) {
	if (verbose) {
	    printf("skipping save_card %d %d %s\n",
		   current,
		   currentdeck ? currentdeck->h.dsize : 0,
		   currentdeck ? currentdeck->deckname : "<NONE>");
	    fflush(stdout);
	}
	return;
    }
    save_buffer[recall_next] = current;
    decksave_buffer[recall_next] = currentdeck;
    stomp = (recall_next == recall_first);
    if (recall_first == -1)
	recall_first = 0;
    recall_next++;
    if (recall_next == SAVE_LIMIT)
	recall_next = 0;
    if (stomp)
	recall_first = recall_next;
    else
	saved++;
}

void
goback()
{
    if (recall_first != -1) {
	saved--;
	recall_next--;
	if (recall_next == -1)
	    recall_next = SAVE_LIMIT - 1;
	if (recall_next == recall_first)
	    recall_first = -1;
	if (decksave_buffer[recall_next] != thisdeck) {
	    thisdeck = decksave_buffer[recall_next];
	    show_init_card();
	    ps_set_deck_name(thisdeck->deckname);
	    if (verbose)
		printf("Deck: %s\n", thisdeck->deckname);
	}
	show_card(save_buffer[recall_next]);
    }
}
