%%SccsID: @(#)hyperview.cps 23.4 90/06/19

#include "hvtags.h"
C: #include "hvtags.h"
		
cdef ps_command(int index) => COMMAND_TAG (index)

cdef ps_error_msg(string error_msg)
	null error_msg /setfooter win send

cdef ps_set_deck_name(string deckname)
	deckname null /setfooter win send

cdef ps_show_init_card(int card_no, cstring card_string)
    {
	/safedict 500 dict store
	gsave
	    safedict begin
		card_string cvx exec
	    end
	grestore
    } /Client /sendclient win send

cdef ps_show_card(int saved, int card_no, cstring card_string)
	null card_no 4 string cvs /setfooter win send
	saved card_no card_string /showHyperCard /Client /sendclient win send

cdef ps_find_command(string to_find) => FIND_TAG (to_find)

cdef ps_to_goto(string anint) => GOTO_TAG (anint)
	gotoint cvis GOTO_TAG tagprint typedprint

cdef ps_shutdown()
	/destroy win send
	currentprocess killprocessgroup

cdef ps_initialize(string to_find) => (to_find)

/thisfile currentfile def

% ensure that no matter what happens, our window gets destroyed
{
    currentprocess /ErrorDetailLevel 1 put
    { currentfile cvx exec } stopped {
	console (*******************\nError in HyperDeck!\n) fprintf
	console $error /message get fprintf
	/destroy win send
    } if
    currentprocess killprocessgroup
} exec

/gotoint 1 def

/ClassCanvas load isclass? not {
    console (NeWS initialization in progress. Be patient.\n) fprintf
} if    

/HyperViewCanvas ClassCanvas
dictbegin
    /ClientPaintProcedure	null def
    /Card			() def
    /CardNumber			0 def
    /SavedCards			0 def
    /fontsize			20 def
    /TextFamily			/LucidaSans-Bold def
    /font			TextFamily findfont fontsize scalefont def
    /Spots			[] def
    /selected			-1 def
    /selecttime			-1 def
    /safedict			1 dict def
    /pageheight			0 def
    /pagewidth			0 def
    /BX				0 def
    /BY				0 def
    /Gap			8 def
    /Previewing			false def
    /invertpixel		null def
dictend
classbegin

    /newinit {
	/newinit super send

	/CreateMenu self send
    } def

    /destroy { % - => -
	{
	    COMMAND_TAG //thisfile tagprint
	    QUIT //thisfile typedprint
	    flush
	} stopped {
	    pop pop	% pop the file(?,W,R,EOF) and the tag.
	} if
	/thisfile null store
	/safedict null store
	/win null store
	statusdict /hyperview_file null put
	statusdict /hyperview_tag  null put
	/destroy super send
    } def

% Page scaling utility methods.
%
    /inch	{72 mul} def
    /USLttr	{8.5 inch 11 inch SetPageSize} def

    /SetPageSize {
	/pageheight exch store
	/pagewidth exch store
	PageScale
    } def

    /PageScale { % - => -
	clippath pathbbox pop pop translate
	clippath pathbbox pageheight div exch pagewidth div exch
			  min dup scale pop pop
	clippath pathbbox 2 div pageheight 2 div sub exch
	2 div pagewidth 2 div sub exch
	translate pop pop
    } def

    /showHyperCard { % saved-cards card-number card-string => -
	/Card exch def
	/CardNumber exch def
	/SavedCards exch def
	/paint self send
    } def

    /clearspots { % - => -
	/Spots [] store
	/selected -1 store
	/selecttime -1 store
    } def

    /rectshow { % x y w h str => -
	gsave
	dictbegin
	/s exch def
	/h exch def
	/w exch def
	/y exch def
	/x exch def
	x w 2 div add y h 2 div add 
	currentfont dup fontdescent exch fontascent add 2 div sub moveto
	s cshow
	dictend
	grestore
    } def

    /XorReflect { % bool => -
	pop
	gsave
	    6 setrasteropcode invertpixel setpixel
	    fill
	grestore
    } def

    /killselection { 
	selected -1 ne {
	    gsave
		/canvas self send setcanvas
		PageScale
		false selected /hilite self send
		/selected -1 store
	    grestore
	} if
    } def

    /sendcommand { % TAG
	/killselection self send
	COMMAND_TAG //thisfile tagprint
	//thisfile typedprint
    } def

    /goBack {
	GO_BACK /sendcommand self send
    } def
    /goFirst { 
	FIRST_CARD /sendcommand self send
    } def
    /goLast { 
	LAST_CARD /sendcommand self send
    } def
    /goNext {
	NEXT_CARD /sendcommand self send
    } def
    /goPrev { 
	PREV_CARD /sendcommand self send
    } def


% Build the client menu and store it in the instance variable /CanvasMenu.
%
    /CreateMenu { % - => -
	/CanvasMenu [
		(Go Back)	null /goBack self soften buildsend
		(First)		null /goFirst self soften buildsend
		(Last)		null /goLast self soften buildsend
		(Next)		null /goNext self soften buildsend
		(Previous)	null /goPrev self soften buildsend
	] framebuffer /newdefault ClassMenu send def
	true /setpinnable CanvasMenu send
	(Goto) /setlabel CanvasMenu send
	(HyperView: ) /setowner CanvasMenu send
    } def

    /ReadChar { % ev => -
	/Name get [
	    127 { /goBack self send }
	    /Default { beep }
	] case
    } def

    /hilite { % n => -
	gsave
	    newpath Spots exch get dup 0 get aload pop rectpath 2 get exec
	grestore
    } def

    /PaintCanvas { % - => -
% get fillcolor from hyperdeck if it has one and promote it to the bag if so.
	safedict /FillColor FillColor ?get
	/FillColor 1 index promote
	/invertpixel FillColor setcolor currentpixel
			0 setgray currentpixel xor def
	/FillCanvas self send
	Card length 0 gt {
	    gsave
		safedict begin
		    selected [ Card cvx exec cleartomark /selected exch store
		end
	    grestore
	} if
	selected -1 ne {
	    gsave
		/canvas self send setcanvas
		PageScale
		true selected /hilite self send
	    grestore
	} if
    } def

    /restorefooter { % - => -
	deckname CardNumber 4 string cvs /setfooter /parent self send send
    } def

    /doBusy { % - => -
	true /setbusy /parent self send send
	{
	    1 30 div sleep	% 2 seconds
	    false /setbusy /parent self send send
	    /restorefooter self send
	} fork pop
    } def

% execute spot function
    /doSpot { % spot => -
	null (please wait...) /setfooter /parent self send send
	1 get dup type /stringtype eq {
	    /restorefooter self send
	    FIND_TAG tagprint typedprint
	} {
	    /doBusy self send
	    [ exch
	    { cvx exec } stopped {
		null (Error in hot spot!) /setfooter /parent self send send
	    } if
	    counttomark 0 ne {
		(Started ) exch append null /setfooter /parent self send send
	    } if
	    cleartomark
	} ifelse
    } def

% track the spot function
    /DoSpot { % event => -
    	dup /trackon self send unblockinputqueue
	Previewing { pop } {
	  safedict begin
	    Spots length 0 gt {
		/canvas self send setcanvas
		PageScale
		begin TimeStamp XLocation YLocation end
		/evy exch def
		/evx exch def
		/evt exch def
		/idx 0 def
		true Spots {
		    /spot exch store
		    gsave
			spot 0 get aload pop rectpath
			evx evy pointinpath
		    grestore
		    {
			selected -1 eq {
			    /selected idx store
			    true selected /hilite self send
			    /selecttime evt store
			} {
			    selected idx eq {
				evt selecttime sub
				UserProfile /MultiClickThresh get le {
				    /selected -1 store
				    false idx /hilite self send
				    spot doSpot
				} {
				    /selecttime evt store
				} ifelse
			    } {
				true idx /hilite self send
				false selected /hilite self send
				/selecttime evt store
				/selected idx store
			    } ifelse
			} ifelse
			pop false exit
		    } if	% click in a hot spot?
		    /idx idx 1 add store
		} forall	% hot spots...
		selected -1 ne and {
		    false selected /hilite self send
		    /selecttime -1 store
		    /selected -1 store
		} if
	    } {
		pop
	    } ifelse
	  end
	} ifelse
    } def

    /DoUp { % event => -
	Previewing { pop } {
	  safedict begin
	    Spots length 0 gt {
		/canvas self send setcanvas
		PageScale
		begin TimeStamp XLocation YLocation end
		/evy exch def
		/evx exch def
		/evt exch def
		/idx 0 def
		Spots {
		    /spot exch store
		    gsave
			spot 0 get aload pop rectpath
			evx evy pointinpath
		    grestore
		    {
			selected idx eq {
			    spot 1 get dup type /stringtype eq {
				/selected -1 store
				false idx /hilite self send
				FIND_TAG tagprint typedprint
			    } {
				pop
				/selecttime evt store
			    } ifelse
			} if
		    } if	% click in a hot spot?
		    /idx idx 1 add store
		} forall	% hot spots...
	    } {
		pop
	    } ifelse
	  end
	} ifelse
    } def

% show the location of all spots
%
    /SeeSpots {
	pop				% lose the event
	gsave
	    safedict begin
		Spots length 0 gt {
		    /canvas self send setcanvas
		    PageScale
		    6 setrasteropcode invertpixel setpixel
		    Spots {
			0 get aload pop rectpath
		    } forall
		    stroke
		    /Previewing true store
		    [
			AdjustButton {
			    pop		% lose the event
			    6 setrasteropcode invertpixel setpixel
			    Spots {
				0 get aload pop rectpath
			    } forall
			    stroke
			    /Previewing false store
			    currentprocess killprocess
			} /UpTransition
			null excleventmgrinterest

			/MouseDragged {pop} null null excleventmgrinterest
		    ] forkeventmgr pause pop
		} { redistributeevent} ifelse
	    end % safedict
	grestore unblockinputqueue
    } def

    /MakeInterests {
	/MakeInterests super send

	PointButton /DoSpot BuildCanvasSend
	/DownTransition /canvas self send syncheventmgrinterest

	AdjustButton /SeeSpots BuildCanvasSend
	/DownTransition /canvas self send syncheventmgrinterest

	/ReadChar self soften buildsend /canvas self send soften
	/defaultkeys ClassKeysInterest send
    } def

    /trackon { % event => -
    	[
	    exch /Name get {
		/DoUp self send
		%currentprocess killprocess
		exit
	    } self soften buildsend
	    /UpTransition null excleventmgrinterest
	    /MouseDragged {pop} null null excleventmgrinterest
	] forkeventmgr pause pop
    } def

    /minsize { % - => w h
	/minsize super send
	220 max exch
	160 max exch
    } def

    /preferredsize { % - => w h
	/preferredsize super send
	550 max exch
	400 max exch
    } def

classend def


/win [HyperViewCanvas] [] framebuffer /newdefault ClassBaseFrame send def

{   gsave
	/size self send scale
	/pastel { colorcanvas { .4 1 sethsbcolor } { setgray } ifelse } def
	/lightfont /Helvetica findfont .2 scalefont def
	/boldfont /Helvetica-Bold findfont .2 scalefont def
	0 fillcanvas
	TextColor setcolor
	.05 .2 .85 {
	    dup 1.25 mul pastel
	    lightfont setfont
	    .02 1 index moveto (hyper) show

	    1.25 mul 1 exch sub pastel
	    boldfont setfont
	    (view) show
	} for
    grestore
} /seticon win send

(HyperView) /setlabel win send
null /seticonlabel win send

/place win send
/activate win send
/map win send

statusdict /hyperview_tag () ?get typedprint	% return value for initialize
statusdict /hyperview_tag () put
statusdict /hyperview_file currentfile put
