%!CPS-NeWS1.2
%%Title: lunar.cps
%%Description: C bindings for NeWS functions
%%SccsId: @(#)lunar.cps 1.3 90/06/19

#include "lunartags.h"
C: #include "lunartags.h"

cdef ps_initialize(xmin, ymin, xmax, ymax, randseed)
	true setpacking

	% Create some utility procs for calling from the C-side
	/lander { % thrust rotation x y => -
		gsave 37.5 add translate rotate
			0 setgray
		%body
			-18.5 -22.5 moveto -18.5 -15.0 lineto -5.5 -15.0 lineto
			-15.0 -5.5 lineto -15.0 5.5 lineto -5.5 15.0 lineto
			5.5 15.0 lineto 15.0 5.5 lineto 15.0 -5.5 lineto
			5.5 -15.0 lineto 18.5 -15.0 lineto 18.5 -22.5 lineto
			closepath
		%flame
			-5.5 -22.5 moveto
			neg -22.5 add 0.0 exch lineto
			5.5 -22.5 lineto
		%left leg
			-15.0 -22.5 moveto -15.0 -15.0 rlineto
			-2.5 0.0 rmoveto 5.0 0.0 rlineto
			-7.5 -22.5 moveto -22.5 -30.0 lineto
		%right leg
			15.0 -22.5 moveto 15.0 -15.0 rlineto
			-2.5 0.0 rmoveto 5.0 0.0 rlineto
			7.5 -22.5 moveto 22.5 -30.0 lineto
		%window
			-5.0 4.0 moveto -4.0 4.0 rlineto 5.0 0.0 rlineto
			closepath
			5.0 4.0 moveto 4.0 4.0 rlineto -5.0 0.0 rlineto
			closepath

			stroke
		grestore
	} def
	/boom { % index sc x y => -
		gsave translate dup scale shards stroke grestore pop
	} def
	/astronaut { % x y => -
	    gsave
		translate
		-5.0 0.0 moveto 0.0 10.0 lineto 5.0 0.0 lineto
		0.0 10.0 moveto 0.0 22.5 lineto -2.5 2.5 rlineto
		2.5 2.5 rlineto 2.5 -2.5 rlineto -2.5 -2.5 rlineto
		-7.5 15.0 moveto 0.0 20.0 lineto 7.5 10.0 lineto
		stroke
	    grestore
	} def
	/timer { % delay-in-ms => -
		createevent dup begin
			/Name /Timer def
			/Canvas backdrop def
			/TimeStamp 3 -1 roll minim mul currenttime add def
		end sendevent
	} def

	% Create a backdrop that is the size and shape of the framebuffer
	/backdrop framebuffer newcanvas def
	backdrop /Retained false put
	backdrop /Transparent false put
	framebuffer setcanvas clippath backdrop reshapecanvas
	backdrop /Mapped true put

	% Start up a process to listen for some events and inform the C-side
	{
		createevent dup begin
			/Name dictbegin
				/Damaged	{DAMAGETAG tagprint} def
				/MouseDragged	{
					dup begin
						XLocation YLocation
					end
					MOUSETAG tagprint
					typedprint typedprint
				} def
				/Timer		{TIMERTAG tagprint} def
			dictend def
			/Canvas backdrop def
		end expressinterest
		{
			awaitevent pop
		} loop
	} fork /ProcessName (lunar lander event manager) put

	% return backdrop extents and random number seed
		=> SIZETAG (ymax, xmax, ymin, xmin, randseed)
	usertime
	clippath pathbbox
	1 index 4 index add 2 div 1 index 4 index add 2 div setcursorlocation
	SIZETAG tagprint typedprint typedprint typedprint typedprint typedprint

cdef ps_startshards()
	/shards { % index => -

cdef ps_dorotate(theta, randnum)
	    dup randnum mul theta add rotate

cdef ps_defshards()
	} def

cdef ps_lander(thrust, angle, x, y)
	thrust angle x y lander

cdef ps_boom(x, y, sc, index)
	index sc x y boom

cdef ps_astronaut(x, y)
	x y astronaut

cdef ps_starttimer(delay)
	delay timer

cdef ps_eraseoverlay()
	fboverlay setcanvas erasepage

cdef ps_get_mouse(x, y)	=> MOUSETAG (y, x)

cdef ps_get_tag(tag)	=> tag

cdef ps_translate(x, y)
	x y translate

cdef ps_damagepath(xmin, ymin, xmax, ymax)
	backdrop setcanvas
	damagepath clipcanvas
	0 fillcanvas
	1 setgray
	clippath pathbbox
	DMGPATHTAG tagprint		=> DMGPATHTAG (ymax, xmax, ymin, xmin)
	ceiling typedprint ceiling typedprint
	floor typedprint floor typedprint

cdef ps_initclip()
	newpath clipcanvas

