% Copyright (c) 1989, Sun Microsystems, Inc.  RESTRICTED RIGHTS LEGEND:
% Use, duplication, or disclosure by the Government is subject to
% restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
% Technical Data and Computer Software clause at DFARS 52.227-7013 and
% in similar clauses in the FAR and NASA FAR Supplement.
%
%       @(#)pstermutil.cps 23.2 90/06/19 SMI
%

#include "tags.h"

/ClassPsTermSelection ClassSelection
dictbegin
    /SelectionContents	null def
dictend
classbegin

    /destroy {  % - => -
	/SelectionContents null store
	/destroy super send
    } def

    /deselect { % - => -
	Rank /deselect Holder send
    } def

    /invalidate { % - => -
	/SelectionContents null store	
    } def

    /GetContents { % - => contents of selection
	SelectionContents null eq { % req req key
	    Rank /ContentsAscii Holder send
	    /SelectionContents exch store
	} if
	SelectionContents
    } def

    /request { %  request  =>  response
	dup dup {				% req req key val
	    pop dup {				% req req key
		/ContentsAscii {
		    /GetContents self send	% req req key val
		}
		/SelectionObjsize {
		    /GetContents self send length
		}
		/Default {			% req req key
		    /UnknownRequest		% req req key /UR
		}
	    } case				% req req key val'
	    put dup				% req req
	} forall pop				% req = response
    } def

classend def

/ClassPsTermSelectable DragTextSelectable []
classbegin
    % Methods

    /selectat { %  event selection  =>  --
	begin
	    Preview? 1 0 ifelse Level Rank EVENT_SETSEL
		/SendMouseEvent Canvas send
	end
    } def

    /adjustto { %  event selection  =>  --
	begin				    % event selection
	     Preview? 1 0 ifelse Level Rank EVENT_EXTENDSEL
		/SendMouseEvent Canvas send
	end
    } def

    /inselection? { %  event selection  =>  bool
	begin
	    Rank /inselection? Holder send
	end
    } def

    /newselection { %  event rank holder  =>  selection
	/new ClassPsTermSelection send
	exch pop                    % pop the event, return selection
    } def

    /CurrentFont { % - => font
	/TextFamily Holder send findfont 12 scalefont
    } def

    /CurrentText { % selection => string
	/GetContents exch send
    } def

classend def

/ClassPsTermCanvas ClassCanvas
dictbegin
    /maxy		    0 def
    /out_file		    null def
    /process		    null def
    /ContentsAsciiString    null def
    /Cols		    80 def
    /Lines		    24 def
    /ProgName		    nullstring def
    /Console?		    false def
    /TermType		    nullstring def
dictend

classbegin
    % Defaults:
    /OrigMatrix         null def
    /KeyConsumer?       true def
    /TextFamily         /Courier def
    /Transparent        false def
    /Mapped             true def
    /minsize            { 1 1 } def

    /MetaKeys?          false def       % default no metakeys (until bugfix)
    /MENU_PAGEMODE      1 def
    /MENU_MARGINS       2 def
    /BeepAction		/Both def
    /FlashDelay		.0005 def

    /RankMap 8 dict dup begin
	/InputFocus		0 2 copy exch def def
	/PrimarySelection	1 2 copy exch def def
	/SecondarySelection	2 2 copy exch def def
	/ShelfSelection		3 2 copy exch def def
    end def

    /setdimensions { % c l => -
        /Lines exch def
        /Cols exch def
    } def

    /setprogramname { % name => -
	/ProgName exch def
    } def

    /setconsole { % bool => -
	/Console? exch def
    } def

    /settermtype { % bool => -
	/TermType exch def
    } def

    % Return a string suitable for firing up psterm in the same
    % position and with the same dimensions as this one.
    %
    /commandstring { % - => string true || false
	(% -li % -co % -xy % % -wh % % -t %%)
	    [ ProgName Lines Cols
	      /location /parent self send send
	      /size /parent self send send
	      TermType
	      Console? { ( -C) } { nullstring } ifelse
	    ] sprintf
	true
    } def

    /preferredsize { % - => pw ph
        gsave
            TextFont setfont
	    ( ) stringwidth pop floor Cols mul ceiling
	    currentfont fontheight Lines .3 add mul ceiling
        grestore
    } def

    /newinit {
	/newinit super send
	/out_file currentfile def
    } def

    /destroy { %
	/destroy super send
	/out_file null def
    } def

    /MakeInterests {
	/MakeInterests super send

	/putchar self soften buildsend
	    Canvas MetaKeys? {/metakeys} {/defaultkeys} ifelse
	    ClassKeysInterest send

	% Add function key strings  % if not metakeys (until bugfix)
	MetaKeys? not {
	    dup
	    { /Name get print } null
	    [ /FKeyStrings ClassKeyboard send ] nulldict
	    /new ClassKeysInterest send
	    /addsuite exch send
	} if

	% and selection handlers
	Canvas Canvas false /new ClassPsTermSelectable send

	Canvas /puts true /new AsciiTransferInterest send
    } def

    /with-output-to-file { % proc file => bool; executes proc with stdout as file
	dup dup null ne {
	    status {
		1 dict begin
		    /oldfile currentprocess /Stdout get def
		    currentprocess /Stdout 3 -1 roll put
		    exec
		    currentprocess /Stdout /oldfile load put
		end
		true
	    } {
		false
	    } ifelse
	} {
	    pop pop pop false
	} ifelse	    
    } def

    /EventToXY { % event => x y
	begin
	    XLocation
	    YLocation maxy sub
	end
    } def

    /SendMouseEvent { % event preview level rank tag => -
	currentcanvas 6 1 roll
	    Canvas setcanvas	    % Called in the context of an event to send
				    % a mouse event to the client.
	    { 
		tagprint
		/RankToRankno self send typedprint
		typedprint typedprint
		/EventToXY self send exch typedprint typedprint
	    } out_file /with-output-to-file self send
	    not { pop pop pop pop pop } if
	setcanvas
    } def

    /deselect { % rank => -
	{
	    EVENT_DESELECT tagprint
	    /RankToRankno self send typedprint
	    flush
	} out_file /with-output-to-file self send
	not { pop } if		% pop rank if output-to-file failed
    } def

    % SELECTIONS:
    %
    % The C side stores ranks as numbers.  They are called rankno's.  The
    % postscript stores ranks as names, e.g., /PrimarySelection.  They are
    % called rank's on the postscript side.  The RankMap variable maps
    % rank's to rankno's and rankno's to rank's.

    /RankToRankno { % rank => rank-no
	RankMap exch get
    } def

    /RanknoToRank /RankToRankno load def % rankno => rank

    % Sends a message up the wire requesting the contents of
    % the selection with the specified rank.  This does a
    % blocking call, and while the call is blocked the client
    % side calls ReceiveContentsAscii (defined below) to stuff
    % the value in an instance variable.
    /ContentsAscii { % rank => string
	{
	    EVENT_SELREQUEST tagprint		% rank
	    synchid typedprint
	    /RankToRankno self send typedprint	% rank-no
	    breakpoint

	    ContentsAsciiString			% contents
	    /ContentsAsciiString null store
	} out_file /with-output-to-file self send
	not { pop nullstring } if
    } def

    /ReceiveContentsAscii { % string => -
	/ContentsAsciiString exch store
    } def

    /puts { % string => -
	print
    } def

    /inselection? { %  event rank  =>  bool
	{
	    EVENT_INSELECTION tagprint
	    synchid typedprint
	    /RankToRankno self send typedprint
	    /EventToXY self send typedprint typedprint
	    flush
	    breakpoint
	    EventInSelection?
	} out_file /with-output-to-file self send
	not { pop pop false } if
    } def

    /SetInSelection {   % int -> -
	0 ne /EventInSelection? exch def
    } def

    %
    % DISPLAY HANDLING
    %
    /TextPath {    % w h x y => -  (create path around chars)
	maxy add
	translate                   % w
	0 0 moveto                  % w
	0 exch rlineto      % w
	dup 0 rlineto
	0 lineto
	closepath
    } def

    /CursorChars {          % c x y fg bg => - (paint chars with given colors)
	gsave
	    4 2 roll                % c fg bg x y
	    4 index length 1        % c fg bg x y w h
	    4 2 roll                % c fg bg w h x y
	    TextPath                % c fg bg
	    setcolor fill           % c fg
	    0 maxy neg moveto
	    setcolor show           % -
	grestore
    } def

    /CursorDown {     % str x y => -
	TextColor FillColor CursorChars
    } def

    /CursorUp {    % str x y => -
	FillColor TextColor CursorChars
    } def

    /LineChars {            % w x y color => - (draw colored line under chars)
	gsave
	    4 1 roll            % color w x y
	    2 index 1           % color w x y w h
	    4 2 roll            % color w w h x y
	    TextPath            % color w
	    clip newpath
	    1 maxy sub 2 div    % color w y
	    dup 0 exch moveto   % color w y
	    lineto              % color
	    setcolor stroke     % -
	grestore
    } def

    /UnderLine { % w x y => -
	TextColor LineChars
    } def

    /WhiteLine {  % w x y => -
	FillColor LineChars
    } def

    /EraseRectangle {    % w h x y => -
	gsave
	    TextPath                        % -
	    FillColor setcolor
	    fill
	    TextColor setcolor
	grestore
    } def

    /CopyLine {   % yby w nl yfrom => -
	gsave
	    0 exch                          % yby w nl 0 yfrom
	    TextPath                        % yby
	    0 exch copyarea
	grestore
    } def

    /VisibleBell  {    % - => -
	gsave
	    5 setrasteropcode
	    clippath fill
	    FlashDelay sleep
	    clippath fill
	grestore
    } def

    /AudibleBell  {    % - => -
	BeepAction dup /Both eq exch /Flash eq or {
	    /VisibleBell self send
	} if
	BeepAction dup /Both eq exch /Beep eq or {
	    beep
	} if
    } def

    /AutoMargins {    % onoff => -; define auto margins
	0 ne {(Auto-Margins Off)}{(Auto-Margins On)} ifelse
	MENU_MARGINS exch null {EVENT_TOGGLEAM tagprint}
	    /change CanvasMenu send
    } def

    /PageMode {    % onoff => -; define page mode
	0 ne {(Page Mode Off)}{(Page Mode On)} ifelse
	MENU_PAGEMODE exch null {EVENT_TOGGLEPM tagprint}
	    /change CanvasMenu send
    } def

    %   We have some nasty code here that tries to save the
    %   canvas' original matrix.  The default canvas matrix will
    %   be altered by resetscale and we need to restore it before
    %   we can recalculate thr new scale factors.
    %
    /reshape { % x y w h => -
	OrigMatrix null ne {
	    gsave
		Canvas setcanvas
		OrigMatrix setmatrix
		clippath Canvas reshapecanvas
	    grestore
	} if
	/reshape super send
	gsave
	    Canvas setcanvas
	    /OrigMatrix matrix currentmatrix promote
	grestore
	/invalidate self send
    } def

    /resetscale {   % - => -
	gsave
	    Canvas setcanvas
	    OrigMatrix null ne {
		OrigMatrix setmatrix
	    } if
	    clippath pathbbox
	    0 1 index translate 1 -1 scale
	    Lines .3 add div floor 1 max exch Cols div floor 1 max exch
		scale pop pop
	    0 1 translate

	    % See if can avoid all the font rescaling interations
	    /font_scale_fac -1 def
	    { % Loop looking for a font that fits the screen without overlap
		    TextFamily findfont dup setfont
		    [ ( ) stringwidth pop 1 exch dup 0 eq { pop } { div } ifelse
		    0 0 font_scale_fac 0 0]
		    makefont dup setfont
		    % See if the font is going to fit
		    fontheight 1 le { exit } if
		    font_scale_fac -.1 ge { exit } if
		    /font_scale_fac font_scale_fac .1 add def
	    } loop
	    /TextFont currentfont promote
	    /maxy
		currentfont fontascent
		0 exch dtransform .05 add floor idtransform exch pop
	    neg store
	    clear
	    newpath
	    clippath Canvas reshapecanvas
	grestore
    } def

    /validate {
	/resetscale self send
	EVENT_RESIZE tagprint flush
	/validate super send
    } def

    /CanvasMenu [
	(Stuff) null {
	    /PrimarySelection getselection dup null ne {
		MyCanvas /sendtocanvas 3 -1 roll send
	    } {
	    	pop
	    } ifelse
	}
	(Page Mode On)       null {EVENT_TOGGLEPM tagprint}
	(Auto-Margins On)    null {EVENT_TOGGLEAM tagprint}
    ] framebuffer /newdefault ClassMenu send def

    /BeginRepair {
	gsave
	    Canvas setcanvas
	    damagepath clipcanvas
	    % initialize client canvas with background color
	    FillColor fillcanvas
	    clippath pathbbox
	    EVENT_EXTENTS tagprint
	    ceiling typedprint
	    ceiling typedprint
	    floor typedprint
	    floor typedprint
	    flush
	grestore
    } def

    /EndRepair {
	newpath clipcanvas
    } def

    /HandleFix { % event => -
	pop
	/?validate self send
	EVENT_REPAIR tagprint
    } def

    /paint { % - => -
	/?validate self send
	EVENT_REPAIR tagprint
    } def
classend def

/ClassPsTermFrame /defaultclass ClassBaseFrame send [/ps_process]
classbegin
    /newinit {  % parentcanvas => instance
	/newinit super send
	/ps_process currentprocess def
    } def

    /destroy { % - => -
	framebuffer setcanvas
	/destroy super send
	pause pause pause
	%   Make sure we are in our own process group before killing
	%   the client connection.
	newprocessgroup
	ps_process killprocess
    } def
classend def
