%
% This file is a product of Sun Microsystems, Inc. and is provided for
% unrestricted use provided that this legend is included on all tape
% media and as a part of the software program in whole or part.  Users
% may copy or modify this file without charge, but are not authorized to
% license or distribute it to anyone else except as part of a product
% or program developed by the user.
%
% THIS FILE IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
% WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
% PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
%
% This file is provided with no support and without any obligation on the
% part of Sun Microsystems, Inc. to assist in its use, correction,
% modification or enhancement.
%
% SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
% INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY THIS FILE
% OR ANY PART THEREOF.
%
% In no event will Sun Microsystems, Inc. be liable for any lost revenue
% or profits or other special, indirect and consequential damages, even
% if Sun has been advised of the possibility of such damages.
%
% Sun Microsystems, Inc.
% 2550 Garcia Avenue
% Mountain View, California  94043
%
%
% "@(#)tcap.cps 23.2 90/06/19 SMI
%
% Copyright (c) 1985 by Sun Microsystems, Inc.
%/

C: #include "tags.h"
#include "tags.h"

cdef Initialize(string progname, int x, y, Wwidth, Wheight, cols, lines, fixedsize, string framelabel, string iconlabel, int fontsize)
    true setpacking
    true setshared
    /ClassPsTermFrame (NeWS/pstermutil.ps) systemdict
	CheckLoad not {quit} if
    false setshared

    %   We have to define a nested server here to catch the error when
    %   the server connection goes away.
    /AbortProc {
        % If we still have MyWindow around, destroy it.
	/MyWindow where {
	    pop
	    /destroy MyWindow send
	} if
    } def
    /NestedServer {currentfile cvx exec AbortProc} def
    NestedServer

    /MyWindow [ClassPsTermCanvas] [/Footer false] framebuffer /new ClassPsTermFrame send def
    /cc /client MyWindow send def

    % remember argv[0] for the /commandstring method.
    progname /setprogramname cc send

    % If fontsize was specified, alter the text params now.
    fontsize -1 ne {
	/textparams cc send		% family pointsize encoding
	exch pop fontsize exch		% family newpointsize encoding
	/settextparams cc send
    } if

    cols lines /setdimensions /Client /sendclient MyWindow send

    framelabel /setlabel MyWindow send
    /terminal /seticon MyWindow send
    iconlabel /seticonlabel MyWindow send

    % if specified width/height, make it the preferred width/height
    /preferredsize MyWindow send	    % w h
    Wwidth -1 ne {
	exch pop Wwidth exch		    % neww h
    } if
    Wheight -1 ne {
	pop Wheight			    % neww newh
    } if
    [ 3 1 roll ] cvx /preferredsize exch /promote MyWindow send
	
    fixedsize 0 eq {
	/reshapefromuser MyWindow send
    } {
        x y mul 0 ne {
            x y /preferredsize MyWindow send /reshape MyWindow send
        } {
            /place MyWindow send
	} ifelse
    } ifelse

    /MyCanvas /client MyWindow send soften def
    
    MyCanvas setcanvas

    /CU         { /CursorUp MyCanvas send       } def
    /CD         { /CursorDown MyCanvas send     } def
    /BRP        { /BeginRepair MyCanvas send    } def
    /ERP        { /EndRepair MyCanvas send      } def
    /UL         { /UnderLine MyCanvas send      } def
    /WL         { /WhiteLine MyCanvas send      } def
    /ER         { /EraseRectangle MyCanvas send } def
    /CL         { /CopyLine MyCanvas send       } def
    /VB         { /VisibleBell MyCanvas send    } def
    /AB         { /AudibleBell MyCanvas send    } def
    /AM         { /AutoMargins MyCanvas send    } def
    /PM         { /PageMode MyCanvas send       } def
    /RS		{ /ReceiveContentsAscii MyCanvas send } def
    /IS		{ /SetInSelection MyCanvas send } def
    /resetscale { MyCanvas setcanvas
                  /textfont currentcanvas send setfont
                  /TextColor currentcanvas send setcolor
                } def

    % Invalidate the selection of the specified rank.  This is possibly
    % called when there is no selection of that rank (in the case of a
    % secondary selection ... the selection is gone by the time the client
    % side gets around to invalidating it), or the selection has been
    % transfered to someone else, which doesn't know how to invalidate
    % itself.  So this only does something if the selection exists and
    % it understands the /invalidate message.  REMIND: This seems a little
    % hokey.
    /IVS { % rank => -
	/RanknoToRank ClassPsTermCanvas send
	getselection dup null ne {
	    dup /invalidate /understands? 3 -1 roll send {
		/invalidate exch send
	    } {
		pop
	    } ifelse
	} {
	    pop
	} ifelse
    } def

    /putchar {			% event => --
	/Name get ( ) dup 0 3 index put
	exch 128 ge {
	    EVENT_TYPEDCHAR tagprint
	    typedprint
	} {
	    print
	} ifelse
	flush
    } def

    /logit {	%  --; event begun => --
	console
	(name: %; action: %; x, y: (%, %); canvas: %\n)
	[ Name Action XLocation YLocation Canvas ]
	fprintf
    } def

    /IL {    % str => -; set icon label
        /seticonlabel MyWindow send
    } def

    /SL {  % str => -; set frame label
        /setlabel MyWindow send
    } def
    /PC { % str x y => -
	newpath moveto show
    } def
    /DD { % - => -
	EVENT_DONEDISPLAY tagprint flush
    } def

cdef StartInput()
	/activate MyWindow send
	/map MyWindow send

cdef ReInitialize() resetscale
cdef CursorUp(x,y,cstring c) c x y CU
cdef CursorDown(x,y,cstring c) c x y CD
cdef PaintChars(x,y,cstring str) str x y PC
cdef UnderLine(x,y,w)	w x y UL
cdef WhiteLine(x,y,w)	w x y WL
cdef EraseRectangle(x,y,w,h)	w h x y ER
cdef CopyLines(yfrom, yby, w, nl) yby w nl yfrom CL
cdef BeginRepair(sr, sc, er, ec) BRP => EVENT_EXTENTS (er, ec, sr, sc)
cdef EndRepair() ERP
cdef SetFrameLabel(string str) str SL
cdef SetIconLabel(string str) str IL
cdef SendSelection(cstring str)	str RS
cdef RingBell() AB
cdef VisibleBell() VB
cdef SetPageMode(onoff) onoff PM
cdef SetAutoMargins(onoff) onoff AM
cdef SetInSelection(is_in) is_in IS
cdef ContinueProcess(synch_id) synch_id synchdone
cdef DoneDisplaying() DD

cdef ps_event_setsel(r, c, rank, lvl, preview) => EVENT_SETSEL (rank, lvl, preview, c, r)
cdef ps_event_extsel(r, c, rank, lvl, preview) => EVENT_EXTENDSEL (rank, lvl, preview, c, r)
cdef ps_event_desel(rank)		=> EVENT_DESELECT (rank)
cdef ps_event_selrequest(rank, synch)	=> EVENT_SELREQUEST (synch, rank)
cdef ps_event_insel(r, c, rank, synch)	=> EVENT_INSELECTION (synch, rank, r, c)
cdef ps_event_char(cstring s)		=> EVENT_TYPEDCHAR (s)

cdef ps_invalidate_selection(rank)
    rank IVS

cdef ps_setconsole(int console)
    console 0 ne /setconsole /Client /sendclient MyWindow send

cdef ps_settermtype(string name)
    name cvn /settermtype /Client /sendclient MyWindow send
