/*
 * This file is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify this file without charge, but are not authorized to
 * license or distribute it to anyone else except as part of a product
 * or program developed by the user.
 *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * This file is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY THIS FILE
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even
 * if Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

#ifndef lint
static char sccsid[] = "@(#)technichron.c 23.2 90/06/19";
#endif

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */

#ifndef SYSV
#include	<sys/time.h>
#else
#include	<ref/config.h>
#include	<time.h>
#endif

#include	<sys/types.h>
#include	"technichron.h"

#define DEFAULT_DELAY 240

struct timeval tv;
struct timezone tz;
struct tm  *t, *lt;
struct timeval delay = {
    DEFAULT_DELAY,		/* tv_sec */
    0				/* tv_usec */
};


main(argc, argv)
    int         argc;
    char      **argv;
{
    int         width = getdtablesize();
    fd_set      fds,
                rfds;
    int         exists;

    extern char *optarg;
    extern int  optind,
                opterr;
    int         optchar;
    int         errflag = 0;

    while ((optchar = getopt(argc, argv, "d:")) != EOF) {
	switch (optchar) {
	case 'd':
	    if ((delay.tv_sec = atoi(optarg)) <= 0)
		++errflag;
	    break;
	default:
	    ++errflag;
	}
    }

    if (optind != argc)
	++errflag;

    if (errflag) {
	fprintf(stderr, "usage: %s [-d delay]\n", argv[0]);
	exit(1);
    }

    ps_open_PostScript();
    ps_technichron_exists(&exists);
    if (!exists)
	ps_initialize();
    ps_startup();
    ps_flush_PostScript();

    FD_ZERO(&fds);
    FD_SET(psio_fileno(PostScript), &fds);
    while (1) {
	gettimeofday(&tv, &tz);
	t = gmtime(&tv.tv_sec);
	ps_setgmt(t->tm_yday, t->tm_hour, t->tm_min);
	lt = localtime(&tv.tv_sec);
	ps_setlocaltime(lt->tm_yday, lt->tm_hour, lt->tm_min, lt->tm_wday,
			lt->tm_mon, lt->tm_mday, lt->tm_year, lt->tm_zone);
	ps_flush_PostScript();
	rfds = fds;
	if (select(width, &rfds, (fd_set *) NULL, (fd_set *) NULL, &delay)
		== -1 || FD_ISSET(psio_fileno(PostScript), &rfds))
	    break;
    };
    exit(0);
}
