%
% This file is a product of Sun Microsystems, Inc. and is provided for
% unrestricted use provided that this legend is included on all tape
% media and as a part of the software program in whole or part.	 Users
% may copy or modify this file without charge, but are not authorized to
% license or distribute it to anyone else except as part of a product
% or program developed by the user.
% 
% THIS FILE IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
% WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
% PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
% 
% This file is provided with no support and without any obligation on the
% part of Sun Microsystems, Inc. to assist in its use, correction,
% modification or enhancement.
% 
% SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
% INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY THIS FILE
% OR ANY PART THEREOF.
% 
% In no event will Sun Microsystems, Inc. be liable for any lost revenue
% or profits or other special, indirect and consequential damages, even
% if Sun has been advised of the possibility of such damages.
% 
% Sun Microsystems, Inc.
% 2550 Garcia Avenue
% Mountain View, California  94043
%
%
% @(#)technichron.cps 23.4 90/06/19
%
% Copyright (c) 1989 by Sun Microsystems, Inc.
%

cdef ps_setgmt(int day, int hour, int minute)
    day hour minute /updatetime client send

cdef ps_setlocaltime(int day, int hour, int minute, int wday,
		     int month, int day, int year, string timezone)

    (%, % %, 19%) [Weekdays wday get Months month get day year] sprintf
    (%:%%m %) [
	hour 12 gt { 
	    hour 12 sub
	} { 
	    hour 0 eq { 12 } { hour } ifelse
	} ifelse
	minute 10 lt { (0) } { () } ifelse
	minute 2 string cvs append
	hour 12 gt { (p) } { (a) } ifelse
	timezone
    ] sprintf
    /setfooter win send

cdef ps_startup()
    currentprocess /ProcessName (Technichron) put
    /win TechnichronCanvas [] framebuffer /new TechnichronFrame send def

    (technichron) /setlabel win send

    % salt away the client for use later
    /client /client win send def

    /Weekdays [ (Sunday) (Monday) (Tuesday) (Wednesday)
		(Thurday) (Friday) (Saturday) ] def

    /Months [ (January) (February) (March) (April) (May) (June) (July)
	      (August) (September) (October) (November) (December) ] def

    /place win send
    /activate win send
    /map win send

#define EXISTS_TAG 1
cdef ps_technichron_exists(exists) => EXISTS_TAG(exists)
    EXISTS_TAG tagprint
    systemdict /TechnichronCanvas known { 1 } { 0 } ifelse typedprint


cdef ps_initialize()

systemdict begin

    /TechnichronFrame /defaultclass ClassBaseFrame send []
    classbegin
	/IconFrameClass { TechnichronIcon } def

	/open { % bool => -
	    % only flip the parent of the client if the open state
	    % is really changing.
	    dup /opened? self send ne {
		dup dup {
		    null /setclient /Icon /sendsubframe self send
		    dup /setclient self send pop
		    /validate self send
		} {
		    null /setclient self send
		    dup /setclient /Icon /sendsubframe self send pop
		    /validate /Icon /sendsubframe self send
		} ifelse		    % open? open? client
		/open exch send
	    } if
	    /open super send
	} def
    classend def

    /TechnichronIcon /defaultclass ClassIconFrame send []
    classbegin
	% We do not want icons to have labels by default.
	%
	/Label false def

	% make the icon a 2:1 ratio
	/minsize { % - => minwidth minheight
	    128 64
	} def
    classend def


    /TechnichronCanvas ClassCanvas
    dictbegin
	/Declination -23 def
	/Longitude 0 def
	/Terminator 0 def
	/SunWRTIdl 90 def		% 0 - 360 International DateLine
	/ConnectionFile null def
	/WarpProcess null def
	/mm 0 def
	/hh 0 def
	/yd 0 def
	/realmm 0 def
	/realhh 0 def
	/realyd 0 def
	/dminute 0 def
	/dhour 0 def
	/dday 1 def
	/DayColor 1 1 1 rgbcolor def
	/NightColor 0 0 0 rgbcolor def
	/invertpixel null def
    dictend
    classbegin

    /minsize { % - => w h
	/minsize super send
	64 max exch
	128 max exch
    } def

    /open { % bool => -
    	not {
	    /deactivate self send
	} if
    } def

    /preferredsize { % - => w h
	/preferredsize super send
	256 max exch
	512 max exch
    } def

    /newinit { % - => -
	/newinit super send
	/ConnectionFile currentfile store
    } def

    /destroy { % - => -
	/destroy super send
	ConnectionFile closefile
	/killwarp self send
    } def

    /killwarp { 
	WarpProcess null ne { 
	    WarpProcess killprocess
	    /WarpProcess null store
	} if
    } def

    /setmode { % 0..3 => -
	/killwarp self send
	/dminute 0 store
	/dhour 0 store
	/dday 0 store
	{
	    0 {
		/mm realmm store
		/hh realhh store
		/yd realyd store
		/updateDayNight self send
		exit
	    }
	    1 {	/dminute }
	    2 {	/dhour }
	    3 {	/dday }
	} case
	1 store
	/WarpProcess {
	    {
		/mm mm dminute add store
		mm 59 gt {
		    /mm mm 60 sub store
		    /hh hh 1 add store
		} if
		/hh hh dhour add store
		hh 23 gt {
		    /hh hh 24 sub store
		    /yd yd 1 add store
		} if
		/yd yd dday add store
		yd 364 gt {
		    /yd yd 365 sub store
		} if
		/updateDayNight self send
		pause
	    } loop
	} fork store
	WarpProcess /ProcessName (Time Warp) put
    } def

    /CanvasMenu [
	(Current Time) (Minute Warp) (Hour Warp) (Day Warp)
    ] null {
	/value 1 index send
	/setmode /sendtarget 4 -1 roll send
    } framebuffer /newdefault ClassMenu send def
    (technichron) /setlabel CanvasMenu send

    % solar declination from
    % Practical Astronomy with your calculator
    % second edition, Peter Duffett-Smith
    % Cambridge University Press pp-82

    /PlotDaylightTerminator {
	Declination 0 eq {
	    SunWRTIdl 90 sub -90 180 dup rectpath
	    SunWRTIdl 270 add -90 180 dup rectpath
	} {
	    Declination 0 gt {
		360 90 moveto 0 90 lineto
	    } {
		360 -90 moveto 0 -90 lineto
	    } ifelse
	    0 3 360 {
		dup SunWRTIdl sub cos neg Declination tan div
 		dup 0 gt {
		    arctan
		} {
		    dup 0 ne { arctan 360 sub } if
		} ifelse
		lineto
	    } for
	    closepath
	} ifelse
    } def

    /settime { % - => -
	/SunWRTIdl mm 60 div hh add 24 div 360 mul neg 360 add store
	/Declination yd 365.25 div 360 mul cos neg 24 mul store
    } def

    /updateDayNight {
	gsave
	    /canvas self send setcanvas
	    /invertpixel NightColor setcolor currentpixel
		DayColor setcolor currentpixel xor store
	    clippath emptypath not {
		1 1 translate
		pathbbox points2rect
		2 sub 180 div exch 2 sub 360 div exch scale pop pop
		0 90 translate
		PlotDaylightTerminator
		/settime self send
		PlotDaylightTerminator
		6 setrasteropcode invertpixel setpixel
		eofill
	    } if
	grestore
    } def

    /updatetime { % yd hh mm => - (0..365 0..23 0..59)
	/realmm exch store
	/realhh exch store
	/realyd exch store
	WarpProcess null eq {
	    /mm realmm store
	    /hh realhh store
	    /yd realyd store
	    /updateDayNight self send
	} if
    } def

    /PaintCanvas {
	/canvas self send setcanvas
	initclip
	gsave
	    NightColor setcolor clippath fill
	    DayColor setcolor
	    /worldmap self send
	grestore
	clippath emptypath not {
	    1 1 translate
	    pathbbox points2rect
	    2 sub 180 div exch 2 sub 360 div exch scale pop pop
	    0 90 translate
	    PlotDaylightTerminator
	    6 setrasteropcode invertpixel setpixel
	    fill
	} if
    } def

    /worldmap nullproc def

classend def

% worldmap breaks methodcompile, so stuff it in by hand.
TechnichronCanvas /worldmap {
#include "worldmap.ps"
} put
end % systemdict
