/*
 * @(#)defs.h 23.2 90/06/19 SMI
 */

/*
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 */

/*
 * General definitions used at all levels of the system.
 */

#ifndef	_defs_h
#define _defs_h

#include <NeWS/psio.h>


/*
 * The vendor string identifies the vendor responsible for the
 * server executable.
 */
#define VENDOR_STRING "X11/NeWS - Sun Microsystems Inc."

/* 
 * A small utility macro to aid in tricking the C preprocessor:
 * EXPAND(fu)bar becomes fubar 
 */
#define EXPAND(c) c
#define CPPCONCAT(a,b) EXPAND(a)b

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#define BACKSLASH '\\'

/*
 * Definition of assert macro for DEBUG and !DEBUG
 */
#ifndef assert
#ifdef DEBUG
#define assert(x) 					\
	(!(x) ? fprintf(stderr,				\
	"Assertion failed \"x\" [file %s, line %d]\n",  \
	__FILE__, __LINE__),fflush(stderr),abort() : 0)
#else	/* DEBUG */
#define assert(x)
#endif  /* DEBUG */
#endif  /* assert */

/*
 * Unix system call error number.
 */
extern int errno;		

/*
 * True iff PostScript should print out various tidbits about what
 * is currently going on in the system.  Used for debugging.
 */
extern int verbose;	

/*
 * 1 + highest interesting fd
 */
extern int maximum_fd;

/*
 * Incremented by vfract primitives whenever an operation overflows
 * a fract value.
 */
extern short fract_overflows;

#endif	/* #ifndef _defs_h */
