/*
 * @(#) environ.h 23.2 90/06/19
 */

/*
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 */

/*
 * environ.h
 */

#define DEFAULT_KEYBOARD_CLICK  frpercent(0)		/* percent of max */
#define DEFAULT_BELL            frpercent(50)		/* percent of max */
#define DEFAULT_BELL_PITCH      fracti(400)		/* Hz */
#define DEFAULT_BELL_DURATION   fraction(1, 600)	/* 100 ms */
#define DEFAULT_AUTOREPEAT      1			/* true */
/* do we need this? */
#define DEFAULT_AUTOREPEATS     {\
	0, 0, 0, 0, 0, 0, 0, 0,\
	0, 0, 0, 0, 0, 0, 0, 0,\
	0, 0, 0, 0, 0, 0, 0, 0,\
	0, 0, 0, 0, 0, 0, 0, 0 }
#define DEFAULT_LEDS            0x0        		/* all off */
#define DEFAULT_KEY_REPEAT_THRESH fraction(1, 120)	/* 1/2 second */
#define DEFAULT_KEY_REPEAT_TIME	fraction(1,1200)	/* 1/20 second */

struct kbd_environment {
	int	click, bell, bell_pitch, bell_duration;
	long	leds;
	/*
	 * NeWS does autorepeat in PostScript.
	 */
	int	autoRepeat;
	int	key_repeat_thresh;
	int	key_repeat_time;
	unsigned char autoRepeats[32]; /* do we need this? */
};

#define DEFAULT_ACCELL_NUM	1
#define DEFAULT_ACCELL_DENUM	1
#define DEFAULT_THRESHOLD	2000
#define DEFAULT_COMPRESSION	1

struct ptr_environment {
	int	accellNum;
	int	accellDenum;
	int	threshold;
	int	do_compression;
};

enum dev_type {
	keyboard_type,
	pointer_type,
};

struct environment {
	char *devname;
	enum dev_type type;
	union {
		struct kbd_environment keybd;
		struct ptr_environment ptr;
	} env;
};



void	ringBell();
void	kbdCtrl();
extern struct environment *currentenvironment;
extern int collapsePtrMotion;

/*
 * Screen saver stuff - this stuff MUST match the #defines in the X11 .h files
 */
#define DontPreferBlanking      0
#define PreferBlanking          1
#define DefaultBlanking         2

#define DisableScreenSaver      0
#define DisableScreenInterval   0

#define DontAllowExposures      0
#define AllowExposures          1
#define DefaultExposures        2

/* for ForceScreenSaver */

#define ScreenSaverReset 0
#define ScreenSaverActive 1

#define DEFAULT_SCREEN_SAVER_TIME (10 * (60 * 1000))
#define DEFAULT_SCREEN_SAVER_INTERVAL (10 * (60 * 1000))
#define DEFAULT_SCREEN_SAVER_BLANKING 1		/* PreferBlanking */
#define DEFAULT_SCREEN_SAVER_EXPOSURES 1	/* AllowExposures */

#define SCREEN_SAVER_ON   0
#define SCREEN_SAVER_OFF  1
#define SCREEN_SAVER_FORCER 2

