/* @(#)input.h 23.3 90/06/19 SMI */

/*
 * Copyright (c) 1986 by Sun Microsystems, Inc. 
 */

#ifndef _input_h
#define _input_h

/*
 * Definitions having to do with input events 
 */

extern int		 distribution_count,
			 news_has_cursor,
			 raw_keyboard,
			 raw_mouse;


extern struct object	but1_keyword,
			but2_keyword,
			but3_keyword,
			but4_keyword,
			but5_keyword,
			damage_keyword,
			down_keyword,
			enter_keyword,
			exit_keyword,
			motion_keyword,
			raw_but1_keyword,
			raw_but2_keyword,
			raw_but3_keyword,
			raw_motion_keyword,
			up_keyword,
			redistribute_keyword;

extern REF		eventq;

extern REF		current_keystate;

enum event_action	{ neither, down, up };
extern enum event_action last_action;
extern struct object	 last_name;

extern struct timeval	 startup_time;

extern fract		 last_event_time,
			 last_event_x,
			 last_event_y;

extern struct object	createevent();

extern void		 determine_keystate(/* event */),
			 post_crossings(/* CANVAS from, to;
					   corpus *fr_name, *to_name; (kwds)
					   fract x, y, time */),
			 return_interests(/* ilist, ee */),
			 tangle_event(/* ee, event */),
			 untangle_event(/* event */),
			 enqueueEvent(/* event */),
			 dequeueEvent(/* event */),
			 enqueueDamageEvent(/* canvas */),
			 enqueueUnmapEvent(/* canvas, int from-configure */),
			 enqueueGravityEvent(/* canvas */),
			 enqueueColormapEvent(/* cv , cmap, new, state */),
			 enqueueVisibilityEvent(/* canvas, enum visibility */);

#define is_local_root(cv)   (is_ref_zero(cs_parent(cv)))
extern RCANVAS GlobalRoot;
#define global_root() GlobalRoot->opaqueparent
#define GlobalInterestList  \
	(((XNCANVAS) entity_addr(global_root()))->preInterest)

struct queue_lock {
    int		count;
    fract       timer;
};

extern struct queue_lock    input_queue_lock;

#define DEFAULT_INPUT_QUEUE_TIMEOUT	((fract)546)	/* .5 sec */

#define DEVIDKBD	0x6F00
#define DEVIDMS		0x6E00
#define DEVIDMSLBUT	DEVIDMS+1
#define DEVIDMSMBUT	DEVIDMS+2
#define DEVIDMSRBUT	DEVIDMS+3
#define DEVIDSERA	0x6D00
#define DEVIDSERB	0x6C00


#define createevent(objp) \
    {\
    REF ce_tmp;\
    ce_tmp = pnew(NO_POOL, event_type, 0);\
    set_object_from_ref((objp), ce_tmp);\
    }



REF	CanvasUnderMouse,	/* The canvas currently under the mouse */
	LastCanvasUnderMouse;	/* The canvas under the mouse the last time
				   it moved */

/*
 * interest list cons cell
 */
typedef struct _eventconscell {
    struct _eventconscell       *next;
    ENTITY			*interest;
    unsigned int                serial;
} EvConsCell;

#endif
