/*
 * @(#)X11.h 23.2 90/06/19
 */

/*-
 * 	X11.h:	Stubs for X11.
 *
 *	(C) Copyright 1987 Sun Microsystems, Inc.
 * 
 */

#ifndef _X11_H
#define	_X11_H

#include <NeWS/PostScript.h>
#define MAX_REQUEST_SIZE 16384

/*
 * limit of damage rectangles we'll send individually.  with more
 * than this we send the bbox of the damage area.
 *
 * this number should probably be tuned
 */
#define	MAX_RECTS_TO_SEND	20

#define Bool int	/* from Xlib.h (!) */

#define BUFSIZE 4096
#define MAXBUFSIZE (1<<17)

typedef struct _connectionBuf {
    unsigned char *buffer;     /* contains current client input */
    unsigned char *bufptr;     /* pointer to current start of data */
    int  bufcnt;               /* count of bytes in buffer */
    int lenLastReq;
    int size;
} ConnectionBuf;

/* One line funcs to macros, all from X11.c */

#ifdef DEBUG
#define InitNewClient(client) { \
				  client->requestLogIndex = 0; \
				  SendConnectionSetupInfo(client); \
				  }
#else
#define InitNewClient(client) { SendConnectionSetupInfo(client); }
#endif

#define GetHosts(data,pnHosts,pEnabled) 0

extern void SaveScreens();
#define ScreenSaverOff() SaveScreens(SCREEN_SAVER_FORCER, ScreenSaverReset)
#define ScreenSaverOn() SaveScreens(SCREEN_SAVER_FORCER, ScreenSaverActive)

#define ClientSwapped(client) ((client)->swapped)

#define ClientId(client) ((client)->index)

#define request_length(req,client) \
  ((client->swapped ? lswaps((req)->length) : (req)->length) << 2)

#endif	/* _X11_H */
