/*
 * @(#) cache.h 23.2 90/06/19
 */

/*
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 */

/*
 * cache.h:  this file contains all of the cached values that the X
 *	code uses.  Most notable is xcompat_private.
 */

#ifndef _cache_h
#define _cache_h

#include <NeWS/PostScript.h>

/*========================================================================
 * Please try to keep this list in a neat format.  The object is to
 * be able to find the object that you need with minimal difficulty,
 * and having a jumble of decl's will discourage people from looking...
 *
 * Also, be careful as to which init routine you put the look-up call into.
 * initialize_x_cache() gets called before any PostScript files get loaded
 * and is suitable for Keyword initialization, &c.   init_x_cache gets
 * called from the xinit PostScript operator and is executed after all
 * PostScript intialization but before the X interpreter loop starts.
 *========================================================================*/

#ifdef UNDEF_EXTERN
#define extern
#endif

/*
 * Dictionaries and arrays
 */
extern DICT		*Xcompat_private,
			*XResource,
			*XKeyNamesDict,
			*XSaveSets;

/* Names */
extern struct object	gfxdam_keyword,
			nogfxdam_keyword,
			doit_keyword,
			getselection_keyword,
			setselection_keyword,
			convertselection_keyword,
			getkeycontrol_keyword,
			querykeymap_keyword,
			getfontpath_keyword,
			getimage_keyword,
			grabexitnotify_keyword,
			grabenternotify_keyword,
			grabfocusoutnotify_keyword,
			grabfocusinnotify_keyword,
			listhosts_keyword,
			reply_keyword,
			newvalue_keyword,
			deleted_keyword;


/* Keywords */
extern struct object	xdict_key_object,
			xresource_key_object,
			evmaskname_object,
                	to_focusname_object,
                	messagename_object,
                	configure_x_object,
                	configure_y_object,
                	configure_width_object,
                	configure_height_object,
                	configure_border_object,
                	configure_detail_object,
                	configure_mask_object,
                	configure_window_object,
                	configure_sibling_object,
			canvas_object,
			rank_object,
			time_object,
			target_object,
			property_object,
			format8_object,
			format16_object,
			format32_object,
			substruct_redirect_object,
			resize_redirect_object,
			subdestroy_keyword,
			destroy_keyword;


/*
 * this macro ensures that if we ever want to redesign the cache interface
 * so that it is different/smarter/better-smelling/etc, we can.
 */
#define get_cache(name)		name
#define put_cache(name, value)	name = value

/*
 * define a private X operator
 */
#define define_X_operator(name, function, index, args, results) {	\
    struct object o;						        \
    static struct operator_def d =					\
                {index, name, args, results - args, function};		\
    o = add_kwd_name(d.pname);					        \
    d.bindname = (struct kwd_name *) entity_addr(o);			\
    define_operator_obj.value.def = &d;					\
    (void) define_object_in_dictionary(o,  define_operator_obj,		\
					Xcompat_private, (ENTITY *)0);	\
}


#endif /* _cache_h */
