/*
 * @(#)extnsionst.h 23.2 90/06/19
 */
/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/
/*
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 */


/*
 * extensionstruct.h - 
 */

#ifndef EXTENSIONSTRUCT_H
#define EXTENSIONSTRUCT_H 


#include "extension.h"

typedef struct _ExtensionEntry {
    int 	index;
    void (*CloseDown)();	/* called at server shutdown */
    char 	*name;          /* extension name */
    int 	base;           /* base request number */
    int 	eventBase;            
    int 	eventLast;
    int 	errorBase;
    int 	errorLast;
    pointer 	extPrivate;
} ExtensionEntry;

typedef void (*ExtensionLookupProc)();

typedef struct _ProcEntry {
    char 	*name;
    ExtensionLookupProc proc;
} ProcEntryRec, *ProcEntryPtr;

typedef struct _ScreenProcEntry {
    int num;
    ProcEntryPtr procList;
} ScreenProcEntry;


#define InsertGCI(pGC, pGCI, order, pPrevGCI) order(pGC,pGCI,pPrevGCI);

#define GCI_FIRST(pGC,pGCI,dummy) {				    \
    pGCI->pNextGCInterest = pGC->gcext->pNextGCInterest;\
    pGCI->pLastGCInterest = (GCInterestPtr)&pGC->gcext->pNextGCInterest; \
    pGC->gcext->pNextGCInterest->pLastGCInterest = pGCI; \
    pGC->gcext->pNextGCInterest=pGCI;		    \
}					    

#define GCI_MIDDLE(pGC,pGCI,pPrevGCI) {			    \
    pGCI->pNextGCInterest = pPrevGCI->pNextGCInterest;\
    pGCI->pLastGCInterest = (GCInterestPtr)&pPrevGCI->pNextGCInterest; \
    pPrevGCI->pNextGCInterest->pLastGCInterest = pGCI; \
    pPrevGCI->pNextGCInterest=pGCI;		    \
}

#define GCI_LAST(pGC,pGCI,dummy)\
    {					    \
    pGCI->pNextGCInterest = (GCInterestPtr)&pGC->gcext->pNextGCInterest;\
    pGCI->pLastGCInterest = pGC->gcext->pLastGCInterest;\
    pGC->gcext->pLastGCInterest->pNextGCInterest = pGCI;\
    pGC->gcext->pLastGCInterest=pGCI;		     \
    }

#define RemoveGCI(pGCI) \
	pGCI->pNextGCInterest->pLastGCInterest = pGCI->pLastGCInterest;\
	pGCI->pLastGCInterest->pNextGCInterest = pGCI->pNextGCInterest;\
	pGCI->pNextGCInterest = 0;\
	pGCI->pLastGCInterest = 0;


#define	SetGCMask(pGC, selectMask, newDataMask)			\
    pGC->stateChanges = (~selectMask & pGC->stateChanges) |	\
		        (selectMask & newDataMask);		\
    if (selectMask & newDataMask)				\
        pGC->serialNumber |= GC_CHANGE_SERIAL_BIT;


#define    SetGCVector(pGC, VectorElement, NewRoutineAddress, Atom)    \
    pGC->gcext->VectorElement = NewRoutineAddress;

/*
 * The idea is that GetGCValue(pGC,element) will get expanded into
 * a call to elementXGCelement.  That is, a call to GetGCValue(pGC,foo)
 * will turn into "fooXGC(pGC)".  Clever, huh?  In ANSI C, the null
 * comment part could be replaced by "##", but we don't have that
 * functionality on Suns yet.
 *
 * Putting the XGC first would look better, but then if there's a space in
 * the call to GetGCValue after the comma, it becomes part of GCElement and
 * so this all won't work.
 *
 * Sorry this is so disgusting.  JSS
 *
 * Note that these expect a GCPtr -- using a REF will crash & burn.
 */
#define GetGCValue(pGC,GCElement)	GCElement/**/XGC(pGC)

/*
 * Elements that still exist merely reference them directly.
 */
#define depthXGC(GC)		((GC)->depth)
#define arcModeXGC(GC)		((GC)->arcMode)
#define patOrgXGC(GC)		((GC)->patOrg)
#define subWindowModeXGC(GC)	((GC)->subWindowMode)
#define graphicsExposuresXGC(GC) ((GC)->graphicsExposures)
#define clipOrgXGC(GC)		((GC)->clipOrg)
#define clientClipTypeXGC(GC)	((GC)->clientClipType)
#define FillSpansXGC(GC)	((GC)->gcext->FillSpans)
#define SetSpansXGC(GC)		((GC)->gcext->SetSpans)
#define PutImageXGC(GC)		((GC)->gcext->PutImage)
#define CopyAreaXGC(GC)		((GC)->gcext->CopyArea)
#define CopyPlaneXGC(GC)	((GC)->gcext->CopyPlane)
#define PolyPointXGC(GC)	((GC)->gcext->PolyPoint)
#define PolylinesXGC(GC)	((GC)->gcext->Polylines)
#define PolySegmentXGC(GC)	((GC)->gcext->PolySegment)
#define PolyRectangleXGC(GC)	((GC)->gcext->PolyRectangle)
#define PolyArcXGC(GC)		((GC)->gcext->PolyArc)
#define FillPolygonXGC(GC)	((GC)->gcext->FillPolygon)
#define PolyFillRectXGC(GC)	((GC)->gcext->PolyFillRect)
#define PolyFillArcXGC(GC)	((GC)->gcext->PolyFillArc)
#define PolyText8XGC(GC)	((GC)->gcext->PolyText8)
#define PolyText16XGC(GC)	((GC)->gcext->PolyText16)
#define ImageText8XGC(GC)	((GC)->gcext->ImageText8)
#define ImageText16XGC(GC)	((GC)->gcext->ImageText16)
#define ImageGlyphBltXGC(GC)	((GC)->gcext->ImageGlyphBlt)
#define PolyGlyphBltXGC(GC)	((GC)->gcext->PolyGlyphBlt)
#define PushPixelsXGC(GC)	((GC)->gcext->PushPixels)
/*
 * These elements have direct cscript analogies.
 */
#define planemaskXGC(GC)	((unsigned long) csx_planemask(GC))
#define fgPixelXGC(GC)		((unsigned long) csx_fgpixel(GC))
#define bgPixelXGC(GC)		((unsigned long) csx_bgpixel(GC))
#define lineWidthXGC(GC)	csx_linewidth(GC)
#define dashOffsetXGC(GC)	csx_dashoffset(GC)
/*
 * These have cscript analogies, but they return different values.
 * The csx_ functions take the cscript value and return the appropriate
 * X11 value.
 */
#define aluXGC(GC)		csx_alu(GC)
#define lineStyleXGC(GC)	csx_linestyle(GC)
#define capStyleXGC(GC)		csx_capstyle(GC)
#define joinStyleXGC(GC)	csx_joinstyle(GC)
#define fillStyleXGC(GC)	csx_fillstyle(GC)
#define fillRuleXGC(GC)		csx_fillrule(GC)
unsigned char	*csx_dash();
#define dashXGC(GC)		csx_dash(GC)
/*
 * I haven't yet figured out how to deal with these.
 */
#define GetSpansXGC(GC)				/* Function */
#define GetImageXGC(GC)				/* Function */
#define QueryTextExtentsXGC(GC)			/* Function */

extern void InitExtensions();
extern ExtensionEntry *AddExtension();
extern ExtensionLookupProc LookupProc();
extern void RegisterProc();
extern void RegisterScreenProc();

extern int ProcQueryExtension();
extern int ProcListExtensions();
/*  List of extension procs go here */

#endif /* EXTENSIONSTRUCT_H */
