/*
 * @(#)grabs.h 23.2 90/06/19
 */

/*
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 */

/*
 * grabs.h - This is a replacement for the GrabRec in inputstr.h
 */

#ifndef GRABS_H
#define GRABS_H

#include <graphics/sh_fract.h>
#include "dix.h"

#define KBD_ID  0x6F
#define PTR_ID  0x00
#define NODEV	0xFF

#define MAX_BUTTONS 5

/*
 * Grab modes -
 *	GrabModeAsync (1) and GrabModeSync (0) defined in X.h
 */
#define FreezeNextEvent	2
#define FreezeBothNextEvent 3


typedef struct {
    unsigned char          devid;
    unsigned char          code;
} GrabKey;

typedef struct _GrabRec *GrabPtr;

typedef struct _GrabRec {
    GrabPtr         win_next;   /* for chain of passive grabs on a window */
    GrabPtr         all_next;	/* global chain of passive grabs */
    ClientPtr       client;
    REF             window;	/* references a canvas */
    GrabKey         key;        /* only for passive grabs */
    Bool            ownerEvents;
    unsigned char   keyboardMode, pointerMode;
    unsigned char   revert_keyboardMode, revert_pointerMode;
    int             modifiers:30;	/* only need 17 bits */
    unsigned        passive:1;
    unsigned        active:1;
    Mask            eventMask;  /* pointer events only */
    REF             confineTo;  /* pointer events only - references a canvas */
    REF             cursor;     /* pointer events only - references a cursor */
    struct object   grab_interest;
    struct object   freeze_interest;
    unsigned        serial;	/* event serial number - for replay */
} GrabRec;


typedef struct {
    int             grabbed;			/* device grabbed? */
    fract           time;			/* grab time */
    int             kbd_frozen, ptr_frozen;	/* device status */
    int             modstate;			/* modifier state during grab */
    unsigned char   buttons_down;	/* buttons during implicit grab */
    int             is_implicit;		/* implicit grab? */
    int		    is_passive;			/* passive grab? */
    GrabPtr         grab;			/* the grab info */
    REF		    replay_event;		/* last event through queue */
    ClientPtr       sync_client;		/* the client who synced us */
} ActiveGrab;

#endif /* GRABS_H */
