/*
 * @(#)os.h 23.2 90/06/19 
 */
/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef OS_H
#define OS_H

#include "misc.h"
#include <graphics/sh_main.h>	/* for ALLOCATE_LOCAL */

#if sun || (SYSV && i386)
#define X_server_pool		server_pool
#define X_tmp_pool		current_pool
#define X_client_pool		current_pool
#endif /* sun || (SYSV && i386) */

#define SCREEN_SAVER_ON   0
#define SCREEN_SAVER_OFF  1
#define SCREEN_SAVER_FORCER 2

#define MAX_REQUEST_SIZE 16384

typedef struct _FontPathRec *FontPathPtr;
typedef struct _NewClientRec *NewClientPtr;


/*
 * Motion buffers
 */
#define MOTIONBUFFERSIZE 100

extern char *ReadRequestFromClient();   /* should be xReq but then 
					   include Xproto.h */
extern WriteToClient();
extern void CreateWellKnownSockets();
extern FontPathPtr ExpandFontNamePattern();
extern void AbortServer();
extern void ErrorF();

extern char *strcat();
extern char *strncat();
extern char *strcpy();
extern char *strncpy();

#endif /* OS_H */
