/*
 * @(#)cs_cmap.h %23.4 90/06/19
 */

/* 
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 */

/*
 * cs_cmap.h
 */
#ifndef cmap_h
#define cmap_h 1

#include <Core/core.h>		/* uses REF's */

/* these follow X.h's AllocNone and AllocAll */
#define CM_PSCREEN 2
#define CM_PWIN	   3
/* Passed internally in colormap.c */
#define REDMAP 0
#define GREENMAP 1
#define BLUEMAP 2
#define PSEUDOMAP 3
#define AllocPrivate (-1)
#define DynamicClass  1


/* Values for the flags field of a colormap. These should have 1 bit set
 * and not overlap */
#define IsDefault 1
#define AllAllocated 2
#define BeingCreated 4

/* NOTE: dependent on X11 protocol file X.h */
#define ALLOCMASK	0x1
#define InitCmap	0x8

typedef unsigned long	Pixel;
typedef struct _CMEntry *CMAP_ENTRY;
typedef struct _ColormapRec *COLORMAP;

/* TEMP */
typedef struct _ColormapRec *ColormapPtr;

extern Pixel findcolor();
extern int TellNoMap();
extern int TellNewMap();
extern int IsMapInstalled();

#ifdef CMAPGRAB
extern unsigned long cs_cmapgrab_grab();
extern void cs_cmapgrab_release();
extern void cs_cmapgrab_force_release();
#endif CMAPGRAB

#define cs_alloc_color(cmap, r, g, b, pix)                              \
	cv_alloc_color((COLORMAP)entity_addr(cmap), r, g, b, pix)

#define cs_alloc_color_cells(cmap, colors, planes, contig, pix, masks)  \
	cv_alloc_color_cells((COLORMAP)entity_addr(cmap),               \
				colors, planes, contig, pix, masks)
#endif /* cmap_h */
