/* 
 * @(#)cs_cursor.h 23.2 90/06/19
 */

/*
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 */

/*
 * cs_cursor.h - cursor information
 */

#ifndef _cs_cursor_h
#define _cs_cursor_h

#include <graphics/shapes.h>
#include <Core/core.h>
#include "cs_common.h"
#include "cs_psfont.h"

struct cursordata {
    GLYPH glyph;
    int   hotspot_x, 
	  hotspot_y;
    REF   psfont;
    REF   font;
    unsigned short charindex;
};

struct cs_cursor {
    ENTITY_FIELDS
    struct cursordata image;
    struct cursordata mask;
    struct packedcolor foreground;
    struct packedcolor background;
    CURSER cursor;
};

typedef struct cs_cursor* CURSOR;

extern REF cs_createglyphcursor ();
#ifndef NEWS_ONLY
extern REF cs_createrastercursor ();
#endif

REF cs_createglyphcursor ();
void cs_movecursor ();
void cs_disablecursor ();
void cs_enablecursor ();
void cs_getcursorpos ();
void cs_setcanvascursor ();
void cs_recolorcursor ();
REF cs_getcanvascursor ();
void cs_grabcursor ();
void cs_releasecursor ();
void cs_getcursorinfo ();
void cs_getcursorcolors ();

extern void cursorisincanvas();
#define cs_cursorisincanvas(cv)						\
	cursorisincanvas((RCANVAS)(entity_addr(cv)))

#endif /* _cs_cursor_h */
