/*
 * @(#)cdefs.h 2.1 90/01/18
 *
 */
/*
 *************************************************************
 *                                                           *
 *   Copyright (c) 1989, 1987 by Sun Microsystems, Inc.      *
 *                                                           *
 *   This program is protected by Federal Copyright Law.     *
 *   No part of this program may be reproduced, stored in    *
 *   a retrieval system, translated, transcribed, or         *
 *   transmitted, in any form or by any means manual,        *
 *   electric, electronic, electro-magnetic, mechanical,     *
 *   optical, or otherwise, without prior explicit written   *
 *   permission from Sun Microsystems, Inc.                  *
 *                                                           *
 *************************************************************
 */
/*
 *
 */

/*  	The following definition (edu,5/6/88) is intended as a replacement
    	for 'void' which doesn't seem to work in situations such as:

    	void	(*f)();
    	void	g() { ... }

    	... if (f==g) ...   incompatible types
*/
#define	VOID	int

#define	int32	long
#define	int16	short
#define	int8	char
#define	bool	char
#define	uint32	unsigned long
#define	uint16	unsigned short
#define	uint8	unsigned char
#define byte	unsigned char

#define	Rint32	register long
#define	Rint16	register short
#define	Rint8	register char
#define	Rbool	register char
#define	Ruint32	register unsigned long
#define	Ruint16	register unsigned short
#define	Ruint8	register unsigned char
#define Rbyte	register unsigned char

#define	FLOAT	float

#define	TRUE	1
#define	true	1
#define	FALSE	0
#define	false	0
#define ON	1
#define OFF	0

#ifndef EOF
#define	EOF	-1
#endif	/*EOF*/

#ifndef NIL
#define	NIL	-1
#endif	/*NIL*/

#ifndef	NULL
#define	NULL	0
#endif	/*NULL*/

#ifndef M_PI
#define	M_PI	3.14159265358979323846
#endif

#define	DEGTORAD(d) 	(((FLOAT)(d)/180)*M_PI)
#define	RADTODEG(r) 	(((FLOAT)(r)*180)/M_PI)
#define abs(a)		(((a) >= 0) ? (a) : -(a))
#define	max(a, b)	(((a) >= (b)) ? (a) : (b))
#define	min(a, b)	(((a) >= (b)) ? (b) : (a))

#define	sq(n)		((n) * (n))

/*	The following round function should be used instead of the
 *	<rint> provided in the math library, which only works if your program
 *	is compiled with the -f68881 option.  And furthermore, there are
 *	inconsistencies in the result.		may 5/11/88
 */
#define round(v)        (((v) > 0) ? floor((v)+0.5) : ceil((v)-0.5))


