/*
 * @(#)f3io.h 2.3 90/04/18
 *
 */
/*
 *************************************************************
 *                                                           *
 *   Copyright (c) 1989, 1987 by Sun Microsystems, Inc.      *
 *                                                           *
 *   This program is protected by Federal Copyright Law.     *
 *   No part of this program may be reproduced, stored in    *
 *   a retrieval system, translated, transcribed, or         *
 *   transmitted, in any form or by any means manual,        *
 *   electric, electronic, electro-magnetic, mechanical,     *
 *   optical, or otherwise, without prior explicit written   *
 *   permission from Sun Microsystems, Inc.                  *
 *                                                           *
 *************************************************************
 */

extern	long	f3_EncryptState;
extern	void	f3_SetFontEncryption( /* bool */ );
extern	void	f3_Seed( /* int32 */ );

extern	int32	f3_FontReadBINTNE( /* FILE * */ );
extern	int32 	f3_FontReadWINTNE( /* FILE * */ );
extern	int32 	f3_FontReadLINTNE( /* FILE * */ );
extern	fract 	f3_FontReadSREALNE( /* FILE * */ );
extern	fract 	f3_FontReadFREALNE( /* FILE * */ );

extern	void 	f3_FontWriteBINTNE( /* FILE *, int32 */ );
extern	void 	f3_FontWriteWINTNE( /* FILE *, int32 */ );
extern	void 	f3_FontWriteLINTNE( /* FILE *, int32 */ );
extern	void 	f3_FontWriteSREALNE( /* FILE *, fract */ );
extern	void 	f3_FontWriteFREALNE( /* FILE *, fract */ );

extern	int32	f3_FontReadBINTE( /* FILE * */ );
extern	int32 	f3_FontReadWINTE( /* FILE * */ );
extern	int32 	f3_FontReadLINTE( /* FILE * */ );
extern	fract 	f3_FontReadSREALE( /* FILE * */ );
extern	fract 	f3_FontReadFREALE( /* FILE * */ );

extern	void 	f3_FontWriteBINTE( /* FILE *, int32 */ );
extern	void 	f3_FontWriteWINTE( /* FILE *, int32 */ );
extern	void 	f3_FontWriteLINTE( /* FILE *, int32 */ );
extern	void 	f3_FontWriteSREALE( /* FILE *, fract */ );
extern	void 	f3_FontWriteFREALE( /* FILE *, fract */ );

extern	int32	(*f3_FontReadBINTXX)( /* FILE * */ );
extern	int32 	(*f3_FontReadWINTXX)( /* FILE * */ );
extern	int32 	(*f3_FontReadLINTXX)( /* FILE * */ );
extern	fract 	(*f3_FontReadSREALXX)( /* FILE * */ );
extern	fract 	(*f3_FontReadFREALXX)( /* FILE * */ );

extern	void 	(*f3_FontWriteBINTXX)( /* FILE *, int32 */ );
extern	void 	(*f3_FontWriteWINTXX)( /* FILE *, int32 */ );
extern	void 	(*f3_FontWriteLINTXX)( /* FILE *, int32 */ );
extern	void 	(*f3_FontWriteSREALXX)( /* FILE *, fract */ );
extern	void 	(*f3_FontWriteFREALXX)( /* FILE *, fract */ );

#define	f3_FontReadBINT(fp)		(*f3_FontReadBINTXX)(fp)
#define	f3_FontReadWINT(fp) 		(*f3_FontReadWINTXX)(fp)
#define	f3_FontReadLINT(fp) 		(*f3_FontReadLINTXX)(fp)
#define	f3_FontReadSREAL(fp) 		(*f3_FontReadSREALXX)(fp)
#define	f3_FontReadFREAL(fp) 		(*f3_FontReadFREALXX)(fp)

#define	f3_FontWriteBINT(fp,v) 		(*f3_FontWriteBINTXX)(fp,v)
#define	f3_FontWriteWINT(fp,v)		(*f3_FontWriteWINTXX)(fp,v)
#define	f3_FontWriteLINT(fp,v)		(*f3_FontWriteLINTXX)(fp,v)
#define	f3_FontWriteSREAL(fp,v)		(*f3_FontWriteSREALXX)(fp,v)
#define	f3_FontWriteFREAL(fp,v)		(*f3_FontWriteFREALXX)(fp,v)

#define f3_MAGICNUMBER     0x137A2950
#define f3_EMAGICNUMBER    0x137A2951   /* magic number for encrypted file */

#include <sys/mman.h>

#if	(!_MAP_NEW || DEBUG || DOS || F3WRIO)
/*
 * In this case, we either do not have the ability to mmap files,
 * we are building a debug version, or we are building an app
 * that needs to both read and write f3 files.
 * In any case, we must use stdio.
 */
#define	FOPEN(n,m)	fopen(n,m)
#define	FSEEK(fp,d,t)	fseek(fp,d,t)
#define	FTELL(fd)	ftell(fd)
#define	getbyteNE(fp,b)	b = getc(fp);
#define	getbyteE(fp,b)	{ b = getc(fp); CRYPT(b) }
#define	FCLOSE(fp)	fclose(fp)
#else
/*
 * Use mmap on the f3 file.
 */
extern	FILE	*f3_mmapopen();

#define	FOPEN(n,m)	 f3_mmapopen(n,m)
/*
 * WARNING: This version of FSEEK only works with absolute offsets.
 */
#define	FSEEK(fp,d,t) \
	((((d) < fp->_cnt) && (fp->_ptr = fp->_base + (d))) ? 0 : 1)
#define	FTELL(fp)	(fp->_ptr - fp->_base)
#define	getbyteNE(fp,b)	b = *fp->_ptr++;
#define	getbyteE(fp,b)	{ b = *fp->_ptr++; CRYPT(b) }
#define	FCLOSE(fp)	{ fp->_flag = 0; munmap(fp->_base, fp->_cnt); }
#endif /*!_MAP_NEW || DEBUG || DOS || F3WRIO*/
