/*
 * @(#)sh_pr_impl.h 23.2 90/06/19 SMI
 */

/*
 * Copyright 1990, Sun Microsystems, Inc.
 */

/*
 * Implementation aid for Shapes code which uses pixrect include files.
 */

#ifndef	sh_pr_impl_h
#define	sh_pr_impl_h

#include <sys/types.h>

/* fake Shapes (for testing) */

#ifdef FAKE

#include "fake.h"

/* depth support */
#define	SUP1	1
#define	SUP8	1
#define	SUP16	defined(SUPALL)
#define	SUP32	defined(SUPALL)

#else FAKE

#ifdef REF
#include <ref/config.h>		/* XXX untested */
#endif
#include "shapes.h"
#include <di/shapes.h>
#include <di/fb_ctx.h>
#include <di/fb_render.h>
#include "mem/vec_typ.h"

#undef	FAST
#undef	error

#define	SUP1	1
#define	SUP8	(!defined(i386) && !defined(SH_NO_DEPTH8))
#define	SUP16	0
#define	SUP32	(!defined(SH_NO_DEPTH8) && !defined(SH_NO_DEPTH32))

#endif FAKE


#include <pixrect/pixrect.h>
#include <pixrect/pr_impl_util.h>
#include <pixrect/memvar.h>
#include <pixrect/mem_rop_impl_ops.h>
#include <pixrect/mem_rop_impl_util.h>

/* control macros */
#define	PIXRECT		0
#define	IFPIXRECT IFFALSE

/* depth support */
#define	SUPCOLOR	(SUP8 || SUP16 || SUP32)

#if SUP1
#define	IFSUP1	IFTRUE
#else
#define	IFSUP1	IFFALSE
#endif

#if SUP8
#define	IFSUP8	IFTRUE
#else
#define	IFSUP8	IFFALSE
#endif

#if SUP16
#define	IFSUP16	IFTRUE
#else
#define	IFSUP16	IFFALSE
#endif

#if SUP32
#define	IFSUP32	IFTRUE
#else
#define	IFSUP32	IFFALSE
#endif

#define	IFDEPTH1_1	IFTRUE
#define	IFDEPTH1_8	IFFALSE
#define	IFDEPTH1_16	IFFALSE
#define	IFDEPTH1_32	IFFALSE

#define	IFDEPTH1(depth)	_CAT(IFDEPTH1_,depth)

#define	PIX_T(depth)	_CAT(PIX,depth)
#define	TMP_T(depth)	_CAT(TMP,depth)


/* macros from the latest version of pr_impl_util.h */
#ifndef IFAND
/* and together multiple options */
#define	IFAND IFAND2
#define	IFAND2(opt1,opt2,a,b) opt1(opt2(a,b),b)
#define	IFAND3(opt1,opt2,opt3,a,b) opt1(opt2(opt3(a,b),b),b)
#define	IFAND4(opt1,opt2,opt3,opt4,a,b) opt1(opt2(opt3(opt4(a,b),b),b),b)
#define	IFAND5(opt1,opt2,opt3,opt4,opt5,a,b) \
		opt1(opt2(opt3(opt4(opt5(a,b),b),b),b),b)
#define	IFAND6(opt1,opt2,opt3,opt4,opt5,opt6,a,b) \
		opt1(opt2(opt3(opt4(opt5(opt6(a,b),b),b),b),b),b)
#endif IFAND

#ifndef ENDIAN
#ifndef LITTLE_ENDIAN
#define	LITTLE_ENDIAN	defined(i386)
#endif

#if LITTLE_ENDIAN
#define	ENDIAN	IFTRUE
#else
#define	ENDIAN	IFFALSE
#endif
#endif ENDIAN


/*
 * SPARC-tuned op macros (should be in mem_rop_impl_ops.h)
 */

/* masked rop */

#undef	OP_mmsk0
#undef	OP_mrop0
#define	OP_mmsk0(m)	(m)
#define	OP_mrop0(d,m,s)	((d) & ~(m))

#undef	OP_mmsk2
#undef	OP_mrop2
#define	OP_mmsk2(m)	(m)
#define	OP_mrop2(d,m,s)	((d) & ~((m) & (s)))

#undef	OP_mmsk8
#undef	OP_mrop8
#define	OP_mmsk8(m)	(m)
#define	OP_mrop8(d,m,s)	((d) & (~(m) | (s)))

/* unmasked fill */

#undef	OP_ufgen2
#undef	OP_ufill2
#define	OP_ufgen2(c)	(c)
#define	OP_ufill2(d,k)	((d) & ~(k))

#undef	OP_ufgen9
#undef	OP_ufill9
#define	OP_ufgen9(c)	(c)
#define	OP_ufill9(d,k)	((d) ^ ~(k))

#undef	OP_ufgenB
#undef	OP_ufillB
#define	OP_ufgenB(c)	(c)
#define	OP_ufillB(d,k)	((d) | ~(k))

/* masked fill */

#undef	OP_mfgen0
#undef	OP_mfmsk0
#undef	OP_mfill0
#define	OP_mfgen0(m,c)	(c)
#define	OP_mfmsk0(m)	(m)
#define	OP_mfill0(d,m,k) ((d) & ~(m))

#undef	OP_mfgen1
#undef	OP_mfmsk1
#undef	OP_mfill1
#define	OP_mfgen1(m,c)	(c)
#define	OP_mfmsk1(m)	(m)
#define	OP_mfill1(d,m,k) ((d) ^ ((m) & ((d) | ~(k))))

#undef	OP_mfgen2
#undef	OP_mfmsk2
#undef	OP_mfill2
#define	OP_mfgen2(m,c)	((m) & (c))
#define	OP_mfmsk2(m)	(m)
#define	OP_mfill2(d,m,k) ((d) & ~(k))

#undef	OP_mfgen3
#undef	OP_mfmsk3
#undef	OP_mfill3
#define	OP_mfgen3(m,c)	((m) & ~(c))
#define	OP_mfmsk3(m)	(m)
#define	OP_mfill3(d,m,k) (((d) & ~(m)) | (k))

#undef	OP_mfgenC
#undef	OP_mfmskC
#undef	OP_mfillC
#define	OP_mfgenC(m,c)	((m) & (c))
#define	OP_mfmskC(m)	(m)
#define	OP_mfillC(d,m,k) (((d) & ~(m)) | (k))


#endif	sh_pr_impl_h
