/****
 *
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 * @(#)sh_scr_dev.h 1.9 88/08/13 Copyright 1988 Sun Micro
 *
 * SCR_DEV.H - Screen Device codes
 * The user should modify this file to have different codes for all
 * supported devices. The open routine for the device should initialize
 * SCR_PHYS_DEV and SCR_VIRT_DEV in the SCREEN object to be one
 * of the following codes. The order is not important.
 * They need only be reasonably sequential (there can be "holes")
 * and smaller than 256.
 *
 * SCR_PHYS_DEV selects the UNIX physical device which is opened
 * (and closed). SCR_VIRT_DEV selects a class type that determines how
 * each Shapes class is implemented for that particular device.
 * Note that the UNIX device can be different than the implementation.
 * For example, the cg4 overlay planes open UNIX device CG4
 * (SCR_PHYS_DEV = SCR_DEV_CG4) but use the bw2 class type to access
 * the bit planes (SCR_VIRT_DEV = SCR_DEV_BW2).
 *
 ****/
#define	SCR_DEV_GENERIC	0	/* generic class implementations */
#define	SCR_DEV_MEM1	1	/* depth 1 memory framebuffer */
#define	SCR_DEV_MEM8	2	/* depth 8 memory framebuffer */
#define	SCR_DEV_MEM32	3	/* depth 32 memory framebuffer */

#define	SCR_DEV_CG2	4	/* Sun CG2 framebuffer (depth 8) */
#define	SCR_DEV_BW2	5	/* Sun BW2 framebuffer (depth 1) */
#define	SCR_DEV_CG4	6	/* Sun CG4 framebuffer (1 or 8) */
#define	SCR_DEV_CG6	7	/* Sun CG6 (Lego) */
#define	SCR_DEV_CG3	8	/* Sun CG3 (Color RoadRunner) */
#define	SCR_DEV_GPFB	9	/* GP1/GP+/GP2 framebuffer (depth 8) */
#define	SCR_DEV_GP	10	/* GP1/GP+/GP2 accelerator */
#define	SCR_DEV_CG5	11	/* Sun CG5 framebuffer (depth 8) */
#define SCR_DEV_CG8	12	/* Sun CG8 framebuffer (depth 8, 24 bit color)*/
#define SCR_DEV_LAST    12      /* last built-in device code */


#define	SCR_DEV_MAX	20	/* maximum physical device code */

#define	SCR_VIRT_MAX	40	/* maximum # of virtual devices */

