/****
 *
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 * @(#)shapes.h 23.2 90/06/19 Copyright 1988 Sun Micro
 *
 * SHAPES.H - Shapes header
 * This header is the main header for USER programs. It includes
 * definitions for all Shapes objects.
 * 
 * Compile time flags:
 *
 *  SH_DRAW_FUNC implements the drawing operators using
 *      the main operator function table in the CONTEXT.
 *      This is slower than the default which defines them
 *      as macros, but allows the drawing operators to be overridden.
 *
 *
 ****/
#ifndef	_SHAPES
#include "sh_main.h"
#include "sh_class.h"		/* CLASS handler */
#include "sh_SHAPE.h"		/* SHAPE class */
#include "sh_CTX.h"		/* CONTEXT class */
#include "sh_RAS.h"		/* RASTER class */
#include "sh_CURSOR.h"		/* CURSOR class */
#include "sh_PATH.h"		/* PATH class */
#include "sh_TRANS.h"		/* TRANSFORM class */
#include "sh_LIGHTS.h"		/* LIGHTS class */
#include "sh_CMAP.h"		/* CMAP class */
#include "sh_PAT.h"		/* PATTERN class */
#include "sh_glyph.h"		/* GLYPH objects */
#include "sh_draw.h"		/* Drawing macros */

#define	_SHAPES
#endif	/* _SHAPES */
