/*
 * @(#)memaccount.h 23.2 90/06/19 SMI
 */

/*
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 */

/*
 * memaccount.h
 *	Definitions for the interface to the memory accounting mechanism.
 */

#define MAXFAMILIES	10

typedef struct {
    char	*family_name;		/* description of family */
    unsigned	numtypes;		/* number of types in family */
    unsigned	*number;		/* number of type n */
    unsigned	*memory;		/* total bytes for type n */
    char	**type_name;		/* description of type n */
} Family;

extern Family	family_list[MAXFAMILIES];
extern unsigned	num_families;

#define MA_family(fam, ntypes, name)		{		\
	assert(num_families < MAXFAMILIES);			\
	fam = num_families++;					\
	family_list[fam].family_name = name;			\
	family_list[fam].numtypes    = (unsigned) ntypes;	\
	family_list[fam].number      =				\
	    (unsigned *) palloc((struct pool_desc *)NULL,	\
				(ntypes) * sizeof(int));	\
	family_list[fam].memory      =				\
	    (unsigned *) palloc((struct pool_desc *)NULL,	\
				(ntypes) * sizeof(int));	\
	family_list[fam].type_name   =				\
	    (char **) palloc((struct pool_desc *)NULL,		\
			     (ntypes) * sizeof(char *));	\
	memset((char *) family_list[fam].number,		\
	       0, (int)((ntypes) * sizeof(int)));		\
	memset((char *) family_list[fam].memory,		\
	       0, (int)((ntypes) * sizeof(int)));		\
	memset((char *) family_list[fam].type_name,		\
	       0, (int)((ntypes) * sizeof(char *)));		\
}

#define MA_create(fam, type, size)	{	\
	family_list[fam].number[(unsigned) type] += 1;		\
	family_list[fam].memory[(unsigned) type] += size;	\
}

#define MA_adjust(fam, type, size)		\
	family_list[fam].memory[(unsigned) type] += size;

#define MA_destroy(fam, type, size)	{	\
	family_list[fam].number[(unsigned) type] -= 1;		\
	family_list[fam].memory[(unsigned) type] -= size;	\
}

#define MA_describe(fam, type, name)		\
	family_list[fam].type_name[(unsigned) type] = name;
