/*
 * @(#)compile.h 23.2 90/06/19 SMI
 */

/*
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 */

/*
 * This header file deals with packed arrays, both packing and peephole
 * optimizations. Peephole optimization group certain object sequences 
 * into a single operation.
 */

/*
* The marker values and indices used in packed arrays. Marker values
* indicate something of interest follows. Index values are used directly
* in the unpacked_object table to obtain a corresponding object.
* THE ORDERING OF THE FOLLOWING LIST IS CRITICAL AS IT MUST CORRESPOND TO THE
* PACKED_INDEX VALUES ESTABLISHED IN OBJECTS.C: load_unpack().
*/
enum arraycompile_type {
        unpacked_object,	/* Full width struct object */

	/* Packed ints: -1 to +5 */
	packed_neg_one,		/* value must be 1! */
	packed_zero,
	packed_one,
	packed_two,
	packed_three,
	packed_four,
	packed_five,

	/* Packed and optimized operators */
	packed_lineto,
	packed_rlineto,
	packed_dup,
	packed_roll,
	packed_exch,
	packed_add,
	packed_eq,
	packed_pop,
	packed_known,

	/* Optimized operator array marker values */
#define FIRST_OPTIMIZED		(int) optimized_ifelse
	optimized_ifelse,	/* Operators compounded with args  */
	optimized_if,
	optimized_pop2,
	optimized_dup_type_k_eq,
	optimized_roll,
	optimized_index,
	optimized_k_eq,
	optimized_n_n_roll,

	/* Packed executable and non-executable names */
        packed_keyword,			/* Non-executable name */
        packed_executable_keyword,	/* Executable name */

	packed_terminator,
	packed_maximum
};


#define ispacked_integer(i) (i >= -1 && i <= 5)	  /* Packed int value range */

#define ptoi(n)		((n) - 2)	/* Packed int index to int value */
